import { Empty, Tag } from 'ant-design-vue';
import moment from 'moment';
import Editor from 'vue2-ace-editor';
import AMapLoader from '@amap/amap-jsapi-loader';
import Base64 from 'crypto-js/enc-base64';
import HmacSHA1 from 'crypto-js/hmac-sha1';
import Utf8 from 'crypto-js/enc-utf8';
import axios from 'axios';
import _ from 'lodash';
import { uid } from 'uid';
import Vue from 'vue';

function ownKeys(object, enumerableOnly) {
  var keys = Object.keys(object);
  if (Object.getOwnPropertySymbols) {
    var symbols = Object.getOwnPropertySymbols(object);
    enumerableOnly && (symbols = symbols.filter(function (sym) {
      return Object.getOwnPropertyDescriptor(object, sym).enumerable;
    })), keys.push.apply(keys, symbols);
  }
  return keys;
}
function _objectSpread2(target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = null != arguments[i] ? arguments[i] : {};
    i % 2 ? ownKeys(Object(source), !0).forEach(function (key) {
      _defineProperty(target, key, source[key]);
    }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) {
      Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
    });
  }
  return target;
}
function _regeneratorRuntime() {
  _regeneratorRuntime = function () {
    return exports;
  };
  var exports = {},
    Op = Object.prototype,
    hasOwn = Op.hasOwnProperty,
    defineProperty = Object.defineProperty || function (obj, key, desc) {
      obj[key] = desc.value;
    },
    $Symbol = "function" == typeof Symbol ? Symbol : {},
    iteratorSymbol = $Symbol.iterator || "@@iterator",
    asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator",
    toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  function define(obj, key, value) {
    return Object.defineProperty(obj, key, {
      value: value,
      enumerable: !0,
      configurable: !0,
      writable: !0
    }), obj[key];
  }
  try {
    define({}, "");
  } catch (err) {
    define = function (obj, key, value) {
      return obj[key] = value;
    };
  }
  function wrap(innerFn, outerFn, self, tryLocsList) {
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator,
      generator = Object.create(protoGenerator.prototype),
      context = new Context(tryLocsList || []);
    return defineProperty(generator, "_invoke", {
      value: makeInvokeMethod(innerFn, self, context)
    }), generator;
  }
  function tryCatch(fn, obj, arg) {
    try {
      return {
        type: "normal",
        arg: fn.call(obj, arg)
      };
    } catch (err) {
      return {
        type: "throw",
        arg: err
      };
    }
  }
  exports.wrap = wrap;
  var ContinueSentinel = {};
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}
  var IteratorPrototype = {};
  define(IteratorPrototype, iteratorSymbol, function () {
    return this;
  });
  var getProto = Object.getPrototypeOf,
    NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  NativeIteratorPrototype && NativeIteratorPrototype !== Op && hasOwn.call(NativeIteratorPrototype, iteratorSymbol) && (IteratorPrototype = NativeIteratorPrototype);
  var Gp = GeneratorFunctionPrototype.prototype = Generator.prototype = Object.create(IteratorPrototype);
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function (method) {
      define(prototype, method, function (arg) {
        return this._invoke(method, arg);
      });
    });
  }
  function AsyncIterator(generator, PromiseImpl) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if ("throw" !== record.type) {
        var result = record.arg,
          value = result.value;
        return value && "object" == typeof value && hasOwn.call(value, "__await") ? PromiseImpl.resolve(value.__await).then(function (value) {
          invoke("next", value, resolve, reject);
        }, function (err) {
          invoke("throw", err, resolve, reject);
        }) : PromiseImpl.resolve(value).then(function (unwrapped) {
          result.value = unwrapped, resolve(result);
        }, function (error) {
          return invoke("throw", error, resolve, reject);
        });
      }
      reject(record.arg);
    }
    var previousPromise;
    defineProperty(this, "_invoke", {
      value: function (method, arg) {
        function callInvokeWithMethodAndArg() {
          return new PromiseImpl(function (resolve, reject) {
            invoke(method, arg, resolve, reject);
          });
        }
        return previousPromise = previousPromise ? previousPromise.then(callInvokeWithMethodAndArg, callInvokeWithMethodAndArg) : callInvokeWithMethodAndArg();
      }
    });
  }
  function makeInvokeMethod(innerFn, self, context) {
    var state = "suspendedStart";
    return function (method, arg) {
      if ("executing" === state) throw new Error("Generator is already running");
      if ("completed" === state) {
        if ("throw" === method) throw arg;
        return doneResult();
      }
      for (context.method = method, context.arg = arg;;) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }
        if ("next" === context.method) context.sent = context._sent = context.arg;else if ("throw" === context.method) {
          if ("suspendedStart" === state) throw state = "completed", context.arg;
          context.dispatchException(context.arg);
        } else "return" === context.method && context.abrupt("return", context.arg);
        state = "executing";
        var record = tryCatch(innerFn, self, context);
        if ("normal" === record.type) {
          if (state = context.done ? "completed" : "suspendedYield", record.arg === ContinueSentinel) continue;
          return {
            value: record.arg,
            done: context.done
          };
        }
        "throw" === record.type && (state = "completed", context.method = "throw", context.arg = record.arg);
      }
    };
  }
  function maybeInvokeDelegate(delegate, context) {
    var methodName = context.method,
      method = delegate.iterator[methodName];
    if (undefined === method) return context.delegate = null, "throw" === methodName && delegate.iterator.return && (context.method = "return", context.arg = undefined, maybeInvokeDelegate(delegate, context), "throw" === context.method) || "return" !== methodName && (context.method = "throw", context.arg = new TypeError("The iterator does not provide a '" + methodName + "' method")), ContinueSentinel;
    var record = tryCatch(method, delegate.iterator, context.arg);
    if ("throw" === record.type) return context.method = "throw", context.arg = record.arg, context.delegate = null, ContinueSentinel;
    var info = record.arg;
    return info ? info.done ? (context[delegate.resultName] = info.value, context.next = delegate.nextLoc, "return" !== context.method && (context.method = "next", context.arg = undefined), context.delegate = null, ContinueSentinel) : info : (context.method = "throw", context.arg = new TypeError("iterator result is not an object"), context.delegate = null, ContinueSentinel);
  }
  function pushTryEntry(locs) {
    var entry = {
      tryLoc: locs[0]
    };
    1 in locs && (entry.catchLoc = locs[1]), 2 in locs && (entry.finallyLoc = locs[2], entry.afterLoc = locs[3]), this.tryEntries.push(entry);
  }
  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal", delete record.arg, entry.completion = record;
  }
  function Context(tryLocsList) {
    this.tryEntries = [{
      tryLoc: "root"
    }], tryLocsList.forEach(pushTryEntry, this), this.reset(!0);
  }
  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) return iteratorMethod.call(iterable);
      if ("function" == typeof iterable.next) return iterable;
      if (!isNaN(iterable.length)) {
        var i = -1,
          next = function next() {
            for (; ++i < iterable.length;) if (hasOwn.call(iterable, i)) return next.value = iterable[i], next.done = !1, next;
            return next.value = undefined, next.done = !0, next;
          };
        return next.next = next;
      }
    }
    return {
      next: doneResult
    };
  }
  function doneResult() {
    return {
      value: undefined,
      done: !0
    };
  }
  return GeneratorFunction.prototype = GeneratorFunctionPrototype, defineProperty(Gp, "constructor", {
    value: GeneratorFunctionPrototype,
    configurable: !0
  }), defineProperty(GeneratorFunctionPrototype, "constructor", {
    value: GeneratorFunction,
    configurable: !0
  }), GeneratorFunction.displayName = define(GeneratorFunctionPrototype, toStringTagSymbol, "GeneratorFunction"), exports.isGeneratorFunction = function (genFun) {
    var ctor = "function" == typeof genFun && genFun.constructor;
    return !!ctor && (ctor === GeneratorFunction || "GeneratorFunction" === (ctor.displayName || ctor.name));
  }, exports.mark = function (genFun) {
    return Object.setPrototypeOf ? Object.setPrototypeOf(genFun, GeneratorFunctionPrototype) : (genFun.__proto__ = GeneratorFunctionPrototype, define(genFun, toStringTagSymbol, "GeneratorFunction")), genFun.prototype = Object.create(Gp), genFun;
  }, exports.awrap = function (arg) {
    return {
      __await: arg
    };
  }, defineIteratorMethods(AsyncIterator.prototype), define(AsyncIterator.prototype, asyncIteratorSymbol, function () {
    return this;
  }), exports.AsyncIterator = AsyncIterator, exports.async = function (innerFn, outerFn, self, tryLocsList, PromiseImpl) {
    void 0 === PromiseImpl && (PromiseImpl = Promise);
    var iter = new AsyncIterator(wrap(innerFn, outerFn, self, tryLocsList), PromiseImpl);
    return exports.isGeneratorFunction(outerFn) ? iter : iter.next().then(function (result) {
      return result.done ? result.value : iter.next();
    });
  }, defineIteratorMethods(Gp), define(Gp, toStringTagSymbol, "Generator"), define(Gp, iteratorSymbol, function () {
    return this;
  }), define(Gp, "toString", function () {
    return "[object Generator]";
  }), exports.keys = function (val) {
    var object = Object(val),
      keys = [];
    for (var key in object) keys.push(key);
    return keys.reverse(), function next() {
      for (; keys.length;) {
        var key = keys.pop();
        if (key in object) return next.value = key, next.done = !1, next;
      }
      return next.done = !0, next;
    };
  }, exports.values = values, Context.prototype = {
    constructor: Context,
    reset: function (skipTempReset) {
      if (this.prev = 0, this.next = 0, this.sent = this._sent = undefined, this.done = !1, this.delegate = null, this.method = "next", this.arg = undefined, this.tryEntries.forEach(resetTryEntry), !skipTempReset) for (var name in this) "t" === name.charAt(0) && hasOwn.call(this, name) && !isNaN(+name.slice(1)) && (this[name] = undefined);
    },
    stop: function () {
      this.done = !0;
      var rootRecord = this.tryEntries[0].completion;
      if ("throw" === rootRecord.type) throw rootRecord.arg;
      return this.rval;
    },
    dispatchException: function (exception) {
      if (this.done) throw exception;
      var context = this;
      function handle(loc, caught) {
        return record.type = "throw", record.arg = exception, context.next = loc, caught && (context.method = "next", context.arg = undefined), !!caught;
      }
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i],
          record = entry.completion;
        if ("root" === entry.tryLoc) return handle("end");
        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc"),
            hasFinally = hasOwn.call(entry, "finallyLoc");
          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) return handle(entry.catchLoc, !0);
          } else {
            if (!hasFinally) throw new Error("try statement without catch or finally");
            if (this.prev < entry.finallyLoc) return handle(entry.finallyLoc);
          }
        }
      }
    },
    abrupt: function (type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev && hasOwn.call(entry, "finallyLoc") && this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }
      finallyEntry && ("break" === type || "continue" === type) && finallyEntry.tryLoc <= arg && arg <= finallyEntry.finallyLoc && (finallyEntry = null);
      var record = finallyEntry ? finallyEntry.completion : {};
      return record.type = type, record.arg = arg, finallyEntry ? (this.method = "next", this.next = finallyEntry.finallyLoc, ContinueSentinel) : this.complete(record);
    },
    complete: function (record, afterLoc) {
      if ("throw" === record.type) throw record.arg;
      return "break" === record.type || "continue" === record.type ? this.next = record.arg : "return" === record.type ? (this.rval = this.arg = record.arg, this.method = "return", this.next = "end") : "normal" === record.type && afterLoc && (this.next = afterLoc), ContinueSentinel;
    },
    finish: function (finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) return this.complete(entry.completion, entry.afterLoc), resetTryEntry(entry), ContinueSentinel;
      }
    },
    catch: function (tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if ("throw" === record.type) {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }
      throw new Error("illegal catch attempt");
    },
    delegateYield: function (iterable, resultName, nextLoc) {
      return this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      }, "next" === this.method && (this.arg = undefined), ContinueSentinel;
    }
  }, exports;
}
function _typeof(obj) {
  "@babel/helpers - typeof";

  return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) {
    return typeof obj;
  } : function (obj) {
    return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
  }, _typeof(obj);
}
function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }
  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}
function _asyncToGenerator(fn) {
  return function () {
    var self = this,
      args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);
      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }
      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }
      _next(undefined);
    });
  };
}
function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}
function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor);
  }
}
function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  Object.defineProperty(Constructor, "prototype", {
    writable: false
  });
  return Constructor;
}
function _defineProperty(obj, key, value) {
  key = _toPropertyKey(key);
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }
  return obj;
}
function _inherits(subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function");
  }
  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      writable: true,
      configurable: true
    }
  });
  Object.defineProperty(subClass, "prototype", {
    writable: false
  });
  if (superClass) _setPrototypeOf(subClass, superClass);
}
function _getPrototypeOf(o) {
  _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf.bind() : function _getPrototypeOf(o) {
    return o.__proto__ || Object.getPrototypeOf(o);
  };
  return _getPrototypeOf(o);
}
function _setPrototypeOf(o, p) {
  _setPrototypeOf = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function _setPrototypeOf(o, p) {
    o.__proto__ = p;
    return o;
  };
  return _setPrototypeOf(o, p);
}
function _isNativeReflectConstruct() {
  if (typeof Reflect === "undefined" || !Reflect.construct) return false;
  if (Reflect.construct.sham) return false;
  if (typeof Proxy === "function") return true;
  try {
    Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {}));
    return true;
  } catch (e) {
    return false;
  }
}
function _assertThisInitialized(self) {
  if (self === void 0) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }
  return self;
}
function _possibleConstructorReturn(self, call) {
  if (call && (typeof call === "object" || typeof call === "function")) {
    return call;
  } else if (call !== void 0) {
    throw new TypeError("Derived constructors may only return object or undefined");
  }
  return _assertThisInitialized(self);
}
function _createSuper(Derived) {
  var hasNativeReflectConstruct = _isNativeReflectConstruct();
  return function _createSuperInternal() {
    var Super = _getPrototypeOf(Derived),
      result;
    if (hasNativeReflectConstruct) {
      var NewTarget = _getPrototypeOf(this).constructor;
      result = Reflect.construct(Super, arguments, NewTarget);
    } else {
      result = Super.apply(this, arguments);
    }
    return _possibleConstructorReturn(this, result);
  };
}
function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread();
}
function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) return _arrayLikeToArray(arr);
}
function _iterableToArray(iter) {
  if (typeof Symbol !== "undefined" && iter[Symbol.iterator] != null || iter["@@iterator"] != null) return Array.from(iter);
}
function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}
function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;
  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];
  return arr2;
}
function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _createForOfIteratorHelper(o, allowArrayLike) {
  var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"];
  if (!it) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      var F = function () {};
      return {
        s: F,
        n: function () {
          if (i >= o.length) return {
            done: true
          };
          return {
            done: false,
            value: o[i++]
          };
        },
        e: function (e) {
          throw e;
        },
        f: F
      };
    }
    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }
  var normalCompletion = true,
    didErr = false,
    err;
  return {
    s: function () {
      it = it.call(o);
    },
    n: function () {
      var step = it.next();
      normalCompletion = step.done;
      return step;
    },
    e: function (e) {
      didErr = true;
      err = e;
    },
    f: function () {
      try {
        if (!normalCompletion && it.return != null) it.return();
      } finally {
        if (didErr) throw err;
      }
    }
  };
}
function _toPrimitive(input, hint) {
  if (typeof input !== "object" || input === null) return input;
  var prim = input[Symbol.toPrimitive];
  if (prim !== undefined) {
    var res = prim.call(input, hint || "default");
    if (typeof res !== "object") return res;
    throw new TypeError("@@toPrimitive must return a primitive value.");
  }
  return (hint === "string" ? String : Number)(input);
}
function _toPropertyKey(arg) {
  var key = _toPrimitive(arg, "string");
  return typeof key === "symbol" ? key : String(key);
}

var Comparator = /*#__PURE__*/function () {
  /**
   *
   * @param {*} expression   计算表达式
   * @param {*} formData     form表单数据
   * @param {*} parentFormData     父级数据
   */
  function Comparator(expression, formData, parentFormData) {
    _classCallCheck(this, Comparator);
    if (!expression) return;
    // expression 数组长度小于3则表达式不完整
    if (!Array.isArray(expression) || expression.length < 3) return;
    this.expression = expression;
    this.formData = formData;
    this.parentFormData = parentFormData;
  }

  /**
   * 根据表达式计算
   */
  _createClass(Comparator, [{
    key: "compare",
    value: function compare() {
      console.warn("Concrete Compare should override calc function");
    }
    // 计算值
  }, {
    key: "getValue",
    value: function getValue(field) {
      var value = "";
      if (field.startsWith("parentFormData.")) {
        field = field.replace("parentFormData.", "");
        value = this.parentFormData ? this.parentFormData[field] : undefined;
      } else {
        value = this.formData ? this.formData[field] : undefined;
      }
      return value;
    }
  }]);
  return Comparator;
}();

var EqualsComparator = /*#__PURE__*/function (_Comparator) {
  _inherits(EqualsComparator, _Comparator);
  var _super = _createSuper(EqualsComparator);
  function EqualsComparator(expression, formData, parentFormData) {
    _classCallCheck(this, EqualsComparator);
    return _super.call(this, expression, formData, parentFormData);
  }
  _createClass(EqualsComparator, [{
    key: "compare",
    value: function compare() {
      if (!this.formData) return false;
      var field = this.expression[1];
      var value = this.expression[2];
      var fieldValue = this.getValue(field);
      // const fieldValue = this.formData[field];
      return value === fieldValue;
    }
  }]);
  return EqualsComparator;
}(Comparator);

var UnEqualsComparator = /*#__PURE__*/function (_Comparator) {
  _inherits(UnEqualsComparator, _Comparator);
  var _super = _createSuper(UnEqualsComparator);
  function UnEqualsComparator(expression, formData, parentFormData) {
    _classCallCheck(this, UnEqualsComparator);
    return _super.call(this, expression, formData, parentFormData);
  }
  _createClass(UnEqualsComparator, [{
    key: "compare",
    value: function compare() {
      if (!this.formData) return false;
      var field = this.expression[1];
      var value = this.expression[2];
      var fieldValue = this.getValue(field);
      // const fieldValue = this.formData[field];
      return value !== fieldValue;
    }
  }]);
  return UnEqualsComparator;
}(Comparator);

var ContainsComparator$1 = /*#__PURE__*/function (_Comparator) {
  _inherits(ContainsComparator, _Comparator);
  var _super = _createSuper(ContainsComparator);
  function ContainsComparator(expression, formData, parentFormData) {
    _classCallCheck(this, ContainsComparator);
    return _super.call(this, expression, formData, parentFormData);
  }
  _createClass(ContainsComparator, [{
    key: "compare",
    value: function compare() {
      if (!this.formData) return false;
      var field = this.expression[1];
      var value = this.expression.slice(2);
      var fieldValue = this.getValue(field);
      // const fieldValue = this.formData[field];
      if (!fieldValue || !Array.isArray(fieldValue)) return false;
      return value.every(function (item) {
        return fieldValue.indexOf(item) >= 0;
      });
    }
  }]);
  return ContainsComparator;
}(Comparator);

var InComparator = /*#__PURE__*/function (_Comparator) {
  _inherits(InComparator, _Comparator);
  var _super = _createSuper(InComparator);
  function InComparator(expression, formData, parentFormData) {
    _classCallCheck(this, InComparator);
    return _super.call(this, expression, formData, parentFormData);
  }
  _createClass(InComparator, [{
    key: "compare",
    value: function compare() {
      var field = this.expression[1];
      var arr = this.expression.slice(2);
      var fieldValue = this.getValue(field);
      // const fieldValue = this.formData[field];

      return arr.indexOf(fieldValue) >= 0;
    }
  }]);
  return InComparator;
}(Comparator);

var AnyComparator = /*#__PURE__*/function (_Comparator) {
  _inherits(AnyComparator, _Comparator);
  var _super = _createSuper(AnyComparator);
  function AnyComparator(expression, formData, parentFormData) {
    _classCallCheck(this, AnyComparator);
    return _super.call(this, expression, formData, parentFormData);
  }
  _createClass(AnyComparator, [{
    key: "compare",
    value: function compare() {
      var _this = this;
      var res = false;
      this.expression.forEach(function (item, index) {
        if (res) return;
        if (index > 0) {
          res = ComparatorFactory.createComparator(item, _this.formData, _this.parentFormData).compare();
        }
      });
      return res;
    }
  }]);
  return AnyComparator;
}(Comparator);

var AllComparator = /*#__PURE__*/function (_Comparator) {
  _inherits(AllComparator, _Comparator);
  var _super = _createSuper(AllComparator);
  function AllComparator(expression, formData, parentFormData) {
    _classCallCheck(this, AllComparator);
    return _super.call(this, expression, formData, parentFormData);
  }
  _createClass(AllComparator, [{
    key: "compare",
    value: function compare() {
      var _this = this;
      var res = true;
      this.expression.forEach(function (item, index) {
        if (!res) return;
        if (index > 0) {
          res = ComparatorFactory.createComparator(item, _this.formData, _this.parentFormData).compare();
        }
      });
      return res;
    }
  }]);
  return AllComparator;
}(Comparator);

var ContainsComparator = /*#__PURE__*/function (_Comparator) {
  _inherits(ContainsComparator, _Comparator);
  var _super = _createSuper(ContainsComparator);
  function ContainsComparator(expression, formData, parentFormData) {
    _classCallCheck(this, ContainsComparator);
    return _super.call(this, expression, formData, parentFormData);
  }
  _createClass(ContainsComparator, [{
    key: "compare",
    value: function compare() {
      if (!this.formData) return false;
      var field = this.expression[1];
      var value = this.expression.slice(2);
      // const fieldValue = this.formData[field];
      var fieldValue = this.getValue(field);
      if (!fieldValue || !Array.isArray(fieldValue)) return false;
      return value.some(function (item) {
        return fieldValue.indexOf(item) >= 0;
      });
    }
  }]);
  return ContainsComparator;
}(Comparator);

var COMPARATOR_TYPES = {
  EQUALS: "==",
  UNEQUALS: "!=",
  CONTAINS: "contains",
  IN: "in",
  All: "all",
  ANY: "any",
  CONTAINS_ANY: "contains-any"
};
var createComparator = function createComparator(expression, formData, parentFormData) {
  if (!expression || !Array.isArray(expression) || expression.length < 3 || !formData && !parentFormData) return;
  var type = expression[0];
  switch (type) {
    case COMPARATOR_TYPES.EQUALS:
      return new EqualsComparator(expression, formData, parentFormData);
    case COMPARATOR_TYPES.UNEQUALS:
      return new UnEqualsComparator(expression, formData, parentFormData);
    case COMPARATOR_TYPES.CONTAINS:
      return new ContainsComparator$1(expression, formData, parentFormData);
    case COMPARATOR_TYPES.IN:
      return new InComparator(expression, formData, parentFormData);
    case COMPARATOR_TYPES.All:
      return new AllComparator(expression, formData, parentFormData);
    case COMPARATOR_TYPES.ANY:
      return new AnyComparator(expression, formData, parentFormData);
    case COMPARATOR_TYPES.CONTAINS_ANY:
      return new ContainsComparator(expression, formData, parentFormData);
  }
};
var ComparatorFactory = {
  createComparator: createComparator
};

//
var script$v = {
  inject: ["bus"],
  name: "Card",
  props: {
    options: {
      type: Object
    }
  },
  data: function data() {
    return {
      emptyImage: Empty.PRESENTED_IMAGE_SIMPLE,
      emptyVisible: false,
      visible: true
    };
  },
  mounted: function mounted() {
    this.updateVisibility();
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.formChangeHandler);
    this.setEmptyVisible();
  },
  methods: {
    formChangeHandler: function formChangeHandler(payload) {
      if (!this.options || !this.options.children) return;
      this.setEmptyVisible();
      this.updateVisibility(payload);
    },
    setEmptyVisible: function setEmptyVisible() {
      var _this = this;
      this.$nextTick(function () {
        var height = 0;
        _this.options.children.forEach(function (comp, index) {
          var c = _this.$refs[index][0];
          if (c && !isNaN(c.$el.clientHeight)) {
            height += c.$el.clientHeight;
          }
          _this.emptyVisible = height === 0;
        });
      });
    },
    // 自动显示或隐藏
    updateVisibility: function updateVisibility(payload) {
      var formData = (payload === null || payload === void 0 ? void 0 : payload.data) || this.options["formData"];
      var depends = this.options.depends;
      if (depends) {
        var comparator = ComparatorFactory.createComparator(depends, formData);
        this.visible = comparator.compare();
      }
    }
  }
};

function normalizeComponent(template, style, script, scopeId, isFunctionalTemplate, moduleIdentifier /* server only */, shadowMode, createInjector, createInjectorSSR, createInjectorShadow) {
    if (typeof shadowMode !== 'boolean') {
        createInjectorSSR = createInjector;
        createInjector = shadowMode;
        shadowMode = false;
    }
    // Vue.extend constructor export interop.
    const options = typeof script === 'function' ? script.options : script;
    // render functions
    if (template && template.render) {
        options.render = template.render;
        options.staticRenderFns = template.staticRenderFns;
        options._compiled = true;
        // functional template
        if (isFunctionalTemplate) {
            options.functional = true;
        }
    }
    // scopedId
    if (scopeId) {
        options._scopeId = scopeId;
    }
    let hook;
    if (moduleIdentifier) {
        // server build
        hook = function (context) {
            // 2.3 injection
            context =
                context || // cached call
                    (this.$vnode && this.$vnode.ssrContext) || // stateful
                    (this.parent && this.parent.$vnode && this.parent.$vnode.ssrContext); // functional
            // 2.2 with runInNewContext: true
            if (!context && typeof __VUE_SSR_CONTEXT__ !== 'undefined') {
                context = __VUE_SSR_CONTEXT__;
            }
            // inject component styles
            if (style) {
                style.call(this, createInjectorSSR(context));
            }
            // register component module identifier for async chunk inference
            if (context && context._registeredComponents) {
                context._registeredComponents.add(moduleIdentifier);
            }
        };
        // used by ssr in case component is cached and beforeCreate
        // never gets called
        options._ssrRegister = hook;
    }
    else if (style) {
        hook = shadowMode
            ? function (context) {
                style.call(this, createInjectorShadow(context, this.$root.$options.shadowRoot));
            }
            : function (context) {
                style.call(this, createInjector(context));
            };
    }
    if (hook) {
        if (options.functional) {
            // register for functional component in vue file
            const originalRender = options.render;
            options.render = function renderWithStyleInjection(h, context) {
                hook.call(context);
                return originalRender(h, context);
            };
        }
        else {
            // inject component registration as beforeCreate hook
            const existing = options.beforeCreate;
            options.beforeCreate = existing ? [].concat(existing, hook) : [hook];
        }
    }
    return script;
}

const isOldIE = typeof navigator !== 'undefined' &&
    /msie [6-9]\\b/.test(navigator.userAgent.toLowerCase());
function createInjector(context) {
    return (id, style) => addStyle(id, style);
}
let HEAD;
const styles = {};
function addStyle(id, css) {
    const group = isOldIE ? css.media || 'default' : id;
    const style = styles[group] || (styles[group] = { ids: new Set(), styles: [] });
    if (!style.ids.has(id)) {
        style.ids.add(id);
        let code = css.source;
        if (css.map) {
            // https://developer.chrome.com/devtools/docs/javascript-debugging
            // this makes source maps inside style tags work properly in Chrome
            code += '\n/*# sourceURL=' + css.map.sources[0] + ' */';
            // http://stackoverflow.com/a/26603875
            code +=
                '\n/*# sourceMappingURL=data:application/json;base64,' +
                    btoa(unescape(encodeURIComponent(JSON.stringify(css.map)))) +
                    ' */';
        }
        if (!style.element) {
            style.element = document.createElement('style');
            style.element.type = 'text/css';
            if (css.media)
                style.element.setAttribute('media', css.media);
            if (HEAD === undefined) {
                HEAD = document.head || document.getElementsByTagName('head')[0];
            }
            HEAD.appendChild(style.element);
        }
        if ('styleSheet' in style.element) {
            style.styles.push(code);
            style.element.styleSheet.cssText = style.styles
                .filter(Boolean)
                .join('\n');
        }
        else {
            const index = style.ids.size - 1;
            const textNode = document.createTextNode(code);
            const nodes = style.element.childNodes;
            if (nodes[index])
                style.element.removeChild(nodes[index]);
            if (nodes.length)
                style.element.insertBefore(textNode, nodes[index]);
            else
                style.element.appendChild(textNode);
        }
    }
}

/* script */
var __vue_script__$v = script$v;

/* template */
var __vue_render__$v = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.visible,
      expression: "visible"
    }],
    staticClass: "form-card-wrapper"
  }, [_c("a-card", {
    attrs: {
      title: _vm.options.title
    }
  }, [_vm._l(_vm.options.children, function (component, index) {
    return [!component.options || component.options.visible !== false ? _c(component.type, {
      key: index,
      ref: index,
      refInFor: true,
      tag: "component",
      attrs: {
        options: component.options
      }
    }) : _vm._e()];
  }), _vm._v(" "), _vm.emptyVisible ? _c("a-empty", {
    attrs: {
      description: "此项由其他填报项决定，暂无可填报内容",
      image: _vm.emptyImage
    }
  }) : _vm._e()], 2)], 1);
};
var __vue_staticRenderFns__$v = [];
__vue_render__$v._withStripped = true;

/* style */
var __vue_inject_styles__$v = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-96bf16e6_0", {
    source: ".form-card-wrapper[data-v-96bf16e6] {\n  margin-top: 12px;\n}\n.ant-card[data-v-96bf16e6] {\n  color: rgba(0, 0, 0, 0.85);\n}\n.ant-empty-normal[data-v-96bf16e6] {\n  margin: 12px 0;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,gBAAgB;AAClB;AACA;EACE,0BAA0B;AAC5B;AACA;EACE,cAAc;AAChB",
      "file": "index.vue",
      "sourcesContent": [".form-card-wrapper {\n  margin-top: 12px;\n}\n.ant-card {\n  color: rgba(0, 0, 0, 0.85);\n}\n.ant-empty-normal {\n  margin: 12px 0;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$v = "data-v-96bf16e6";
/* module identifier */
var __vue_module_identifier__$v = undefined;
/* functional template */
var __vue_is_functional_template__$v = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$v = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$v,
  staticRenderFns: __vue_staticRenderFns__$v
}, __vue_inject_styles__$v, __vue_script__$v, __vue_scope_id__$v, __vue_is_functional_template__$v, __vue_module_identifier__$v, false, createInjector, undefined, undefined);

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var script$u = {
  props: {
    options: {
      type: Object
    }
  },
  name: "Grid"
};

/* script */
var __vue_script__$u = script$u;

/* template */
var __vue_render__$u = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "form-grid-wraper"
  }, [_c("a-row", {
    attrs: {
      gutter: [20, 0],
      type: "flex"
    }
  }, [_vm._l(_vm.options.children, function (component, index) {
    return [component.options.visible !== false ? _c("a-col", {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: !component.options.hide,
        expression: "!component.options.hide"
      }],
      key: index,
      attrs: {
        span: 24 / _vm.options.columns
      }
    }, [_c(component.type, {
      tag: "component",
      attrs: {
        options: component.options
      }
    })], 1) : _vm._e()];
  })], 2)], 1);
};
var __vue_staticRenderFns__$u = [];
__vue_render__$u._withStripped = true;

/* style */
var __vue_inject_styles__$u = undefined;
/* scoped */
var __vue_scope_id__$u = undefined;
/* module identifier */
var __vue_module_identifier__$u = undefined;
/* functional template */
var __vue_is_functional_template__$u = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$u = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$u,
  staticRenderFns: __vue_staticRenderFns__$u
}, __vue_inject_styles__$u, __vue_script__$u, __vue_scope_id__$u, __vue_is_functional_template__$u, __vue_module_identifier__$u, false, undefined, undefined, undefined);

//
var script$t = {
  inject: ["bus"],
  name: "Group",
  props: {
    options: {
      type: Object
    }
  },
  data: function data() {
    return {
      visible: undefined
    };
  },
  computed: {
    formData: function formData() {
      return this.options.formData;
    },
    depends: function depends() {
      return this.options.depends;
    }
  },
  created: function created() {
    if (this.depends) {
      this.updateVisibility();
    }
  },
  mounted: function mounted() {
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.formChangeHandler);
  },
  methods: {
    // 自动显示或隐藏
    updateVisibility: function updateVisibility() {
      var comparator = ComparatorFactory.createComparator(this.depends, this.formData);
      this.visible = comparator.compare();
      this.$set(this.options, "visible", this.visible);
      console.log(this.options.visible);
    },
    //
    formChangeHandler: function formChangeHandler(_ref) {
      var field = _ref.field;
      // 处理deponds逻辑
      if (this.depends && this.fieldInDepands(field, this.depends)) {
        this.updateVisibility();
      }
    },
    fieldInDepands: function fieldInDepands(field, depends) {
      var res = false;
      for (var i = 0; i < depends.length; i++) {
        if (Array.isArray(depends[i])) {
          //判断是否为多维数组
          res = this.fieldInDepands(field, depends[i]);
          if (res) return true;
        } else {
          if (depends[i] === field) return true;
        }
      }
      return res;
    }
  }
};

/* script */
var __vue_script__$t = script$t;

/* template */
var __vue_render__$t = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "form-group-wrapper"
  }, [_vm._l(_vm.options.children, function (component, index) {
    return [component.options.visible !== false ? _c(component.type, {
      key: index,
      tag: "component",
      attrs: {
        options: component.options
      }
    }) : _vm._e()];
  })], 2);
};
var __vue_staticRenderFns__$t = [];
__vue_render__$t._withStripped = true;

/* style */
var __vue_inject_styles__$t = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-81e1d264_0", {
    source: ".form-group-wrapper[data-v-81e1d264] {\n  border: 1px dashed #ccc;\n  padding: 4px 8px 0 8px;\n  margin: 0 -8px 8px -8px;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,uBAAuB;EACvB,sBAAsB;EACtB,uBAAuB;AACzB",
      "file": "index.vue",
      "sourcesContent": [".form-group-wrapper {\n  border: 1px dashed #ccc;\n  padding: 4px 8px 0 8px;\n  margin: 0 -8px 8px -8px;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$t = "data-v-81e1d264";
/* module identifier */
var __vue_module_identifier__$t = undefined;
/* functional template */
var __vue_is_functional_template__$t = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$t = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$t,
  staticRenderFns: __vue_staticRenderFns__$t
}, __vue_inject_styles__$t, __vue_script__$t, __vue_scope_id__$t, __vue_is_functional_template__$t, __vue_module_identifier__$t, false, createInjector, undefined, undefined);

//
//
//

var script$s = {
  name: "SplitLine",
  data: function data() {
    return {};
  }
};

/* script */
var __vue_script__$s = script$s;

/* template */
var __vue_render__$s = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "form-split-line"
  });
};
var __vue_staticRenderFns__$s = [];
__vue_render__$s._withStripped = true;

/* style */
var __vue_inject_styles__$s = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-2609db7c_0", {
    source: ".form-split-line[data-v-2609db7c] {\n  margin: 16px -24px;\n  border-top: 1px solid #e8e8e8;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,kBAAkB;EAClB,6BAA6B;AAC/B",
      "file": "index.vue",
      "sourcesContent": [".form-split-line {\n  margin: 16px -24px;\n  border-top: 1px solid #e8e8e8;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$s = "data-v-2609db7c";
/* module identifier */
var __vue_module_identifier__$s = undefined;
/* functional template */
var __vue_is_functional_template__$s = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$s = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$s,
  staticRenderFns: __vue_staticRenderFns__$s
}, __vue_inject_styles__$s, __vue_script__$s, __vue_scope_id__$s, __vue_is_functional_template__$s, __vue_module_identifier__$s, false, createInjector, undefined, undefined);

//
var script$r = {
  name: "Title",
  inject: ["bus"],
  props: {
    options: {
      type: Object
    }
  },
  data: function data() {
    return {
      visible: true
    };
  },
  mounted: function mounted() {
    this.updateVisibility();
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.updateVisibility);
  },
  methods: {
    // 自动显示或隐藏
    updateVisibility: function updateVisibility() {
      var formData = this.options["formData"];
      var depends = this.options.depends;
      if (depends) {
        var comparator = ComparatorFactory.createComparator(depends, formData);
        this.visible = comparator.compare();
      }
    }
  }
};

/* script */
var __vue_script__$r = script$r;

/* template */
var __vue_render__$r = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.visible,
      expression: "visible"
    }],
    staticClass: "form-title-wrapper"
  }, [_vm._v("\n  " + _vm._s(_vm.options.text) + "\n")]);
};
var __vue_staticRenderFns__$r = [];
__vue_render__$r._withStripped = true;

/* style */
var __vue_inject_styles__$r = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-700d86c4_0", {
    source: ".form-title-wrapper[data-v-700d86c4] {\n  padding-bottom: 12px;\n  font-size: 16px;\n  font-weight: 500;\n}\n.form-title-wrapper[data-v-700d86c4]:not(:first-child) {\n  padding-top: 12px;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,oBAAoB;EACpB,eAAe;EACf,gBAAgB;AAClB;AACA;EACE,iBAAiB;AACnB",
      "file": "index.vue",
      "sourcesContent": [".form-title-wrapper {\n  padding-bottom: 12px;\n  font-size: 16px;\n  font-weight: 500;\n}\n.form-title-wrapper:not(:first-child) {\n  padding-top: 12px;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$r = "data-v-700d86c4";
/* module identifier */
var __vue_module_identifier__$r = undefined;
/* functional template */
var __vue_is_functional_template__$r = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$r = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$r,
  staticRenderFns: __vue_staticRenderFns__$r
}, __vue_inject_styles__$r, __vue_script__$r, __vue_scope_id__$r, __vue_is_functional_template__$r, __vue_module_identifier__$r, false, createInjector, undefined, undefined);

var Calculator = /*#__PURE__*/function () {
  /**
   *
   * @param {*} expression   计算表达式
   * @param {*} formData     form表单数据
   * @param {*} fieldData     字段数据，通常是字段发生变化时，FIELD_CHANGE事件中携带的数据，包含了该字段的所有信息，比如下拉框中携带了label、code之外的信心
   */
  function Calculator(expression, formData, fieldData) {
    _classCallCheck(this, Calculator);
    if (!expression || !formData) return;
    // expression 数组长度小于3则表达式不完整
    if (!Array.isArray(expression) || expression.length < 3) return;
    this.expression = expression;
    this.formData = formData;
    this.fieldData = fieldData;
  }

  /**
   * 根据表达式计算
   */
  _createClass(Calculator, [{
    key: "calc",
    value: function calc() {
      console.warn("Concrete Calculator should override calc function");
    }

    /**
     * 获取字段列表
     */
  }, {
    key: "getFields",
    value: function getFields() {
      console.warn("Concrete Calculator should override getFields function");
    }
  }]);
  return Calculator;
}();

var PlusCalculator = /*#__PURE__*/function (_Calculator) {
  _inherits(PlusCalculator, _Calculator);
  var _super = _createSuper(PlusCalculator);
  function PlusCalculator(expression, formData, fieldData) {
    _classCallCheck(this, PlusCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 根据表达式计算
   */
  _createClass(PlusCalculator, [{
    key: "calc",
    value: function calc() {
      var _this = this;
      // 获取所有参与计算的字段名称
      var fields = this.expression.slice(1);
      // 从formData中获取字段值
      var values = fields.map(function (v) {
        return _this.getValue(v);
      });
      // 字段值加和
      // null会作为0参与计算
      var array = values.filter(function (num) {
        return !isNaN(num) && num !== null;
      });
      return array.length > 0 ? array.reduce(function (acr, cur) {
        return acr + cur;
      }) : undefined;
    }
  }, {
    key: "getValue",
    value: function getValue(key) {
      if (!key) return;
      // 如果是数组视为表达式，通过计算器计算
      if (Array.isArray(key)) {
        var calculator = CalculatorFactory.createCalculator(key, this.formData);
        if (!calculator) return;
        return calculator.calc();
      }
      // 如果不是数组视为字段名称，从fromData中获取
      return this.formData[key];
    }
  }, {
    key: "getFields",
    value: function getFields() {
      var _this2 = this;
      if (!this.expression || !Array.isArray(this.expression)) return;
      var items = this.expression.slice(1);
      var fields = [];
      items.forEach(function (item) {
        if (Array.isArray(item)) {
          var calculator = CalculatorFactory.createCalculator(item, _this2.formData);
          if (calculator) {
            fields.push.apply(fields, _toConsumableArray(calculator.getFields()));
          }
        } else {
          fields.push(item);
        }
      });
      return fields;
    }
  }]);
  return PlusCalculator;
}(Calculator);

var SubtractCalculator = /*#__PURE__*/function (_Calculator) {
  _inherits(SubtractCalculator, _Calculator);
  var _super = _createSuper(SubtractCalculator);
  function SubtractCalculator(expression, formData, fieldData) {
    _classCallCheck(this, SubtractCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 根据表达式计算
   */
  _createClass(SubtractCalculator, [{
    key: "calc",
    value: function calc() {
      var _this = this;
      // 获取所有参与计算的字段名称
      var fields = this.expression.slice(1);
      // 从formData中获取字段值
      var values = fields.map(function (v) {
        return _this.getValue(v);
      });
      // 字段值依次减
      // null会作为0参与计算
      var array = values.filter(function (num) {
        return !isNaN(num) && num !== null;
      });
      return array.length > 0 ? array.reduce(function (acr, cur) {
        return acr - cur;
      }) : undefined;
    }
  }, {
    key: "getValue",
    value: function getValue(key) {
      if (!key) return;
      // 如果是数组视为表达式，通过计算器计算
      if (Array.isArray(key)) {
        var calculator = CalculatorFactory.createCalculator(key, this.formData);
        if (!calculator) return;
        return calculator.calc();
      }
      // 如果不是数组视为字段名称，从fromData中获取
      return this.formData[key];
    }
  }, {
    key: "getFields",
    value: function getFields() {
      var _this2 = this;
      if (!this.expression || !Array.isArray(this.expression)) return;
      var items = this.expression.slice(1);
      var fields = [];
      items.forEach(function (item) {
        if (Array.isArray(item)) {
          var calculator = CalculatorFactory.createCalculator(item, _this2.formData);
          if (calculator) {
            fields.push.apply(fields, _toConsumableArray(calculator.getFields()));
          }
        } else {
          fields.push(item);
        }
      });
      return fields;
    }
  }]);
  return SubtractCalculator;
}(Calculator);

var MultiplyCalculator = /*#__PURE__*/function (_Calculator) {
  _inherits(MultiplyCalculator, _Calculator);
  var _super = _createSuper(MultiplyCalculator);
  function MultiplyCalculator(expression, formData, fieldData) {
    _classCallCheck(this, MultiplyCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 根据表达式计算
   */
  _createClass(MultiplyCalculator, [{
    key: "calc",
    value: function calc() {
      var _this = this;
      // 获取所有参与计算的字段名称
      var fields = this.expression.slice(1);
      // 从formData中获取字段值
      var values = fields.map(function (v) {
        return _this.getValue(v);
      });
      // 字段值加和
      var array = values.filter(function (num) {
        return !isNaN(num) && num !== null;
      });
      if (values.length !== array.length) {
        return;
      }
      return array.length > 0 ? array.reduce(function (acr, cur) {
        return acr * cur;
      }) : undefined;
    }
  }, {
    key: "getValue",
    value: function getValue(key) {
      return typeof key === "number" && !isNaN(key) ? key : this.formData[key];
    }
  }, {
    key: "getFields",
    value: function getFields() {
      if (!this.expression || !Array.isArray(this.expression)) return;
      return this.expression.slice(1).filter(function (item) {
        return !(typeof item === "number" && !isNaN(item));
      });
    }
  }]);
  return MultiplyCalculator;
}(Calculator);

var ConcatCalculator$1 = /*#__PURE__*/function (_Calculator) {
  _inherits(ConcatCalculator, _Calculator);
  var _super = _createSuper(ConcatCalculator);
  function ConcatCalculator(expression, formData, fieldData) {
    _classCallCheck(this, ConcatCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 根据表达式计算
   */
  _createClass(ConcatCalculator, [{
    key: "calc",
    value: function calc() {
      var _this = this;
      // 获取所有参与计算的字段名称
      var fields = this.expression.slice(2);
      // 分隔符
      var separator = this.expression[1];
      // 从formData中获取字段值
      var values = fields.map(function (v) {
        return _this.formData[v];
      });
      // 字段值加和
      return values.join(separator);
    }
  }, {
    key: "getFields",
    value: function getFields() {
      if (!this.expression || !Array.isArray(this.expression)) return;
      return this.expression.slice(2);
    }
  }]);
  return ConcatCalculator;
}(Calculator);

var DivideCalculator = /*#__PURE__*/function (_Calculator) {
  _inherits(DivideCalculator, _Calculator);
  var _super = _createSuper(DivideCalculator);
  function DivideCalculator(expression, formData, fieldData) {
    _classCallCheck(this, DivideCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 根据表达式计算
   */
  _createClass(DivideCalculator, [{
    key: "calc",
    value: function calc() {
      var _this = this;
      // 获取所有参与计算的字段名称
      var fields = this.expression.slice(1);
      // 从formData中获取字段值
      var values = fields.map(function (v) {
        return _this.getValue(v);
      });
      // 字段值加和
      var array = values.filter(function (num) {
        return !isNaN(num) && num !== null;
      });
      if (values.length !== array.length && array.length < 2) {
        return;
      }
      var value = array.reduce(function (acr, cur) {
        return acr / cur;
      });
      return isNaN(value) ? "" : value;
    }
  }, {
    key: "getValue",
    value: function getValue(key) {
      return typeof key === "number" && !isNaN(key) ? key : this.formData[key];
    }
  }, {
    key: "getFields",
    value: function getFields() {
      if (!this.expression || !Array.isArray(this.expression)) return;
      return this.expression.slice(1).filter(function (item) {
        return !(typeof item === "number" && !isNaN(item));
      });
    }
  }]);
  return DivideCalculator;
}(Calculator);

var SumCalculator$1 = /*#__PURE__*/function (_Calculator) {
  _inherits(SumCalculator, _Calculator);
  var _super = _createSuper(SumCalculator);
  function SumCalculator(expression, formData, fieldData) {
    _classCallCheck(this, SumCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 用于对子表求和
   * 1. 对子表的单个字段求和
   * ["sum", "sub_form", "field"]
   * 2. 对子表字段进行计算之后再求和
   * ["sum", "sub_form", ["*", "field1", "field2"]]
   */
  _createClass(SumCalculator, [{
    key: "calc",
    value: function calc() {
      // 获取子表单名称
      var subForm = this.expression[1];
      // 从formData中获取子表单的值
      var subFormValue = this.formData[subForm];
      if (!subFormValue) return;
      var dataList = subFormValue.data;
      if (!dataList) return;
      // 对子表字段进行计算
      var sumItem = this.expression[2];
      if (Array.isArray(sumItem)) {
        return this.getSumByCalculator(dataList, sumItem);
      }
      return this.getSumByField(dataList, sumItem);
    }

    // 从子表中获取字段值加和
  }, {
    key: "getSumByField",
    value: function getSumByField(dataList, field) {
      if (!field || !dataList || !Array.isArray(dataList)) return;
      var dataItems = dataList.map(function (d) {
        return d[field];
      }).filter(function (d) {
        return !isNaN(d) && d !== null;
      });
      return dataItems.length > 0 ? dataItems.reduce(function (acr, cur) {
        return acr + cur;
      }) : 0;
    }

    // 对子表中的单条记录按照公司计算，将计算结果加和
  }, {
    key: "getSumByCalculator",
    value: function getSumByCalculator(dataList, expression) {
      if (!dataList || !Array.isArray(dataList) || !expression || !Array.isArray(expression)) return;
      var dataItems = dataList.map(function (item) {
        var calc = CalculatorFactory.createCalculator(expression, item);
        if (calc) {
          return calc.calc();
        }
      });
      dataItems = dataItems.filter(function (d) {
        return !isNaN(d) && d !== null;
      });
      return dataItems.length > 0 ? dataItems.reduce(function (acr, cur) {
        return acr + cur;
      }) : 0;
    }
  }, {
    key: "getFields",
    value: function getFields() {
      if (!this.expression || !Array.isArray(this.expression)) return;
      return [this.expression[1]];
    }
  }]);
  return SumCalculator;
}(Calculator);

var ConcatCalculator = /*#__PURE__*/function (_Calculator) {
  _inherits(ConcatCalculator, _Calculator);
  var _super = _createSuper(ConcatCalculator);
  function ConcatCalculator(expression, formData, fieldData) {
    _classCallCheck(this, ConcatCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 根据表达式计算
   */
  _createClass(ConcatCalculator, [{
    key: "calc",
    value: function calc() {
      var key = this.expression[1];
      if (!this.fieldData || !key) return;
      if (Array.isArray(this.fieldData)) {
        return this.fieldData.map(function (item) {
          return item[key];
        });
      } else {
        return this.fieldData[key];
      }
    }
  }, {
    key: "getFields",
    value: function getFields() {
      if (!this.expression || !Array.isArray(this.expression)) return;
      return this.expression.slice(2);
    }
  }]);
  return ConcatCalculator;
}(Calculator);

var SumCalculator = /*#__PURE__*/function (_Calculator) {
  _inherits(SumCalculator, _Calculator);
  var _super = _createSuper(SumCalculator);
  function SumCalculator(expression, formData, fieldData) {
    _classCallCheck(this, SumCalculator);
    return _super.call(this, expression, formData, fieldData);
  }

  /**
   * 用于对子表求和
   * 1. 对子表的单个字段求和
   * ["sum", "sub_form", "field"]
   * 2. 对子表字段进行计算之后再求和
   * ["sum", "sub_form", ["*", "field1", "field2"]]
   */
  _createClass(SumCalculator, [{
    key: "calc",
    value: function calc() {
      // 获取子表单名称
      var subForm = this.expression[1];
      // 从formData中获取子表单的值
      var subFormValue = this.formData[subForm];
      if (!subFormValue) return;
      var dataList = subFormValue.data;
      if (!dataList) return;
      // 对子表字段进行计算
      var sumItem = this.expression[2];
      var sum = 0;
      if (Array.isArray(sumItem)) {
        sum = this.getSumByCalculator(dataList, sumItem);
      } else {
        sum = this.getSumByField(dataList, sumItem);
      }
      return parseFloat((sum / dataList.length).toFixed(2));
    }

    // 从子表中获取字段值加和
  }, {
    key: "getSumByField",
    value: function getSumByField(dataList, field) {
      if (!field || !dataList || !Array.isArray(dataList)) return;
      var dataItems = dataList.map(function (d) {
        return d[field];
      }).filter(function (d) {
        return !isNaN(d) && d !== null;
      });
      return dataItems.length > 0 ? dataItems.reduce(function (acr, cur) {
        return acr + cur;
      }) : 0;
    }

    // 对子表中的单条记录按照公司计算，将计算结果加和
  }, {
    key: "getSumByCalculator",
    value: function getSumByCalculator(dataList, expression) {
      if (!dataList || !Array.isArray(dataList) || !expression || !Array.isArray(expression)) return;
      var dataItems = dataList.map(function (item) {
        var calc = CalculatorFactory.createCalculator(expression, item);
        if (calc) {
          return calc.calc();
        }
      });
      dataItems = dataItems.filter(function (d) {
        return !isNaN(d) && d !== null;
      });
      return dataItems.length > 0 ? dataItems.reduce(function (acr, cur) {
        return acr + cur;
      }) : 0;
    }
  }, {
    key: "getFields",
    value: function getFields() {
      if (!this.expression || !Array.isArray(this.expression)) return;
      return [this.expression[1]];
    }
  }]);
  return SumCalculator;
}(Calculator);

var CALCULATOR_TYPES = {
  PLUS: "+",
  SUBTRACT: "-",
  MULTIPLY: "*",
  CONCAT: "concat",
  SUM: "sum",
  GET: "get",
  SUM_MEAN: "sum_mean",
  DIVIDE: "/"
};
var createCalculator = function createCalculator(expression, formData, fieldData) {
  if (!expression || !Array.isArray(expression) || expression.length < 3 || !formData) return;
  var type = expression[0];
  switch (type) {
    case CALCULATOR_TYPES.PLUS:
      return new PlusCalculator(expression, formData, fieldData);
    case CALCULATOR_TYPES.SUBTRACT:
      return new SubtractCalculator(expression, formData, fieldData);
    case CALCULATOR_TYPES.MULTIPLY:
      return new MultiplyCalculator(expression, formData, fieldData);
    case CALCULATOR_TYPES.CONCAT:
      return new ConcatCalculator$1(expression, formData, fieldData);
    case CALCULATOR_TYPES.SUM:
      return new SumCalculator$1(expression, formData, fieldData);
    case CALCULATOR_TYPES.GET:
      return new ConcatCalculator(expression, formData, fieldData);
    case CALCULATOR_TYPES.SUM_MEAN:
      return new SumCalculator(expression, formData, fieldData);
    case CALCULATOR_TYPES.DIVIDE:
      return new DivideCalculator(expression, formData, fieldData);
  }
};
var CalculatorFactory = {
  createCalculator: createCalculator
};

var SHARE_DATA_KEY_PREFIX = "__SHARE_DATA_CACHE__";

/**
 * 设置共享数据
 * @param {*} key
 * @param {*} data
 * @returns
 */
var setShareData = function setShareData(key, data) {
  if (!key) return;
  var shareKey = genShareDataKey(key);
  try {
    localStorage.setItem(shareKey, JSON.stringify(data));
    return true;
  } catch (e) {
    console.log("存储共享数据失败：", e);
  }
  return false;
};

/**
 * 获取共享数据
 * @param {*} key
 * @returns
 */
var getShareData = function getShareData(key) {
  if (!key) return;
  var shareKey = genShareDataKey(key);
  try {
    var data = localStorage.getItem(shareKey);
    return JSON.parse(data);
  } catch (e) {
    console.log("获取共享数据失败：", e);
  }
};

/**
 * 删除共享数据
 * @param {*} key
 * @returns
 */
var removeShareData = function removeShareData(key) {
  if (!key) return;
  var shareKey = genShareDataKey(key);
  localStorage.removeItem(shareKey);
};
var genShareDataKey = function genShareDataKey(key) {
  return "".concat(SHARE_DATA_KEY_PREFIX).concat(key);
};
var Storage = {
  setShareData: setShareData,
  getShareData: getShareData,
  removeShareData: removeShareData
};

/**
 * 共享数据操作
 */
var Share = /*#__PURE__*/function () {
  function Share(expression) {
    _classCallCheck(this, Share);
    if (!expression) return;
    var read = expression.read,
      write = expression.write;
    this.readExp = read;
    this.writeExp = write;
  }

  /**
   * 从共享数据池读取数据，存储到shareDataPool(组件内部存储获取到的共享数据)
   * @param {Object} shareDataPool
   */
  _createClass(Share, [{
    key: "read",
    value: function read(shareDataPool) {
      if (!this.readExp || !shareDataPool) return;
      var shareKey = this.readExp[0];
      var dataKey = this.readExp[1];
      var shareData = Storage.getShareData(shareKey);
      shareDataPool[dataKey] = shareData;
    }

    /**
     * 向共享数据池写入数据
     * @param {Object} data
     */
  }, {
    key: "write",
    value: function write(data) {
      if (!this.writeExp) return;
      var shareKey = this.writeExp[0];
      Storage.setShareData(shareKey, data);
    }

    /**
     * 移除共享数据
     */
  }, {
    key: "clear",
    value: function clear() {
      if (!this.writeExp) return;
      var shareKey = this.writeExp[0];
      Storage.removeShareData(shareKey);
    }
  }]);
  return Share;
}();

var importBaseField = {
  // 注入表单级EventBus
  inject: ["bus", "parentFormData"],
  props: {
    options: {
      type: Object
    }
  },
  data: function data() {
    return {
      value: undefined,
      customUnit: undefined,
      visible: undefined,
      shareDataPool: {}
    };
  },
  computed: {
    // 是否必填
    required: function required() {
      return this.options.required === true;
    },
    // 字段名称
    field: function field() {
      return this.options.field;
    },
    // 标注
    label: function label() {
      return this.options.label;
    },
    // 单位
    unit: function unit() {
      if (!this.options.unit) return;
      // return this.customUnit || this.options.unit;
      var match = this.options.unit.match(/\{(.+?)\}/g);
      // 如果没有匹配{xxx}则返回原始内容作为标题
      if (match) {
        var field = "".concat(match[0]).substr(1, match[0].length - 2);
        return this.formData[field] ? this.options.unit.replace(match[0], this.formData[field]) : "";
      }
      return this.customUnit || this.options.unit;
    },
    // 填报占位符
    placeholder: function placeholder() {
      return this.options.placeholder || "\u8BF7\u8F93\u5165".concat(this.options.label);
    },
    // 是否只读
    readonly: function readonly() {
      return this.options.readonly;
    },
    // 依赖
    depends: function depends() {
      return this.options.depends;
    },
    // 计算器
    calculator: function calculator() {
      return this.options.calculator;
    },
    // 标题帮助
    help: function help() {
      return this.options.help;
    },
    // 是否隐藏组件
    hide: function hide() {
      return !!this.options.hide;
    },
    // 表单数据
    formData: function formData() {
      return this.options.formData;
    },
    // 默认值
    "default": function _default() {
      return this.options["default"];
    },
    // 字典
    dict: function dict() {
      return this.options.dict;
    },
    share: function share() {
      return this.options.share;
    }
  },
  mounted: function mounted() {
    if (this.depends) {
      this.updateVisibility();
    }
    if (this.formData && this.field) {
      // 如果formData有field对应的值则对组件进行初始化
      if (this.field in this.formData) {
        this.setValue(this.formData[this.field]);
      } else if (this["default"]) {
        var defaultValue = this.genPlaceholderValue(this["default"]);
        this.setValue(defaultValue);
        this.$set(this.formData, this.field, defaultValue);
      } else {
        // 否则赋空值
        this.$set(this.formData, this.field, undefined);
      }
    }
    // 监听整个表单字段值变化事件
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.formChangeHandler);
    // 派发已完成初始化的事件
    this.bus.$emit(this.$events.form.FIELD_INITIALIZED, {
      field: this.field,
      fieldRef: this
    });
    // 处理共享数据
    if (this.share) {
      this.readShareData();
      this.writeShareData();
    }
  },
  beforeDestroy: function beforeDestroy() {
    // 兼容普通使用组件
    if (this.formData) {
      // delete this.formData[this.field];
      // 去除formData字段并派发更新
      this._beforeDestroy();
    }
    // 删除共享数据
    if (this.share) {
      this.clearShareData();
    }
  },
  methods: {
    _beforeDestroy: function _beforeDestroy() {
      var value = null;
      this.formData[this.field] = value;
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: value
      });
    },
    //更新表单值
    updateFormData: function updateFormData() {
      var value = this.getValue();
      this.formData[this.field] = value;
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: value
      });
      // 处理共享数据
      if (this.share) {
        this.writeShareData();
      }
    },
    //
    formChangeHandler: function formChangeHandler(payload) {
      var field = payload.field,
        data = payload.data;
      // 处理deponds逻辑
      if (this.depends && this.fieldInDepands(field, this.depends)) {
        this.updateVisibility();
      }
      if (this.calculator) {
        this.calcValue(field, data);
      }
      this._formChangeHandler(payload);
    },
    _formChangeHandler: function _formChangeHandler() {
      // 子类按需实现其他对表单数据变化的响应，比如SelectField中对数据进行过滤
    },
    //TODO: 待重构
    fieldInDepands: function fieldInDepands(field, depends) {
      var res = false;
      for (var i = 0; i < depends.length; i++) {
        if (Array.isArray(depends[i])) {
          //判断是否为多维数组
          res = this.fieldInDepands(field, depends[i]);
          if (res) return true;
        } else {
          if (depends[i] === field) return true;
        }
      }
      return res;
    },
    // 自动显示或隐藏
    updateVisibility: function updateVisibility() {
      var comparator = ComparatorFactory.createComparator(this.depends, this.formData, this.parentFormData);
      this.visible = comparator.compare();
      this.$set(this.options, "visible", this.visible);
    },
    // 自动计算
    calcValue: function calcValue(field, fieldData) {
      // 处理自动计算的逻辑
      var calc = CalculatorFactory.createCalculator(this.calculator, this.formData, fieldData);
      if (!calc) return;
      var fields = calc.getFields();
      if (!fields) return;
      // 判断field是否在计算器表达式内
      if (fields.indexOf(field) >= 0) {
        this.setValue(calc.calc(), false);
      }
    },
    // 获取值
    getValue: function getValue() {
      // 不给formData赋undefined，向后端发请求时会被删除
      return this.value === undefined ? null : this.value;
    },
    // 设置值
    setValue: function setValue(value) {
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      // null会被认为是有效值，在form表单中造成显示困扰，比如没有值也不显示占位符
      this.value = value === null ? undefined : value;
      if (!silently) this.updateFormData();
    },
    // 设置单位
    setUnit: function setUnit(unit) {
      this.customUnit = unit;
    },
    // 重置
    reset: function reset() {
      this.value = undefined;
    },
    // 增加获取最外层GTForm的方法
    getRootFormData: function getRootFormData() {
      var formData = {};
      var parent = this.$parent;
      var parentName = parent.$options.name;
      while (parentName !== "App") {
        if (parentName === "GTForm") {
          formData = parent["formData"];
        }
        parent = parent.$parent;
        parentName = parent.$options.name;
      }
      return formData;
    },
    // 生成默认值
    genPlaceholderValue: function genPlaceholderValue(placeholder) {
      var value = placeholder;
      var VALUE_PLACEHOLDER = {
        DATE_NOW: "now",
        USER_CONTACT: "contact",
        USER_NICKNAME: "nickname",
        USER_COMPANY: "company",
        USER_PNAME: "pname",
        USER_PCODE: "pcode",
        USER_CNAME: "cname",
        USER_CCODE: "ccode",
        USER_FNAME: "fname",
        USER_FCODE: "fcode"
      };
      var userInfo = JSON.parse(localStorage.getItem("userInfo"));
      var VALUE_PLACEHOLDER_REGEXP = /\{.+?\}/g;
      if (typeof placeholder === "undefined" || placeholder === null) return;
      var items = "".concat(placeholder).match(VALUE_PLACEHOLDER_REGEXP);
      if (items === null) return placeholder;
      var key = items[0].substr(1, items[0].length - 2).replace("user.", "");
      switch (key) {
        case VALUE_PLACEHOLDER.DATE_NOW:
          value = new Date().getTime();
          break;
        case VALUE_PLACEHOLDER.USER_CONTACT:
          value = userInfo["phone"];
          break;
        case VALUE_PLACEHOLDER.USER_NICKNAME:
        case VALUE_PLACEHOLDER.USER_COMPANY:
        case VALUE_PLACEHOLDER.USER_PNAME:
        case VALUE_PLACEHOLDER.USER_PCODE:
        case VALUE_PLACEHOLDER.USER_CNAME:
        case VALUE_PLACEHOLDER.USER_CCODE:
        case VALUE_PLACEHOLDER.USER_FNAME:
        case VALUE_PLACEHOLDER.USER_FCODE:
          value = [null, ""].includes(userInfo[key]) ? undefined : userInfo[key];
          break;
      }
      return value;
    },
    writeShareData: function writeShareData() {
      if (!this.share) return;
      var share = new Share(this.share);
      if (share) {
        share.write(this.getValue());
      }
    },
    readShareData: function readShareData() {
      if (!this.share) return;
      var share = new Share(this.share);
      if (share) {
        share.read(this.shareDataPool);
      }
    },
    clearShareData: function clearShareData() {
      if (!this.share) return;
      var share = new Share(this.share);
      if (share) {
        share.clear();
      }
    }
  }
};

//
var script$q = {
  name: "AdminField",
  mixins: [importBaseField],
  computed: {
    placeholder: function placeholder() {
      return "\u8BF7\u9009\u62E9".concat(this.field.label);
    }
  },
  data: function data() {
    return {
      value: undefined
    };
  },
  methods: {
    changeHandler: function changeHandler() {},
    getValue: function getValue(key) {
      console.log("get value of ", key);
      return "admin-value";
    }
  }
};

/* script */
var __vue_script__$q = script$q;

/* template */
var __vue_render__$q = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-admin-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.name
    }
  }, [_c("a-cascader", {
    attrs: {
      placeholder: _vm.placeholder,
      "allow-clear": ""
    },
    on: {
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$q = [];
__vue_render__$q._withStripped = true;

/* style */
var __vue_inject_styles__$q = undefined;
/* scoped */
var __vue_scope_id__$q = "data-v-14a5d30f";
/* module identifier */
var __vue_module_identifier__$q = undefined;
/* functional template */
var __vue_is_functional_template__$q = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$q = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$q,
  staticRenderFns: __vue_staticRenderFns__$q
}, __vue_inject_styles__$q, __vue_script__$q, __vue_scope_id__$q, __vue_is_functional_template__$q, __vue_module_identifier__$q, false, undefined, undefined, undefined);

var script$p = {
  name: "SelectField",
  mixins: [importBaseField],
  data: function data() {
    return {
      value: undefined,
      items: [],
      itemMap: {}
    };
  },
  computed: {
    placeholder: function placeholder() {
      return "\u8BF7\u9009\u62E9".concat(this.label);
    }
  },
  mounted: function mounted() {
    this.init();
  },
  methods: {
    changeHandler: function changeHandler() {
      this.updateFormData();
    },
    updateFormData: function updateFormData() {
      var _this = this;
      this.formData[this.field] = this.getValue();
      var data = [];
      if (Array.isArray(this.value)) {
        data = this.value.map(function (item) {
          var _this$itemsMap$item;
          return ((_this$itemsMap$item = _this.itemsMap[item]) === null || _this$itemsMap$item === void 0 ? void 0 : _this$itemsMap$item.data) || _this.itemsMap[item];
        });
      }
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: this.value,
        data: data
      });
    },
    init: function init() {
      var _this$options$dict = this.options.dict,
        items = _this$options$dict.items,
        type = _this$options$dict.type;
      if (type == "enum") {
        this.items = items.map(function (item) {
          return {
            label: item,
            value: item
          };
        });
      }
      if (type == "inline") {
        this.items = items;
      }
      this.itemsMap = this.toMapItems(this.items);
    },
    toMapItems: function toMapItems(items) {
      var itemsMap = this.$newUtils.array.toMap(items, "value");
      if (Array.isArray(items) && items.length > 0) {
        for (var i = 0; i < items.length; i++) {
          var children = items[i].children;
          if (children) {
            itemsMap = _objectSpread2(_objectSpread2({}, itemsMap), this.toMapItems(children));
          }
        }
      }
      return itemsMap;
    },
    // 获取值
    getValue: function getValue() {
      if (!this.value || this.value.length == 0) {
        return null;
      }
      return this.value;
    }
  }
};

/* script */
var __vue_script__$p = script$p;

/* template */
var __vue_render__$p = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-select-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-cascader", {
    attrs: {
      options: _vm.items,
      placeholder: _vm.placeholder,
      "allow-clear": "",
      disabled: _vm.readonly
    },
    on: {
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$p = [];
__vue_render__$p._withStripped = true;

/* style */
var __vue_inject_styles__$p = undefined;
/* scoped */
var __vue_scope_id__$p = undefined;
/* module identifier */
var __vue_module_identifier__$p = undefined;
/* functional template */
var __vue_is_functional_template__$p = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$p = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$p,
  staticRenderFns: __vue_staticRenderFns__$p
}, __vue_inject_styles__$p, __vue_script__$p, __vue_scope_id__$p, __vue_is_functional_template__$p, __vue_module_identifier__$p, false, undefined, undefined, undefined);

var script$o = {
  name: 'CheckboxField',
  mixins: [importBaseField],
  data: function data() {
    return {
      value: undefined,
      items: [],
      itemsMap: {}
    };
  },
  computed: {},
  mounted: function mounted() {
    var _this = this;
    return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
      return _regeneratorRuntime().wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return _this.init();
          case 2:
          case "end":
            return _context.stop();
        }
      }, _callee);
    }))();
  },
  methods: {
    init: function init() {
      var _this2 = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return _this2.$newUtils.dict.parse(_this2.dict);
            case 2:
              _this2.items = _context2.sent;
              if (_this2.items) {
                _this2.itemsMap = _this2.$newUtils.array.toMap(_this2.items, 'value');
              }
            case 4:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }))();
    },
    changeHandler: function changeHandler() {
      this.updateFormData();
    },
    updateFormData: function updateFormData() {
      var _this3 = this;
      this.formData[this.field] = this.value;
      var data = this.value.map(function (item) {
        return _this3.itemsMap[item].data;
      });
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: this.value,
        data: data
      });
    },
    // 设置值
    getValue: function getValue() {
      if (!this.value || this.value.length == 0) {
        return null;
      }
      return this.value;
    }
  }
};

/* script */
var __vue_script__$o = script$o;

/* template */
var __vue_render__$o = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-checkbox-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-checkbox-group", {
    attrs: {
      placeholder: _vm.placeholder,
      "allow-clear": "",
      disabled: _vm.readonly
    },
    on: {
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  }, _vm._l(_vm.items, function (item, index) {
    return _c("a-checkbox", {
      key: index,
      attrs: {
        value: item.value
      }
    }, [_vm._v("\n        " + _vm._s(item.label) + "\n      ")]);
  }), 1)], 1)], 1);
};
var __vue_staticRenderFns__$o = [];
__vue_render__$o._withStripped = true;

/* style */
var __vue_inject_styles__$o = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-3fd4597c_0", {
    source: ".gt-checkbox-field[data-v-3fd4597c] .ant-checkbox-wrapper {\n  margin-right: 7px;\n  margin-bottom: 5px;\n}\n.gt-checkbox-field[data-v-3fd4597c] .ant-checkbox-wrapper + .ant-checkbox-wrapper {\n  margin-left: 0;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,iBAAiB;EACjB,kBAAkB;AACpB;AACA;EACE,cAAc;AAChB",
      "file": "index.vue",
      "sourcesContent": [".gt-checkbox-field /deep/ .ant-checkbox-wrapper {\n  margin-right: 7px;\n  margin-bottom: 5px;\n}\n.gt-checkbox-field /deep/ .ant-checkbox-wrapper + .ant-checkbox-wrapper {\n  margin-left: 0;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$o = "data-v-3fd4597c";
/* module identifier */
var __vue_module_identifier__$o = undefined;
/* functional template */
var __vue_is_functional_template__$o = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$o = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$o,
  staticRenderFns: __vue_staticRenderFns__$o
}, __vue_inject_styles__$o, __vue_script__$o, __vue_scope_id__$o, __vue_is_functional_template__$o, __vue_module_identifier__$o, false, createInjector, undefined, undefined);

//
var script$n = {
  name: "DateField",
  mixins: [importBaseField],
  computed: {
    placeholder: function placeholder() {
      return "\u8BF7\u9009\u62E9".concat(this.label);
    },
    showTime: function showTime() {
      return this.options.showTime;
    }
  },
  methods: {
    changeHandler: function changeHandler() {
      this.updateFormData();
    },
    getValue: function getValue() {
      return !this.value ? null : moment(this.value).valueOf();
    },
    setValue: function setValue(value) {
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      if (value) this.value = moment(value);
      if (!silently) this.updateFormData();
    }
  }
};

/* script */
var __vue_script__$n = script$n;

/* template */
var __vue_render__$n = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-date-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field
    }
  }, [_c("a-date-picker", {
    attrs: {
      placeholder: _vm.placeholder,
      showTime: _vm.showTime,
      disabled: _vm.readonly
    },
    on: {
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$n = [];
__vue_render__$n._withStripped = true;

/* style */
var __vue_inject_styles__$n = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-5067473e_0", {
    source: ".gt-date-field .ant-calendar-picker[data-v-5067473e] {\n  width: 100%;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,WAAW;AACb",
      "file": "index.vue",
      "sourcesContent": [".gt-date-field .ant-calendar-picker {\n  width: 100%;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$n = "data-v-5067473e";
/* module identifier */
var __vue_module_identifier__$n = undefined;
/* functional template */
var __vue_is_functional_template__$n = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$n = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$n,
  staticRenderFns: __vue_staticRenderFns__$n
}, __vue_inject_styles__$n, __vue_script__$n, __vue_scope_id__$n, __vue_is_functional_template__$n, __vue_module_identifier__$n, false, createInjector, undefined, undefined);

//
var script$m = {
  name: "DateRangeField",
  mixins: [importBaseField],
  data: function data() {
    return {
      value: null,
      isopen: false,
      //为定义的日历弹出的状态 false表示隐藏
      Year: null //用于接收年,
    };
  },

  computed: {
    placeholder: function placeholder() {
      return this.options.placeholder || ["开始日期", "结束日期"];
    },
    startField: function startField() {
      return this.options.startField.field;
    },
    endField: function endField() {
      return this.options.endField.field;
    },
    mode: function mode() {
      return this.options.mode;
    },
    showTime: function showTime() {
      return this.options.showTime;
    }
  },
  mounted: function mounted() {
    if (this.formData && this.startField && this.endField) {
      // 如果formData有field对应的值则对组件进行初始化
      if (this.startField in this.formData || this.endField in this.formData) {
        this.setValue(this.formData[this.startField], this.formData[this.endField]);
      }
      // 否则赋空值
      else {
        this.$set(this.formData, this.startField, undefined);
        this.$set(this.formData, this.endField, undefined);
      }
    }
    // 监听整个表单字段值变化事件
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.formChangeHandler);
  },
  methods: {
    setValue: function setValue(start, end) {
      if (start && end) {
        this.value = [moment(start), moment(end)];
      }
    },
    changeHandler: function changeHandler() {
      this.rangeUpdateFormData(this.startField, this.value[0]);
      this.rangeUpdateFormData(this.endField, this.value[1]);
    },
    rangeUpdateFormData: function rangeUpdateFormData(field, value) {
      value = !value ? undefined : moment(value).valueOf();
      this.$set(this.formData, field, value);
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: field,
        value: value
      });
    },
    handlePanelChange: function handlePanelChange(value) {
      this.value = value;
      this.rangeUpdateFormData(this.startField, this.value[0]);
      this.rangeUpdateFormData(this.endField, this.value[1]);
    }
  }
};

/* script */
var __vue_script__$m = script$m;

/* template */
var __vue_render__$m = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-date-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.startField
    }
  }, [_vm.mode == "year" ? [_c("a-range-picker", {
    staticStyle: {
      width: "100%"
    },
    attrs: {
      format: "YYYY年",
      placeholder: _vm.placeholder,
      mode: ["year", "year"],
      disabled: _vm.readonly
    },
    on: {
      change: _vm.changeHandler,
      panelChange: _vm.handlePanelChange
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })] : [_c("a-range-picker", {
    staticStyle: {
      width: "100%"
    },
    attrs: {
      showTime: _vm.showTime,
      placeholder: _vm.placeholder,
      disabled: _vm.readonly
    },
    on: {
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })]], 2)], 1);
};
var __vue_staticRenderFns__$m = [];
__vue_render__$m._withStripped = true;

/* style */
var __vue_inject_styles__$m = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-4c22b214_0", {
    source: ".gt-date-field .ant-calendar-picker[data-v-4c22b214] {\n  width: 100%;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,WAAW;AACb",
      "file": "index.vue",
      "sourcesContent": [".gt-date-field .ant-calendar-picker {\n  width: 100%;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$m = "data-v-4c22b214";
/* module identifier */
var __vue_module_identifier__$m = undefined;
/* functional template */
var __vue_is_functional_template__$m = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$m = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$m,
  staticRenderFns: __vue_staticRenderFns__$m
}, __vue_inject_styles__$m, __vue_script__$m, __vue_scope_id__$m, __vue_is_functional_template__$m, __vue_module_identifier__$m, false, createInjector, undefined, undefined);

//

// import FileAPI from '@/apis/file'

var UPLOAD_URL = "".concat(process.env.VUE_APP_AXIOS_BASE_URL, "/attachment/upload");
var DOWNLOAD_URL = "".concat(process.env.VUE_APP_AXIOS_BASE_URL, "/attachment/download");
var FILE_THUMB_URL = {
  WORD: "".concat(process.env.VUE_APP_URL, "images/file_thumb_word.png"),
  EXCEL: "".concat(process.env.VUE_APP_URL, "images/file_thumb_excel.png"),
  PDF: "".concat(process.env.VUE_APP_URL, "images/file_thumb_pdf.png"),
  DEFAULT: "".concat(process.env.VUE_APP_URL, "images/file_thumb_default.png")
};
var FILE_STATUS = {
  UPLOADING: "uploading",
  DONE: "done",
  ERROR: "error",
  REMOVED: "removed"
};
var script$l = {
  name: "FileField",
  mixins: [importBaseField],
  props: {
    config: {
      type: Object
    }
  },
  data: function data() {
    return {
      value: undefined,
      uploadUrl: UPLOAD_URL,
      headers: {
        Authorization: "Bearer ".concat(localStorage.getItem("access_token"))
      },
      fileList: []
    };
  },
  computed: {
    label: function label() {
      return this.options.label;
    },
    accept: function accept() {
      if (!this.options.suffixes) return;
      return this.options.suffixes.join(",");
    },
    max: function max() {
      return this.options.max || 1;
    },
    // 单位KB
    sizeLimit: function sizeLimit() {
      return !isNaN(this.options.sizeLimit) && this.options.sizeLimit ? this.options.sizeLimit : 0;
    }
  },
  methods: {
    changeHandler: function changeHandler(info) {
      // 必须加下面这一行代码，否则只能监听到uploading事件
      this.fileList = info.fileList;
      //
      var fileStatus = info.file.status;
      switch (fileStatus) {
        case FILE_STATUS.UPLOADING:
          // 避免uploading过程中提示文件为空
          this.formData[this.field] = "__temp_file_uid__";
          break;
        case FILE_STATUS.DONE:
          {
            // 上传成功要根据API返回内容判断是否真的成功
            var code = info.file.response.code;
            if (code === 2000) {
              // 添加文件uid
              info.file.uid = info.file.response.data[0];
              info.file.url = "".concat(DOWNLOAD_URL, "/").concat(info.file.uid);
              info.file.thumbUrl = this.getThumbnailUrl(info.file);
              this.fileList[this.fileList.length - 1] = info.file;
            } else {
              // 删除上传失败的文件
              // delete this.fileList[this.fileList.length - 1]
              this.fileList.pop();
              this.$message.error("文件上传失败，请重试");
            }
            this.updateFormData();
            break;
          }
        case FILE_STATUS.ERROR:
          // 删除上传失败的文件
          // delete this.fileList[this.fileList.length - 1]
          this.fileList.pop();
          this.updateFormData();
          this.$message.error("文件上传失败，请重试");
          break;
        case FILE_STATUS.REMOVED:
          this.updateFormData();
          // FileAPI.del(info.file.uid)
          break;
      }
    },
    getValue: function getValue() {
      if (!this.fileList || this.fileList.length === 0) {
        this.value = undefined;
        return this.value === undefined ? null : this.value;
      }
      var files = [];
      this.fileList.forEach(function (file) {
        files.push({
          name: file.name,
          uid: file.uid
        });
      });
      this.value = files;
      return this.value === undefined ? null : this.value;
    },
    setValue: function setValue(value) {
      var _this = this;
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var v = value || [];
      v = this.$newUtils.object.deepCloneJson(v);
      v.forEach(function (file) {
        file.url = "".concat(DOWNLOAD_URL, "/").concat(file.uid);
        file.thumbUrl = _this.getThumbnailUrl(file);
      });
      this.value = this.fileList = v;
      if (!silently) this.updateFormData();
    },
    beforeUploadHandler: function beforeUploadHandler(file) {
      if (!file || !file.name) return Promise.reject();
      var exceedSizeLimit = this.exceedSizeLimit(file.size);
      if (exceedSizeLimit) {
        this.$message.error("\u6587\u4EF6\u5927\u5C0F\u4E0D\u80FD\u8D85\u8FC7".concat(this.sizeLimit, "KB"));
        return Promise.reject();
      }
      if (!this.testFormat(file.name)) {
        this.$message.warning("\u53EA\u80FD\u4E0A\u4F20".concat(this.accept, "\u7684\u6587\u4EF6"));
        return Promise.reject();
      }
      if (!this.max) return true;
      if (this.fileList.length >= this.max) {
        this.$message.error("\u60A8\u6700\u591A\u53EA\u80FD\u4E0A\u4F20".concat(this.max, "\u4E2A").concat(this.label, "\uFF0C\u8BF7\u5220\u9664\u540E\u518D\u7EE7\u7EED\u4E0A\u4F20"));
        return Promise.reject();
      }
    },
    // 检测图片类型
    testFormat: function testFormat(name) {
      var suffixes = this.options.suffixes;
      if (!suffixes) return true;
      name = name.toLocaleLowerCase();
      return suffixes.some(function (suffix) {
        return name.endsWith(suffix);
      });
    },
    // size单位byte
    exceedSizeLimit: function exceedSizeLimit(size) {
      if (!this.sizeLimit) return false;
      var fileSize = size / 1024;
      if (fileSize > this.sizeLimit) return true;
    },
    getThumbnailUrl: function getThumbnailUrl(_ref) {
      var uid = _ref.uid,
        name = _ref.name;
      if (!uid || !name) return FILE_THUMB_URL.DEFAULT;
      var suffix = name.split(".").pop().toLowerCase();
      if (!suffix) return FILE_THUMB_URL.DEFAULT;
      // WORD
      if (["doc", "docx"].indexOf(suffix) >= 0) {
        return FILE_THUMB_URL.WORD;
      }
      // EXCEL
      if (["xls", "xlsx"].indexOf(suffix) >= 0) {
        return FILE_THUMB_URL.EXCEL;
      }
      // PDF
      if ("pdf" === suffix) {
        return FILE_THUMB_URL.PDF;
      }
      // Picture
      if (["png", "jpeg", "jpg"].indexOf(suffix) >= 0) {
        return "".concat(DOWNLOAD_URL, "/").concat(uid);
      }
      return FILE_THUMB_URL.DEFAULT;
    }
  }
};

/* script */
var __vue_script__$l = script$l;

/* template */
var __vue_render__$l = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-upload-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      unit: _vm.unit,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-upload", {
    "class": {
      "hide-button": _vm.fileList.length >= _vm.max
    },
    attrs: {
      name: "files",
      action: _vm.uploadUrl,
      headers: _vm.headers,
      accept: _vm.accept,
      fileList: _vm.fileList,
      beforeUpload: _vm.beforeUploadHandler,
      disabled: _vm.readonly,
      listType: "picture"
    },
    on: {
      change: _vm.changeHandler
    }
  }, [_c("a-button", {
    attrs: {
      disabled: _vm.readonly
    }
  }, [_c("a-icon", {
    attrs: {
      type: "upload"
    }
  }), _vm._v(" 上传文件\n      ")], 1), _vm._v(" "), _vm.accept ? _c("span", {
    staticClass: "accept-desc"
  }, [_vm._v("支持的格式：" + _vm._s(_vm.accept))]) : _vm._e()], 1)], 1)], 1);
};
var __vue_staticRenderFns__$l = [];
__vue_render__$l._withStripped = true;

/* style */
var __vue_inject_styles__$l = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-53f1f2ef_0", {
    source: "\n[data-v-53f1f2ef] .ant-upload-list-item-card-actions .anticon {\n  color: #e91e63;\n  padding-right: 8px;\n}\n.accept-desc[data-v-53f1f2ef] {\n  padding-left: 12px;\n  color: rgba(0, 0, 0, 0.4);\n}\n.hide-button[data-v-53f1f2ef] .ant-upload-select {\n  display: none;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": ";AAAC;EACC,cAAc;EACd,kBAAkB;AACpB;AACA;EACE,kBAAkB;EAClB,yBAAyB;AAC3B;AACA;EACE,aAAa;AACf",
      "file": "index.vue",
      "sourcesContent": [" /deep/ .ant-upload-list-item-card-actions .anticon {\n  color: #e91e63;\n  padding-right: 8px;\n}\n.accept-desc {\n  padding-left: 12px;\n  color: rgba(0, 0, 0, 0.4);\n}\n.hide-button /deep/ .ant-upload-select {\n  display: none;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$l = "data-v-53f1f2ef";
/* module identifier */
var __vue_module_identifier__$l = undefined;
/* functional template */
var __vue_is_functional_template__$l = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$l = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$l,
  staticRenderFns: __vue_staticRenderFns__$l
}, __vue_inject_styles__$l, __vue_script__$l, __vue_scope_id__$l, __vue_is_functional_template__$l, __vue_module_identifier__$l, false, createInjector, undefined, undefined);

//
var script$k = {
  name: "IntegerField",
  mixins: [importBaseField],
  methods: {
    changeHandler: function changeHandler() {
      this.value = this.value.replace(/[^\d]/g, "");
      this.value = isNaN(this.value) || this.value === "" ? undefined : this.value;
      this.updateFormData();
    },
    blurHandler: function blurHandler() {
      this.updateFormData();
    },
    getValue: function getValue() {
      return isNaN(this.value) || this.value === "" ? null : this.type === "text" ? this.value : Number(this.value);
    }
  }
};

/* script */
var __vue_script__$k = script$k;

/* template */
var __vue_render__$k = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-integer-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-input", {
    attrs: {
      placeholder: _vm.placeholder,
      "allow-clear": "",
      suffix: _vm.unit,
      disabled: _vm.readonly
    },
    on: {
      blur: _vm.blurHandler,
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$k = [];
__vue_render__$k._withStripped = true;

/* style */
var __vue_inject_styles__$k = undefined;
/* scoped */
var __vue_scope_id__$k = undefined;
/* module identifier */
var __vue_module_identifier__$k = undefined;
/* functional template */
var __vue_is_functional_template__$k = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$k = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$k,
  staticRenderFns: __vue_staticRenderFns__$k
}, __vue_inject_styles__$k, __vue_script__$k, __vue_scope_id__$k, __vue_is_functional_template__$k, __vue_module_identifier__$k, false, undefined, undefined, undefined);

var script$j = {
  name: "AceEditor",
  components: {
    Editor: Editor
  },
  props: {
    options: {
      type: Object,
      "default": function _default() {}
    },
    height: {
      type: [Number, String],
      "default": "200"
    },
    lang: {
      type: String,
      "default": "json"
    },
    theme: {
      type: String,
      "default": "chrome"
    },
    value: {
      type: String,
      "default": ""
    }
  },
  data: function data() {
    return {
      baseOptions: {
        // 设置代码编辑器的样式
        enableBasicAutocompletion: true,
        //启用基本自动完成
        enableSnippets: true,
        // 启用代码段
        enableLiveAutocompletion: true,
        //启用实时自动完成
        tabSize: 2,
        //标签大小
        fontSize: 14,
        //设置字号
        showPrintMargin: false //去除编辑器里的竖线
      }
    };
  },

  computed: {
    editorOptions: function editorOptions() {
      if (_typeof(this.options) === "object" && this.options !== null) {
        return Object.assign({}, this.baseOptions, this.options);
      } else {
        return this.baseOptions;
      }
    }
  },
  mounted: function mounted() {
    // this.$refs["editor"].editor.setShowFoldWidgets(false); //折叠属性
    // this.$refs["editor"].editor.setReadOnly(true); //设置只读模式
    // this.$refs["editor"].editor.setHighlightActiveLine(true); //设置行高亮显示
    // this.$refs["editor"].editor.setShowPrintMargin(true); //设置打印边距可见性
  },
  methods: {
    codeChange: function codeChange(val) {
      this.$emit("input", val);
    },
    setValue: function setValue(value) {
      if (_typeof(value) !== "object" && value !== undefined) {
        value = JSON.parse(value);
      }
      try {
        //格式化数据
        value = JSON.stringify(value, null, 2);
      } catch (error) {
        console.log("error :>> ", error);
      }
      this.$refs["editor"].editor.setValue(value);
      // this.$refs["editor"].editor.setReadOnly(isReadonly);
    },
    getValue: function getValue() {
      return this.$refs["editor"].editor.getValue();
    },
    editorInit: function editorInit(editor) {
      var _this = this;
      //   require("brace/theme/chrome");
      require("brace/theme/" + this.theme);
      require("brace/ext/language_tools");
      require("brace/ext/searchbox");
      require("brace/mode/yaml");
      require("brace/mode/json");
      require("brace/mode/less");
      require("brace/snippets/json");
      require("brace/mode/lua");
      require("brace/snippets/lua");
      require("brace/mode/javascript");
      require("brace/snippets/javascript");
      editor.resize();
      editor.commands.addCommand({
        name: "myCommand",
        bindKey: {
          win: "Ctrl-S",
          mac: "Command-S"
        },
        exec: function exec(editor) {
          _this.$emit("bindKey", "Ctrl-S");
          editor.findNext();
          editor.findPrevious();
        }
      });
    }
  }
};

/* script */
var __vue_script__$j = script$j;

/* template */
var __vue_render__$j = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("editor", {
    ref: "editor",
    attrs: {
      value: _vm.value,
      height: _vm.height,
      lang: _vm.lang,
      options: _vm.editorOptions,
      theme: _vm.theme
    },
    on: {
      init: _vm.editorInit,
      input: _vm.codeChange
    }
  });
};
var __vue_staticRenderFns__$j = [];
__vue_render__$j._withStripped = true;

/* style */
var __vue_inject_styles__$j = undefined;
/* scoped */
var __vue_scope_id__$j = "data-v-cdc66466";
/* module identifier */
var __vue_module_identifier__$j = undefined;
/* functional template */
var __vue_is_functional_template__$j = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$j = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$j,
  staticRenderFns: __vue_staticRenderFns__$j
}, __vue_inject_styles__$j, __vue_script__$j, __vue_scope_id__$j, __vue_is_functional_template__$j, __vue_module_identifier__$j, false, undefined, undefined, undefined);

// import { isJSON } from "@/utils/json";
var script$i = {
  name: "JsonField",
  data: function data() {
    return {
      visibleModel: false,
      value: ""
    };
  },
  computed: {
    placeholder: function placeholder() {
      return "\u8BF7\u8F93\u5165".concat(this.label);
    }
  },
  components: {
    AceEditor: __vue_component__$j
  },
  mixins: [importBaseField],
  methods: {
    handlerClick: function handlerClick() {
      var _this = this;
      this.visibleModel = true;
      this.$nextTick(function () {
        if (_this.value) {
          _this.$refs["ace-editor"].setValue(_this.value);
        }
      });
    },
    handleCancel: function handleCancel() {
      this.visibleModel = false;
    },
    formatJson: function formatJson() {
      var _this$handleJson = this.handleJson(),
        code = _this$handleJson.code,
        json = _this$handleJson.json;
      if (code) {
        this.$refs["ace-editor"].setValue(json);
      }
    },
    handleJson: function handleJson() {
      var code = true;
      if (this.dataJson) {
        var isJSON = this.$newUtils.json.isJSON;
        if (!isJSON(this.dataJson)) {
          this.$message.error("请填写正确格式的json数据(不包含单引号)");
          code = false;
        }
      } else {
        this.$message.error("json数据不能为空");
        code = false;
      }
      return {
        code: code,
        json: this.dataJson
      };
    },
    handleOk: function handleOk() {
      var _this2 = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var _this2$handleJson, code, json;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _this2$handleJson = _this2.handleJson(), code = _this2$handleJson.code, json = _this2$handleJson.json;
              if (code) {
                _this2.value = json;
                _this2.updateFormData();
                _this2.visibleModel = false;
              }
            case 2:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    }
  }
};

/* script */
var __vue_script__$i = script$i;

/* template */
var __vue_render__$i = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-admin-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-input-search", {
    attrs: {
      readOnly: "",
      placeholder: _vm.placeholder,
      "enter-button": "设置" + _vm.label
    },
    on: {
      search: _vm.handlerClick
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1), _vm._v(" "), _c("a-modal", {
    staticClass: "edit-modal-box",
    attrs: {
      title: "设置" + _vm.label,
      width: "100%",
      destroyOnClose: true,
      keyboard: false,
      maskClosable: false
    },
    model: {
      value: _vm.visibleModel,
      callback: function callback($$v) {
        _vm.visibleModel = $$v;
      },
      expression: "visibleModel"
    }
  }, [_c("ace-editor", {
    ref: "ace-editor",
    staticClass: "ace-editor",
    model: {
      value: _vm.dataJson,
      callback: function callback($$v) {
        _vm.dataJson = $$v;
      },
      expression: "dataJson"
    }
  }), _vm._v(" "), _c("div", {
    staticClass: "footer-box",
    attrs: {
      slot: "footer"
    },
    slot: "footer"
  }, [_c("div", [_c("a-button", {
    attrs: {
      type: "primary"
    },
    on: {
      click: _vm.formatJson
    }
  }, [_vm._v(" 格式化 ")])], 1), _vm._v(" "), _c("div", [_c("a-button", {
    on: {
      click: _vm.handleCancel
    }
  }, [_vm._v("取消")]), _vm._v(" "), _c("a-button", {
    attrs: {
      type: "primary"
    },
    on: {
      click: _vm.handleOk
    }
  }, [_vm._v(" 确定 ")])], 1)])], 1)], 1);
};
var __vue_staticRenderFns__$i = [];
__vue_render__$i._withStripped = true;

/* style */
var __vue_inject_styles__$i = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-7e9e1e34_0", {
    source: ".footer-box[data-v-7e9e1e34] {\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n}\n.ace-editor[data-v-7e9e1e34] {\n  width: 100%;\n  height: 100% !important;\n}\n.edit-modal-box[data-v-7e9e1e34] .ant-modal {\n  top: 0;\n  left: 0;\n  height: 100%;\n  width: 100% !important;\n}\n.edit-modal-box[data-v-7e9e1e34] .ant-modal .ant-modal-content {\n  left: 0;\n  top: 0;\n  height: 100%;\n  width: 100%;\n  border-radius: 0;\n}\n.edit-modal-box[data-v-7e9e1e34] .ant-modal .ant-modal-body {\n  /* title 和 footer 各占 55px */\n  height: calc(100% - 55px - 55px);\n  overflow: auto;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,aAAa;EACb,8BAA8B;EAC9B,mBAAmB;AACrB;AACA;EACE,WAAW;EACX,uBAAuB;AACzB;AACA;EACE,MAAM;EACN,OAAO;EACP,YAAY;EACZ,sBAAsB;AACxB;AACA;EACE,OAAO;EACP,MAAM;EACN,YAAY;EACZ,WAAW;EACX,gBAAgB;AAClB;AACA;EACE,2BAA2B;EAC3B,gCAAgC;EAChC,cAAc;AAChB",
      "file": "index.vue",
      "sourcesContent": [".footer-box {\n  display: flex;\n  justify-content: space-between;\n  align-items: center;\n}\n.ace-editor {\n  width: 100%;\n  height: 100% !important;\n}\n.edit-modal-box /deep/ .ant-modal {\n  top: 0;\n  left: 0;\n  height: 100%;\n  width: 100% !important;\n}\n.edit-modal-box /deep/ .ant-modal .ant-modal-content {\n  left: 0;\n  top: 0;\n  height: 100%;\n  width: 100%;\n  border-radius: 0;\n}\n.edit-modal-box /deep/ .ant-modal .ant-modal-body {\n  /* title 和 footer 各占 55px */\n  height: calc(100% - 55px - 55px);\n  overflow: auto;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$i = "data-v-7e9e1e34";
/* module identifier */
var __vue_module_identifier__$i = undefined;
/* functional template */
var __vue_is_functional_template__$i = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$i = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$i,
  staticRenderFns: __vue_staticRenderFns__$i
}, __vue_inject_styles__$i, __vue_script__$i, __vue_scope_id__$i, __vue_is_functional_template__$i, __vue_module_identifier__$i, false, createInjector, undefined, undefined);

/* eslint-disable no-redeclare */

var ee = 0.00669342162296594323;
var PI = 3.1415926535897932384626;
var a = 6378245.0;
var transformlat = function transformlat(lng, lat) {
  var lat = +lat;
  var lng = +lng;
  var ret = -100.0 + 2.0 * lng + 3.0 * lat + 0.2 * lat * lat + 0.1 * lng * lat + 0.2 * Math.sqrt(Math.abs(lng));
  ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
  ret += (20.0 * Math.sin(lat * PI) + 40.0 * Math.sin(lat / 3.0 * PI)) * 2.0 / 3.0;
  ret += (160.0 * Math.sin(lat / 12.0 * PI) + 320 * Math.sin(lat * PI / 30.0)) * 2.0 / 3.0;
  return ret;
};
var out_of_china = function out_of_china(lng, lat) {
  var lat = +lat;
  var lng = +lng;
  // 纬度3.86~53.55,经度73.66~135.05
  return !(lng > 73.66 && lng < 135.05 && lat > 3.86 && lat < 53.55);
};
var transformlng = function transformlng(lng, lat) {
  var lat = +lat;
  var lng = +lng;
  var ret = 300.0 + lng + 2.0 * lat + 0.1 * lng * lng + 0.1 * lng * lat + 0.1 * Math.sqrt(Math.abs(lng));
  ret += (20.0 * Math.sin(6.0 * lng * PI) + 20.0 * Math.sin(2.0 * lng * PI)) * 2.0 / 3.0;
  ret += (20.0 * Math.sin(lng * PI) + 40.0 * Math.sin(lng / 3.0 * PI)) * 2.0 / 3.0;
  ret += (150.0 * Math.sin(lng / 12.0 * PI) + 300.0 * Math.sin(lng / 30.0 * PI)) * 2.0 / 3.0;
  return ret;
};
var gcj02towgs84 = function gcj02towgs84(lng, lat) {
  var lat = +lat;
  var lng = +lng;
  if (out_of_china(lng, lat)) {
    return [lng, lat];
  } else {
    var dlat = transformlat(lng - 105.0, lat - 35.0);
    var dlng = transformlng(lng - 105.0, lat - 35.0);
    var radlat = lat / 180.0 * PI;
    var magic = Math.sin(radlat);
    magic = 1 - ee * magic * magic;
    var sqrtmagic = Math.sqrt(magic);
    dlat = dlat * 180.0 / (a * (1 - ee) / (magic * sqrtmagic) * PI);
    dlng = dlng * 180.0 / (a / sqrtmagic * Math.cos(radlat) * PI);
    var mglat = lat + dlat;
    var mglng = lng + dlng;
    return [(lng * 2 - mglng).toFixed(6), (lat * 2 - mglat).toFixed(6)];
  }
};
var wgs84togcj02 = function wgs84togcj02(lng, lat) {
  var lat = +lat;
  var lng = +lng;
  if (out_of_china(lng, lat)) {
    return [lng, lat];
  } else {
    var dlat = transformlat(lng - 105.0, lat - 35.0);
    var dlng = transformlng(lng - 105.0, lat - 35.0);
    var radlat = lat / 180.0 * PI;
    var magic = Math.sin(radlat);
    magic = 1 - ee * magic * magic;
    var sqrtmagic = Math.sqrt(magic);
    dlat = dlat * 180.0 / (a * (1 - ee) / (magic * sqrtmagic) * PI);
    dlng = dlng * 180.0 / (a / sqrtmagic * Math.cos(radlat) * PI);
    var mglat = lat + dlat;
    var mglng = lng + dlng;
    return [mglng, mglat];
  }
};
var COORDINATE_TOOLS = {
  gcj02towgs84: gcj02towgs84,
  wgs84togcj02: wgs84togcj02
};

//
var script$h = {
  name: 'Amap',
  data: function data() {
    return {
      map: null,
      satelliteLayer: null,
      roadNetLayer: null,
      lng: null,
      lat: null,
      textLng: null,
      textLat: null,
      geocoder: null,
      marker: null,
      infoWindow: null,
      value: '',
      placeholder: '请输入关键字进行搜索',
      text: null,
      fakeLng: null,
      fakeLat: null,
      addressInfo: null,
      address: null
    };
  },
  mounted: function mounted() {
    this.init();
  },
  methods: {
    init: function init() {
      var _this = this;
      window._AMapSecurityConfig = {
        securityJsCode: '09e0c185272ea2dd20ac271377311f37'
      };
      AMapLoader.load({
        key: '4d135348b50c30e2bda178cb8a315157',
        // 申请好的Web端开发者Key，首次调用 load 时必填
        version: '2.0',
        // 指定要加载的 JSAPI 的版本，缺省时默认为 1.4.15
        plugins: ['AMap.Geocoder', 'AMap.ToolBar'] // 需要使用的的插件列表，如比例尺'AMap.Scale'等
      }).then(function (AMap) {
        var toolBar = new AMap.ToolBar({
          position: {
            top: '20px',
            right: '20px'
          }
        });
        _this.geocoder = new AMap.Geocoder({});
        _this.marker = new AMap.Marker();
        _this.satelliteLayer = new AMap.TileLayer.Satellite();
        _this.roadNetLayer = new AMap.TileLayer.RoadNet();
        _this.map = new AMap.Map('container', {
          resizeEnable: true
        });
        _this.text = new AMap.Text({
          text: '',
          anchor: 'middle-left',
          // 设置文本标记锚点
          cursor: 'pointer',
          offset: [20, 0],
          position: [116.396923, 39.918203]
        });
        _this.text.setMap(_this.map);
        _this.map.addControl(toolBar);
        _this.map.on('click', function (e) {
          _this.marker.setPosition([e.lnglat.lng, e.lnglat.lat]);
          var lnglat = COORDINATE_TOOLS.gcj02towgs84(e.lnglat.lng, e.lnglat.lat);
          _this.lng = lnglat[0];
          _this.lat = lnglat[1];
          _this.geocoder.getAddress([e.lnglat.lng, e.lnglat.lat], function (status, result) {
            if (status === 'complete' && result.info === 'OK') {
              // result为对应的地理位置详细信息
              _this.address = result.regeocode.formattedAddress;
              _this.addressInfo = result.regeocode.addressComponent;
            }
          });
          _this.map.add(_this.marker);
        });
        _this.map.on('mousemove', function (e) {
          var lnglat = COORDINATE_TOOLS.gcj02towgs84(e.lnglat.lng, e.lnglat.lat);
          _this.textLng = lnglat[0];
          _this.textLat = lnglat[1];
          _this.text.setText(_this.textLng + ', ' + _this.textLat);
          _this.text.setPosition(e.lnglat);
        });
      })["catch"](function (e) {
        console.log('e :>> ', e);
      });
    },
    onBasemapChange: function onBasemapChange(e) {
      if (e) {
        this.map.add([this.satelliteLayer]);
        this.map.add([this.roadNetLayer]);
      } else {
        this.map.remove(this.satelliteLayer);
        this.map.remove(this.roadNetLayer);
      }
    },
    setLocal: function setLocal(e) {
      var _this2 = this;
      this.geocoder.getLocation(e, function (status, result) {
        if (status === 'complete' && result.geocodes.length) {
          var location = result.geocodes[0].location;
          var lnglat = [location.lng, location.lat];
          _this2.map.setZoomAndCenter(15, lnglat);
        } else {
          _this2.$message.error('根据地址查询位置失败');
          console.log('根据地址查询位置失败');
        }
      });
    },
    setLonLat: function setLonLat(a) {
      var _this3 = this;
      if (a.lat) {
        this.fakeLat = a.lat;
      }
      if (a.lon) {
        this.fakeLng = a.lon;
      }
      if (!this.fakeLng || !this.fakeLat) {
        return;
      }
      setTimeout(function () {
        _this3.map.add(_this3.marker);
        var lnglat = COORDINATE_TOOLS.wgs84togcj02(_this3.fakeLng, _this3.fakeLat);
        _this3.marker.setPosition(lnglat);
        _this3.map.setZoomAndCenter(15, lnglat);
      }, 2000);
    },
    btnClick: function btnClick() {
      this.setLocal(this.value);
    },
    confirmHandler: function confirmHandler() {
      this.$emit('mapSetLnglatData', {
        lng: this.lng,
        lat: this.lat,
        address: this.address,
        addressInfo: this.addressInfo
      });
    },
    cancelHandler: function cancelHandler() {
      this.$emit('close');
    }
  }
};

/* script */
var __vue_script__$h = script$h;

/* template */
var __vue_render__$h = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "wrap"
  }, [_c("div", {
    staticClass: "input-wrap"
  }, [_c("a-input", {
    staticClass: "input",
    attrs: {
      placeholder: _vm.placeholder
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  }), _vm._v(" "), _c("a-button", {
    attrs: {
      type: "primary"
    },
    on: {
      click: _vm.btnClick
    }
  }, [_vm._v("搜索")])], 1), _vm._v(" "), _c("div", {
    attrs: {
      id: "container"
    }
  }), _vm._v(" "), _c("div", {
    staticClass: "basemap-btn"
  }, [_vm._v("\n    影像\n    "), _c("a-switch", {
    on: {
      change: _vm.onBasemapChange
    }
  })], 1), _vm._v(" "), _c("div", {
    staticClass: "btn-wrap"
  }, [_c("a-button", {
    staticClass: "btn",
    attrs: {
      type: "primary"
    },
    on: {
      click: _vm.confirmHandler
    }
  }, [_vm._v("确定")]), _vm._v(" "), _c("a-button", {
    staticClass: "btn",
    on: {
      click: _vm.cancelHandler
    }
  }, [_vm._v("取消")])], 1)]);
};
var __vue_staticRenderFns__$h = [];
__vue_render__$h._withStripped = true;

/* style */
var __vue_inject_styles__$h = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-14984f99_0", {
    source: ".wrap[data-v-14984f99] {\n  width: 100%;\n  height: 100%;\n  box-sizing: border-box;\n  position: relative;\n}\n.wrap .input-wrap[data-v-14984f99] {\n  display: flex;\n  margin-bottom: 12px;\n}\n.wrap .input-wrap .input[data-v-14984f99] {\n  width: 400px;\n  margin-right: 12px;\n}\n.wrap #container[data-v-14984f99] {\n  width: 100%;\n  height: calc(100% - 102px);\n}\n.wrap .basemap-btn[data-v-14984f99] {\n  background-color: rgba(255, 255, 255, 0.767);\n  padding: 5px;\n  border-radius: 5px;\n  position: absolute;\n  bottom: 70px;\n  right: 20px;\n}\n.wrap .lnglat-box[data-v-14984f99] {\n  background-color: rgba(255, 255, 255, 0.637);\n  position: absolute;\n  top: 42px;\n  left: 0;\n  z-index: 99;\n}\n.btn-wrap[data-v-14984f99] {\n  padding: 12px 0;\n  box-sizing: border-box;\n}\n.btn-wrap .btn[data-v-14984f99] {\n  margin-right: 12px;\n}\n[data-v-14984f99] .amap-logo,[data-v-14984f99] .map-copyright {\n  display: none !important;\n  pointer-events: none;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,WAAW;EACX,YAAY;EACZ,sBAAsB;EACtB,kBAAkB;AACpB;AACA;EACE,aAAa;EACb,mBAAmB;AACrB;AACA;EACE,YAAY;EACZ,kBAAkB;AACpB;AACA;EACE,WAAW;EACX,0BAA0B;AAC5B;AACA;EACE,4CAA4C;EAC5C,YAAY;EACZ,kBAAkB;EAClB,kBAAkB;EAClB,YAAY;EACZ,WAAW;AACb;AACA;EACE,4CAA4C;EAC5C,kBAAkB;EAClB,SAAS;EACT,OAAO;EACP,WAAW;AACb;AACA;EACE,eAAe;EACf,sBAAsB;AACxB;AACA;EACE,kBAAkB;AACpB;AACC;EAEC,wBAAwB;EACxB,oBAAoB;AACtB",
      "file": "index.vue",
      "sourcesContent": [".wrap {\n  width: 100%;\n  height: 100%;\n  box-sizing: border-box;\n  position: relative;\n}\n.wrap .input-wrap {\n  display: flex;\n  margin-bottom: 12px;\n}\n.wrap .input-wrap .input {\n  width: 400px;\n  margin-right: 12px;\n}\n.wrap #container {\n  width: 100%;\n  height: calc(100% - 102px);\n}\n.wrap .basemap-btn {\n  background-color: rgba(255, 255, 255, 0.767);\n  padding: 5px;\n  border-radius: 5px;\n  position: absolute;\n  bottom: 70px;\n  right: 20px;\n}\n.wrap .lnglat-box {\n  background-color: rgba(255, 255, 255, 0.637);\n  position: absolute;\n  top: 42px;\n  left: 0;\n  z-index: 99;\n}\n.btn-wrap {\n  padding: 12px 0;\n  box-sizing: border-box;\n}\n.btn-wrap .btn {\n  margin-right: 12px;\n}\n /deep/ .amap-logo,\n /deep/ .map-copyright {\n  display: none !important;\n  pointer-events: none;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$h = "data-v-14984f99";
/* module identifier */
var __vue_module_identifier__$h = undefined;
/* functional template */
var __vue_is_functional_template__$h = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$h = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$h,
  staticRenderFns: __vue_staticRenderFns__$h
}, __vue_inject_styles__$h, __vue_script__$h, __vue_scope_id__$h, __vue_is_functional_template__$h, __vue_module_identifier__$h, false, createInjector, undefined, undefined);

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var NUMBER_REGEX$3 = /^(-?)(\d+)?(\.?)(\d+)?$/;
var script$g = {
  name: "LonLatField",
  mixins: [importBaseField],
  props: {
    options: {
      type: Object
    }
  },
  components: {
    Amap: __vue_component__$h
  },
  data: function data() {
    return {
      lon: null,
      lonValue: null,
      lat: null,
      latValue: null,
      visible: false
    };
  },
  computed: {
    precision: function precision() {
      return this.options.precision;
    },
    lonField: function lonField() {
      return this.options.lonField.field;
    },
    latField: function latField() {
      return this.options.latField.field;
    },
    pcodeField: function pcodeField() {
      return this.options.pcodeField.field;
    },
    ccodeField: function ccodeField() {
      return this.options.ccodeField.field;
    },
    fcodeField: function fcodeField() {
      return this.options.fcodeField.field;
    },
    addressField: function addressField() {
      return this.options.addressField.field;
    }
  },
  mounted: function mounted() {
    if (this.formData && this.lonField && this.latField) {
      // 如果formData有field对应的值则对组件进行初始化
      if (this.lonField in this.formData || this.latField in this.formData) {
        this.setValue(this.formData[this.lonField], "lon");
        this.setValue(this.formData[this.latField], "lat");
      }
      // 否则赋空值
      else {
        this.$set(this.formData, this.lonField, undefined);
        this.$set(this.formData, this.latField, undefined);
      }
    }
    // 监听整个表单字段值变化事件
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.formChangeHandler);
  },
  beforeDestroy: function beforeDestroy() {
    delete this.formData[this.lonField];
    delete this.formData[this.latField];
    delete this.formData[this.pcodeField];
    delete this.formData[this.ccodeField];
    delete this.formData[this.fcodeField];
    delete this.formData[this.addressField];
  },
  methods: {
    setValue: function setValue(value, param) {
      if (param == "lon") {
        this.lon = value;
        this.lonValue = value;
      }
      if (param == "lat") {
        this.lat = value;
        this.latValue = value;
      }
    },
    getValueByLonlat: function getValueByLonlat(value) {
      return isNaN(value) || value === "" ? undefined : Number(value);
    },
    changeHandler: function changeHandler(field) {
      // 替换非法字符
      this[field] = this[field].replace(/[^\-?\d.]/g, "").replace(/-\./g, "-");
      // 判断是否符合数值形式
      if (!NUMBER_REGEX$3.test(this[field])) {
        this[field] = this[field + "Value"];
      } else {
        this[field + "Value"] = this[field];
      }
      // 小数位数不设置则不限制
      if (isNaN(this.precision)) {
        this.updataFormDataByLonlat(field);
        return;
      }
      // 计算小数位数
      var digital = this[field].match(/\.(.*)/);
      if (!digital) {
        this.updataFormDataByLonlat(field);
        return;
      }
      var decimals = digital[1].length;
      if (decimals === 0) {
        this.updataFormDataByLonlat(field);
        return;
      }
      // 小数位数超出上限则截断
      if (decimals > this.precision) {
        this[field + "Value"] = this[field] = String(Number(this[field].substr(0, this[field].length - 1)));
      }
      this.updataFormDataByLonlat(field);
    },
    blurHandler: function blurHandler(field) {
      if (NUMBER_REGEX$3.test(this[field + "Value"])) {
        this[field + "Value"] = this[field] = String(Number(this[field]));
      }
    },
    onClose: function onClose() {
      this.visible = false;
    },
    mapSetLnglatData: function mapSetLnglatData(e) {
      this.lon = e.lng;
      this.lonValue = e.lng;
      this.lat = e.lat;
      this.latValue = e.lat;
      this.updataFormDataByLonlat("lon");
      this.updataFormDataByLonlat("lat");
      if (this.ccodeField || this.pcodeField || this.fcodeField || this.addressField) {
        this.updataFormDataByAddress(e);
      }
      this.onClose();
    },
    updataFormDataByAddress: function updataFormDataByAddress(e) {
      if (this.fcodeField) {
        this.$set(this.formData, this.fcodeField, e.addressInfo.adcode);
      }
      if (this.ccodeField) {
        this.$set(this.formData, this.ccodeField, e.addressInfo.adcode.slice(0, 4));
      }
      if (this.pcodeField) {
        this.$set(this.formData, this.pcodeField, e.addressInfo.adcode.slice(0, 2));
      }
      if (this.addressField) {
        this.$set(this.formData, this.addressField, e.address);
      }
    },
    updataFormDataByLonlat: function updataFormDataByLonlat(field) {
      var valueField;
      if (field == "lon") {
        valueField = this.lonField;
      }
      if (field == "lat") {
        valueField = this.latField;
      }
      this.$set(this.formData, valueField, this.getValueByLonlat(this[field + "Value"]));
    }
  }
};

/* script */
var __vue_script__$g = script$g;

/* template */
var __vue_render__$g = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-lonlat-field"
  }, [_c("div", {
    "class": ["label", _vm.options.required ? "label-required" : ""]
  }, [_vm._v("\n    " + _vm._s(_vm.options.label) + "\n  ")]), _vm._v(" "), _c("div", {
    staticClass: "lon_lat_box"
  }, [_c("a-form-model-item", {
    staticClass: "lon lon_lat_item",
    attrs: {
      prop: _vm.options.lonField.field,
      required: _vm.options.lonField.required
    }
  }, [_c("a-input", {
    attrs: {
      placeholder: "请输入经度",
      disabled: "",
      "allow-clear": ""
    },
    on: {
      change: function change($event) {
        return _vm.changeHandler("lon");
      },
      blur: function blur($event) {
        return _vm.blurHandler("lon");
      }
    },
    model: {
      value: _vm.lon,
      callback: function callback($$v) {
        _vm.lon = $$v;
      },
      expression: "lon"
    }
  })], 1), _vm._v(" "), _c("a-form-model-item", {
    staticClass: "lat lon_lat_item",
    attrs: {
      prop: _vm.options.latField.field,
      required: _vm.options.latField.required
    }
  }, [_c("a-input", {
    attrs: {
      placeholder: "请输入纬度",
      disabled: "",
      "allow-clear": ""
    },
    on: {
      change: function change($event) {
        return _vm.changeHandler("lat");
      },
      blur: function blur($event) {
        return _vm.blurHandler("lat");
      }
    },
    model: {
      value: _vm.lat,
      callback: function callback($$v) {
        _vm.lat = $$v;
      },
      expression: "lat"
    }
  })], 1), _vm._v(" "), _vm.options.mapLocationVisible ? _c("a-form-model-item", [_c("a-button", {
    attrs: {
      type: "primary",
      icon: "environment"
    },
    on: {
      click: function click($event) {
        _vm.visible = true;
      }
    }
  })], 1) : _vm._e()], 1), _vm._v(" "), _c("a-drawer", {
    attrs: {
      title: "在线地图",
      width: "calc(100% - 270px)",
      "body-style": {
        height: "calc(100% - 55px)"
      },
      visible: _vm.visible
    },
    on: {
      close: _vm.onClose
    }
  }, [_c("Amap", {
    on: {
      mapSetLnglatData: _vm.mapSetLnglatData,
      close: _vm.onClose
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$g = [];
__vue_render__$g._withStripped = true;

/* style */
var __vue_inject_styles__$g = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-6d765a76_0", {
    source: ".gt-lonlat-field[data-v-6d765a76] {\n  padding: 4px 0;\n}\n.gt-lonlat-field .label[data-v-6d765a76] {\n  display: block;\n  overflow: hidden;\n  line-height: 33px;\n  height: 33px;\n  white-space: nowrap;\n  color: rgba(0, 0, 0, 0.85);\n}\n.gt-lonlat-field .label[data-v-6d765a76]:after {\n  content: \":\";\n  position: relative;\n  top: -0.5px;\n  margin: 0 8px 0 2px;\n}\n.gt-lonlat-field .label-required[data-v-6d765a76]::before {\n  display: inline-block;\n  margin-right: 4px;\n  color: #f5222d;\n  font-size: 14px;\n  font-family: SimSun, sans-serif;\n  line-height: 1;\n  content: \"*\";\n}\n.gt-lonlat-field .lon_lat_box[data-v-6d765a76] {\n  display: flex;\n}\n.gt-lonlat-field .lon_lat_box .lon_lat_item[data-v-6d765a76] {\n  margin-right: 12px;\n  width: calc(50% - 12px);\n  display: flex;\n}\n.gt-lonlat-field .ant-form-item[data-v-6d765a76] {\n  margin-bottom: 0;\n}\n.gt-lonlat-field[data-v-6d765a76] .ant-form-item-control-wrapper {\n  display: inline-block;\n  flex: 1;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,cAAc;AAChB;AACA;EACE,cAAc;EACd,gBAAgB;EAChB,iBAAiB;EACjB,YAAY;EACZ,mBAAmB;EACnB,0BAA0B;AAC5B;AACA;EACE,YAAY;EACZ,kBAAkB;EAClB,WAAW;EACX,mBAAmB;AACrB;AACA;EACE,qBAAqB;EACrB,iBAAiB;EACjB,cAAc;EACd,eAAe;EACf,+BAA+B;EAC/B,cAAc;EACd,YAAY;AACd;AACA;EACE,aAAa;AACf;AACA;EACE,kBAAkB;EAClB,uBAAuB;EACvB,aAAa;AACf;AACA;EACE,gBAAgB;AAClB;AACA;EACE,qBAAqB;EACrB,OAAO;AACT",
      "file": "index.vue",
      "sourcesContent": [".gt-lonlat-field {\n  padding: 4px 0;\n}\n.gt-lonlat-field .label {\n  display: block;\n  overflow: hidden;\n  line-height: 33px;\n  height: 33px;\n  white-space: nowrap;\n  color: rgba(0, 0, 0, 0.85);\n}\n.gt-lonlat-field .label:after {\n  content: \":\";\n  position: relative;\n  top: -0.5px;\n  margin: 0 8px 0 2px;\n}\n.gt-lonlat-field .label-required::before {\n  display: inline-block;\n  margin-right: 4px;\n  color: #f5222d;\n  font-size: 14px;\n  font-family: SimSun, sans-serif;\n  line-height: 1;\n  content: \"*\";\n}\n.gt-lonlat-field .lon_lat_box {\n  display: flex;\n}\n.gt-lonlat-field .lon_lat_box .lon_lat_item {\n  margin-right: 12px;\n  width: calc(50% - 12px);\n  display: flex;\n}\n.gt-lonlat-field .ant-form-item {\n  margin-bottom: 0;\n}\n.gt-lonlat-field /deep/ .ant-form-item-control-wrapper {\n  display: inline-block;\n  flex: 1;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$g = "data-v-6d765a76";
/* module identifier */
var __vue_module_identifier__$g = undefined;
/* functional template */
var __vue_is_functional_template__$g = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$g = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$g,
  staticRenderFns: __vue_staticRenderFns__$g
}, __vue_inject_styles__$g, __vue_script__$g, __vue_scope_id__$g, __vue_is_functional_template__$g, __vue_module_identifier__$g, false, createInjector, undefined, undefined);

//
//
//
//
//
//
//
//
//
//
//

var NUMBER_REGEX$2 = /^(-?)(\d+)?(\.?)(\d+)?$/;
var script$f = {
  name: "InputNumber",
  data: function data() {
    return {
      inputValue: undefined
    };
  },
  computed: {
    precision: function precision() {
      return this.options.precision;
    },
    readonly: function readonly() {
      return this.options.readonly;
    },
    placeholder: function placeholder() {
      return this.options.placeholder;
    }
  },
  props: {
    options: {
      type: Object,
      "default": function _default() {
        return {};
      }
    },
    value: {
      type: [Number, String]
    }
  },
  watch: {
    value: {
      handler: function handler(newVal) {
        if (this.inputValue !== newVal) {
          this.inputValue = newVal;
        }
      },
      immediate: true
    }
  },
  methods: {
    changeHandler: function changeHandler() {
      // 替换非法字符
      this.inputValue = this.inputValue.replace(/[^\-?\d.]/g, "").replace(/-\./g, "-");
      // 判断是否符合数值形式
      if (!NUMBER_REGEX$2.test(this.inputValue)) {
        this.inputValue = this.value;
      } else {
        this.$emit("input", this.inputValue);
      }
      // 小数位数不设置则不限制
      if (isNaN(this.precision)) {
        this.$emit("input", this.inputValue);
        return;
      }
      // 计算小数位数
      var digital = this.inputValue.match(/\.(.*)/);
      if (!digital) {
        this.$emit("input", this.inputValue);
        return;
      }
      var decimals = digital[1].length;
      if (decimals === 0) {
        this.$emit("input", this.inputValue);
        return;
      }
      // 小数位数超出上限则截断
      if (decimals > this.precision) {
        this.inputValue = String(Number(this.inputValue.substr(0, this.inputValue.length - 1)));
        this.$emit("input", this.inputValue);
      }
    },
    blurHandler: function blurHandler() {
      if (this.value !== "" && NUMBER_REGEX$2.test(this.value)) {
        this.inputValue = String(Number(this.value));
      }
      this.$emit("input", this.inputValue);
    }
  }
};

/* script */
var __vue_script__$f = script$f;

/* template */
var __vue_render__$f = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("a-input", {
    staticClass: "number-input",
    attrs: {
      placeholder: _vm.placeholder,
      disabled: _vm.readonly
    },
    on: {
      blur: _vm.blurHandler,
      change: _vm.changeHandler
    },
    model: {
      value: _vm.inputValue,
      callback: function callback($$v) {
        _vm.inputValue = $$v;
      },
      expression: "inputValue"
    }
  });
};
var __vue_staticRenderFns__$f = [];
__vue_render__$f._withStripped = true;

/* style */
var __vue_inject_styles__$f = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-34646940_0", {
    source: ".number-input[data-v-34646940] {\n  width: 100%;\n}\n",
    map: {
      "version": 3,
      "sources": ["InputNumber.vue"],
      "names": [],
      "mappings": "AAAA;EACE,WAAW;AACb",
      "file": "InputNumber.vue",
      "sourcesContent": [".number-input {\n  width: 100%;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$f = "data-v-34646940";
/* module identifier */
var __vue_module_identifier__$f = undefined;
/* functional template */
var __vue_is_functional_template__$f = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$f = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$f,
  staticRenderFns: __vue_staticRenderFns__$f
}, __vue_inject_styles__$f, __vue_script__$f, __vue_scope_id__$f, __vue_is_functional_template__$f, __vue_module_identifier__$f, false, createInjector, undefined, undefined);

//
var script$e = {
  name: "LonLatInputField",
  mixins: [importBaseField],
  components: {
    InputNumber: __vue_component__$f
  },
  props: {
    options: {
      type: Object
    }
  },
  data: function data() {
    return {
      selectList: [{
        label: "度",
        value: "decimal"
      }, {
        label: "度分秒",
        value: "degree"
      }],
      type: "",
      numberValue: undefined,
      duNumberValue: undefined,
      fenNumberValue: undefined,
      miaoNumberValue: undefined
    };
  },
  watch: {
    type: {
      handler: function handler(newVal) {
        if (newVal == "decimal") {
          this.numberValue = this.value;
        } else {
          var _this$changeToDfm = this.changeToDfm(this.value),
            d = _this$changeToDfm.d,
            f = _this$changeToDfm.f,
            m = _this$changeToDfm.m;
          this.duNumberValue = d;
          this.fenNumberValue = f;
          this.miaoNumberValue = m;
        }
      }
    }
  },
  created: function created() {
    this.type = this.options.selectType || "degree";
  },
  computed: {
    precision: function precision() {
      return this.options.precision || 6;
    }
  },
  methods: {
    degreeValueChange: function degreeValueChange(value, type) {
      value = isNaN(value) || value === "" ? 0 : Number(value);
      switch (type) {
        case "d":
          this.duNumberValue = value;
          break;
        case "f":
          this.fenNumberValue = value;
          break;
        case "m":
          this.miaoNumberValue = value;
          break;
      }
      this.changeToDu();
    },
    // 转化为度分秒
    changeToDfm: function changeToDfm(num) {
      if (!num) return {};
      num = num.toString();
      var arr1 = num.split(".");
      var d = arr1[0];
      var tp = "0." + arr1[1];
      tp = String(tp * 60);
      var arr2 = tp.split(".");
      var f = arr2[0];
      tp = "0." + arr2[1];
      var m = tp * 60;
      return {
        d: isNaN(d) ? 0 : parseFloat(d),
        f: isNaN(f) ? 0 : parseFloat(f),
        m: isNaN(m) ? 0 : parseFloat(m.toFixed(2))
      };
    },
    // 转化为数字
    changeToDu: function changeToDu() {
      var d = this.duNumberValue || 0;
      var f = this.fenNumberValue || 0;
      var m = this.miaoNumberValue || 0;
      f = parseFloat(f) + parseFloat(m / 60);
      var value = parseFloat((parseFloat(f / 60) + parseFloat(d)).toFixed(this.precision));
      this.value = value === 0 ? undefined : value;
      this.updateFormData();
    },
    numberValueChange: function numberValueChange(value) {
      value = isNaN(value) || value === "" ? undefined : Number(value);
      this.numberValue = value;
      this.value = value;
      this.updateFormData();
    },
    getValue: function getValue() {
      return isNaN(this.value) || this.value === "" ? null : Number(this.value);
    },
    setValue: function setValue(value) {
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var result = value;
      if (typeof value === "number" && !isNaN(value)) {
        result = !isNaN(this.precision) ? parseFloat(value.toFixed(this.precision)) : value;
      }
      this.value = result;
      if (!silently) {
        this.updateFormData();
      } else {
        if (this.type === "decimal") {
          this.numberValue = this.value;
        } else {
          var _this$changeToDfm2 = this.changeToDfm(this.value),
            d = _this$changeToDfm2.d,
            f = _this$changeToDfm2.f,
            m = _this$changeToDfm2.m;
          this.duNumberValue = d;
          this.fenNumberValue = f;
          this.miaoNumberValue = m;
        }
      }
    }
  }
};

/* script */
var __vue_script__$e = script$e;

/* template */
var __vue_render__$e = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-field-max"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-input-group", {
    staticClass: "group-box",
    attrs: {
      compact: ""
    }
  }, [_c("a-select", {
    staticClass: "group-type-box",
    model: {
      value: _vm.type,
      callback: function callback($$v) {
        _vm.type = $$v;
      },
      expression: "type"
    }
  }, _vm._l(_vm.selectList, function (item) {
    return _c("a-select-option", {
      key: item["value"],
      attrs: {
        value: item["value"]
      }
    }, [_vm._v("\n          " + _vm._s(item["label"]) + "\n        ")]);
  }), 1), _vm._v(" "), _vm.type === "decimal" ? _c("div", {
    key: "decimal",
    staticClass: "group-concent group-concent-decimal",
    "class": {
      "group-concent-disabled": _vm.options["readonly"]
    }
  }, [_c("input-number", {
    attrs: {
      value: _vm.numberValue,
      options: {
        readonly: _vm.options["readonly"],
        placeholder: _vm.placeholder,
        precision: 6
      }
    },
    on: {
      input: _vm.numberValueChange
    }
  })], 1) : _c("div", {
    key: "degree",
    staticClass: "group-concent group-concent-degree",
    "class": {
      "group-concent-disabled": _vm.options["readonly"]
    }
  }, [_c("input-number", {
    attrs: {
      value: _vm.duNumberValue,
      options: {
        readonly: _vm.options["readonly"],
        placeholder: "度",
        precision: 0
      }
    },
    on: {
      input: function input($event) {
        return _vm.degreeValueChange($event, "d");
      }
    }
  }), _vm._v(" "), _c("span", [_vm._v("°")]), _vm._v(" "), _c("input-number", {
    attrs: {
      value: _vm.fenNumberValue,
      options: {
        readonly: _vm.options["readonly"],
        placeholder: "分",
        precision: 0
      }
    },
    on: {
      input: function input($event) {
        return _vm.degreeValueChange($event, "f");
      }
    }
  }), _vm._v(" "), _c("span", [_vm._v("′")]), _vm._v(" "), _c("input-number", {
    attrs: {
      value: _vm.miaoNumberValue,
      options: {
        readonly: _vm.options["readonly"],
        placeholder: "秒",
        precision: 2
      }
    },
    on: {
      input: function input($event) {
        return _vm.degreeValueChange($event, "m");
      }
    }
  }), _vm._v(" "), _c("span", [_vm._v("″")])], 1)], 1)], 1)], 1);
};
var __vue_staticRenderFns__$e = [];
__vue_render__$e._withStripped = true;

/* style */
var __vue_inject_styles__$e = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-5c0d6c68_0", {
    source: ".gt-field-max[data-v-5c0d6c68] {\n  padding: 4px 0;\n}\n.gt-field-max .group-box[data-v-5c0d6c68] {\n  display: flex;\n}\n.gt-field-max .group-box .group-type-box[data-v-5c0d6c68] {\n  width: 90px;\n  flex-shrink: 0;\n}\n.gt-field-max .group-box[data-v-5c0d6c68] .group-concent {\n  flex: 1;\n}\n.gt-field-max .group-box .group-concent-decimal .number-input[data-v-5c0d6c68] {\n  width: 100%;\n  border-top-left-radius: 0;\n  border-bottom-left-radius: 0;\n}\n.gt-field-max .group-box .group-concent-degree[data-v-5c0d6c68] {\n  display: flex;\n  border: 1px solid #d9d9d9;\n  padding: 0 10px;\n  align-items: center;\n}\n.gt-field-max .group-box .group-concent-degree span[data-v-5c0d6c68] {\n  margin: 0 10px;\n  font-weight: bold;\n}\n.gt-field-max .group-box .group-concent-degree .number-input[data-v-5c0d6c68] {\n  width: 100%;\n  border: none;\n  line-height: 24px;\n  height: 24px;\n  padding: 0 11px;\n  text-align: right;\n  border-bottom: 1px solid #d9d9d9;\n  border-radius: 0;\n}\n.gt-field-max .group-box .group-concent-degree .number-input[data-v-5c0d6c68]:focus {\n  border: none;\n  border-right-width: 0 !important;\n  outline: 0;\n  box-shadow: none;\n  border-bottom: 1px solid #d9d9d9;\n}\n.gt-field-max .group-box .group-concent-disabled[data-v-5c0d6c68] {\n  background: #f5f5f5;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,cAAc;AAChB;AACA;EACE,aAAa;AACf;AACA;EACE,WAAW;EACX,cAAc;AAChB;AACA;EACE,OAAO;AACT;AACA;EACE,WAAW;EACX,yBAAyB;EACzB,4BAA4B;AAC9B;AACA;EACE,aAAa;EACb,yBAAyB;EACzB,eAAe;EACf,mBAAmB;AACrB;AACA;EACE,cAAc;EACd,iBAAiB;AACnB;AACA;EACE,WAAW;EACX,YAAY;EACZ,iBAAiB;EACjB,YAAY;EACZ,eAAe;EACf,iBAAiB;EACjB,gCAAgC;EAChC,gBAAgB;AAClB;AACA;EACE,YAAY;EACZ,gCAAgC;EAChC,UAAU;EACV,gBAAgB;EAChB,gCAAgC;AAClC;AACA;EACE,mBAAmB;AACrB",
      "file": "index.vue",
      "sourcesContent": [".gt-field-max {\n  padding: 4px 0;\n}\n.gt-field-max .group-box {\n  display: flex;\n}\n.gt-field-max .group-box .group-type-box {\n  width: 90px;\n  flex-shrink: 0;\n}\n.gt-field-max .group-box /deep/ .group-concent {\n  flex: 1;\n}\n.gt-field-max .group-box .group-concent-decimal .number-input {\n  width: 100%;\n  border-top-left-radius: 0;\n  border-bottom-left-radius: 0;\n}\n.gt-field-max .group-box .group-concent-degree {\n  display: flex;\n  border: 1px solid #d9d9d9;\n  padding: 0 10px;\n  align-items: center;\n}\n.gt-field-max .group-box .group-concent-degree span {\n  margin: 0 10px;\n  font-weight: bold;\n}\n.gt-field-max .group-box .group-concent-degree .number-input {\n  width: 100%;\n  border: none;\n  line-height: 24px;\n  height: 24px;\n  padding: 0 11px;\n  text-align: right;\n  border-bottom: 1px solid #d9d9d9;\n  border-radius: 0;\n}\n.gt-field-max .group-box .group-concent-degree .number-input:focus {\n  border: none;\n  border-right-width: 0 !important;\n  outline: 0;\n  box-shadow: none;\n  border-bottom: 1px solid #d9d9d9;\n}\n.gt-field-max .group-box .group-concent-disabled {\n  background: #f5f5f5;\n}\n"]
    },
    media: undefined
  }), inject("data-v-5c0d6c68_1", {
    source: ".has-error .group-concent-degree {\n  border: 1px solid #f5222d !important;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,oCAAoC;AACtC",
      "file": "index.vue",
      "sourcesContent": [".has-error .group-concent-degree {\n  border: 1px solid #f5222d !important;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$e = "data-v-5c0d6c68";
/* module identifier */
var __vue_module_identifier__$e = undefined;
/* functional template */
var __vue_is_functional_template__$e = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$e = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$e,
  staticRenderFns: __vue_staticRenderFns__$e
}, __vue_inject_styles__$e, __vue_script__$e, __vue_scope_id__$e, __vue_is_functional_template__$e, __vue_module_identifier__$e, false, createInjector, undefined, undefined);

//
var NUMBER_REGEX$1 = /^(-?)(\d+)?(\.?)(\d+)?$/;
var script$d = {
  name: 'NumberField',
  mixins: [importBaseField],
  computed: {
    precision: function precision() {
      return this.options.precision;
    }
  },
  data: function data() {
    return {
      value: undefined,
      inputValue: undefined
    };
  },
  watch: {
    initValue: {
      handler: function handler() {
        this.value = this.inputValue = this.initValue;
      },
      immediate: true
    }
  },
  methods: {
    changeHandler: function changeHandler() {
      // 替换非法字符
      this.inputValue = this.inputValue.replace(/[^\-?\d.]/g, '').replace(/-\./g, '-');
      // 判断是否符合数值形式
      if (!NUMBER_REGEX$1.test(this.inputValue)) {
        this.inputValue = this.value;
      } else {
        this.value = this.inputValue;
      }
      // 小数位数不设置则不限制
      if (isNaN(this.precision)) {
        this.updateFormData();
        return;
      }
      // 计算小数位数
      var digital = this.inputValue.match(/\.(.*)/);
      if (!digital) {
        this.updateFormData();
        return;
      }
      var decimals = digital[1].length;
      if (decimals === 0) {
        this.updateFormData();
        return;
      }
      // 小数位数超出上限则截断
      if (decimals > this.precision) {
        this.value = this.inputValue = String(Number(this.inputValue.substr(0, this.inputValue.length - 1)));
      }
      this.updateFormData();
    },
    blurHandler: function blurHandler() {
      if (this.value !== '' && NUMBER_REGEX$1.test(this.value)) {
        this.value = this.inputValue = String(Number(this.value));
      }
      this.updateFormData();
    },
    getValue: function getValue() {
      return isNaN(this.value) || this.value === '' ? null : Number(this.value);
    },
    setValue: function setValue(value) {
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var result = value;
      if (typeof value === 'number' && !isNaN(value)) {
        result = !isNaN(this.precision) ? parseFloat(value.toFixed(this.precision)) : value;
      }
      this.inputValue = this.value = result;
      if (!silently) this.updateFormData();
    },
    // 重置
    reset: function reset() {
      this.inputValue = this.value = undefined;
      // this.updateFormData()
    }
  }
};

/* script */
var __vue_script__$d = script$d;

/* template */
var __vue_render__$d = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-number-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      help: _vm.help,
      required: _vm.required
    }
  }, [_c("a-input", {
    attrs: {
      placeholder: _vm.placeholder,
      "allow-clear": "",
      disabled: _vm.readonly,
      suffix: _vm.unit
    },
    on: {
      blur: _vm.blurHandler,
      change: _vm.changeHandler
    },
    model: {
      value: _vm.inputValue,
      callback: function callback($$v) {
        _vm.inputValue = $$v;
      },
      expression: "inputValue"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$d = [];
__vue_render__$d._withStripped = true;

/* style */
var __vue_inject_styles__$d = undefined;
/* scoped */
var __vue_scope_id__$d = undefined;
/* module identifier */
var __vue_module_identifier__$d = undefined;
/* functional template */
var __vue_is_functional_template__$d = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$d = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$d,
  staticRenderFns: __vue_staticRenderFns__$d
}, __vue_inject_styles__$d, __vue_script__$d, __vue_scope_id__$d, __vue_is_functional_template__$d, __vue_module_identifier__$d, false, undefined, undefined, undefined);

//
var NUMBER_REGEX = /^(-?)(\d+)?(\.?)(\d+)?$/;
var script$c = {
  name: 'NumberWithUnitField',
  mixins: [importBaseField],
  computed: {
    precision: function precision() {
      return this.options.precision;
    },
    unitField: function unitField() {
      return this.options.unitField.field;
    },
    field: function field() {
      return this.options.field.field;
    }
  },
  data: function data() {
    return {
      value: undefined,
      unitValue: undefined,
      items: [],
      inputValue: undefined
    };
  },
  watch: {
    initValue: {
      handler: function handler() {
        this.value = this.inputValue = this.initValue;
      },
      immediate: true
    }
  },
  mounted: function mounted() {
    this.init();
  },
  beforeDestroy: function beforeDestroy() {
    delete this.formData[this.unitField];
    delete this.formData[this.field];
  },
  methods: {
    init: function init() {
      if (this.options.dict.type == 'enum') {
        this.items = this.options.dict.items.map(function (item) {
          return {
            label: item,
            value: item
          };
        });
      }
      if (this.options.dict.type == 'inline') {
        this.items = this.options.dict.items;
      }
      if (this.unitField in this.formData) {
        this.unitValue = this.formData[this.unitField];
      } else {
        this.unitValue = this.items[0].value;
      }
      this.unitChange();
    },
    changeHandler: function changeHandler() {
      // 替换非法字符
      this.inputValue = this.inputValue.replace(/[^\-?\d.]/g, '').replace(/-\./g, '-');
      // 判断是否符合数值形式
      if (!NUMBER_REGEX.test(this.inputValue)) {
        this.inputValue = this.value;
      } else {
        this.value = this.inputValue;
      }
      // 小数位数不设置则不限制
      if (isNaN(this.precision)) {
        this.updateFormData();
        return;
      }
      // 计算小数位数
      var digital = this.inputValue.match(/\.(.*)/);
      if (!digital) {
        this.updateFormData();
        return;
      }
      var decimals = digital[1].length;
      if (decimals === 0) {
        this.updateFormData();
        return;
      }
      // 小数位数超出上限则截断
      if (decimals > this.precision) {
        this.value = this.inputValue = String(Number(this.inputValue.substr(0, this.inputValue.length - 1)));
      }
      this.updateFormData();
    },
    unitChange: function unitChange() {
      this.$set(this.formData, this.unitField, this.unitValue);
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.unitField,
        value: this.unitValue
      });
    },
    blurHandler: function blurHandler() {
      if (this.value !== '' && NUMBER_REGEX.test(this.value)) {
        this.value = this.inputValue = String(Number(this.value));
      }
      this.updateFormData();
    },
    getValue: function getValue() {
      return isNaN(this.value) || this.value === '' ? null : Number(this.value);
    },
    setValue: function setValue(value) {
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      console.log('set value', value);
      var result = value;
      if (typeof value === 'number' && !isNaN(value)) {
        result = !isNaN(this.precision) ? parseFloat(value.toFixed(this.precision)) : value;
      }
      this.inputValue = this.value = result;
      if (!silently) this.updateFormData();
    },
    // 重置
    reset: function reset() {
      this.inputValue = this.value = undefined;
    }
  }
};

/* script */
var __vue_script__$c = script$c;

/* template */
var __vue_render__$c = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-number-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      unit: _vm.unit,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-input", {
    attrs: {
      placeholder: _vm.placeholder,
      "allow-clear": "",
      disabled: _vm.readonly
    },
    on: {
      blur: _vm.blurHandler,
      change: _vm.changeHandler
    },
    model: {
      value: _vm.inputValue,
      callback: function callback($$v) {
        _vm.inputValue = $$v;
      },
      expression: "inputValue"
    }
  }, [_vm.items && _vm.unitValue ? _c("a-select", {
    staticStyle: {
      width: "80px"
    },
    attrs: {
      slot: "addonAfter",
      disabled: _vm.readonly
    },
    on: {
      change: _vm.unitChange
    },
    slot: "addonAfter",
    model: {
      value: _vm.unitValue,
      callback: function callback($$v) {
        _vm.unitValue = $$v;
      },
      expression: "unitValue"
    }
  }, [_vm._l(_vm.items, function (item, index) {
    return [_c("a-select-option", {
      key: index,
      attrs: {
        value: item.value
      }
    }, [_vm._v("\n            " + _vm._s(item.label) + "\n          ")])];
  })], 2) : _vm._e()], 1)], 1)], 1);
};
var __vue_staticRenderFns__$c = [];
__vue_render__$c._withStripped = true;

/* style */
var __vue_inject_styles__$c = undefined;
/* scoped */
var __vue_scope_id__$c = undefined;
/* module identifier */
var __vue_module_identifier__$c = undefined;
/* functional template */
var __vue_is_functional_template__$c = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$c = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$c,
  staticRenderFns: __vue_staticRenderFns__$c
}, __vue_inject_styles__$c, __vue_script__$c, __vue_scope_id__$c, __vue_is_functional_template__$c, __vue_module_identifier__$c, false, undefined, undefined, undefined);

//
var script$b = {
  name: "PasswordField",
  mixins: [importBaseField],
  computed: {
    maxLength: function maxLength() {
      return this.options.maxLength || "";
    }
  },
  methods: {
    changeHandler: function changeHandler() {
      this.updateFormData();
    }
  }
};

/* script */
var __vue_script__$b = script$b;

/* template */
var __vue_render__$b = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.hide,
      expression: "!hide"
    }],
    staticClass: "gt-text-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      help: _vm.help,
      required: _vm.required
    }
  }, [_c("a-input-password", {
    attrs: {
      placeholder: _vm.placeholder,
      disabled: _vm.readonly,
      maxLength: _vm.maxLength,
      allowClear: ""
    },
    on: {
      change: _vm.changeHandler,
      blur: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$b = [];
__vue_render__$b._withStripped = true;

/* style */
var __vue_inject_styles__$b = undefined;
/* scoped */
var __vue_scope_id__$b = undefined;
/* module identifier */
var __vue_module_identifier__$b = undefined;
/* functional template */
var __vue_is_functional_template__$b = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$b = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$b,
  staticRenderFns: __vue_staticRenderFns__$b
}, __vue_inject_styles__$b, __vue_script__$b, __vue_scope_id__$b, __vue_is_functional_template__$b, __vue_module_identifier__$b, false, undefined, undefined, undefined);

var VALID_MINUTES = 5;
var CONTENT_LENGTH_MAX = 1024 * 1024 * 1024;
var UIDUtil = {};
var script$a = {
  name: "PictureField",
  mixins: [importBaseField],
  data: function data() {
    return {
      value: undefined,
      uploadUrl: "",
      headers: {
        Authorization: "Bearer ".concat(localStorage.getItem("access_token"))
      },
      fileList: [],
      stsConfig: "",
      photo_url: "",
      visiblePreview: false,
      previewImg: ""
    };
  },
  created: function created() {
    this.photo_url = process.env.VUE_APP_PHOTO;
    UIDUtil = this.$newUtils.uid["default"];
  },
  computed: {
    label: function label() {
      return this.options.label;
    },
    accept: function accept() {
      var suffixes = this.options.suffixes || [".png", ".jpg", ".jpeg"];
      return suffixes.join(", ");
    },
    max: function max() {
      return this.options.max || 1;
    },
    // 单位KB
    sizeLimit: function sizeLimit() {
      return !isNaN(this.options.sizeLimit) && this.options.sizeLimit ? this.options.sizeLimit : 0;
    },
    // 服务器路径
    path: function path() {
      return this.options.path || "";
    }
  },
  methods: {
    genSignature: function genSignature(accessKeySecret) {
      var date = new Date();
      date.setMinutes(date.getMinutes() + VALID_MINUTES);
      var policyText = JSON.stringify({
        expiration: date.toISOString(),
        conditions: [["content-length-range", 0, CONTENT_LENGTH_MAX]]
      });
      var policy = Base64.stringify(Utf8.parse(policyText));
      var signature = Base64.stringify(HmacSHA1(policy, accessKeySecret));
      return {
        policy: policy,
        signature: signature
      };
    },
    genFileName: function genFileName(fileSuffix, dir) {
      if (!fileSuffix) return;
      var uploadDate = moment(new Date()).format("YYYYMMDD");
      var fileNameId = UIDUtil.genUID();
      var dirPath = dir ? "".concat(dir, "/") : "";
      return "".concat(dirPath).concat(this.path, "/").concat(uploadDate, "/").concat(fileNameId, ".").concat(fileSuffix);
    },
    getFileSuffix: function getFileSuffix(fileName) {
      var index = fileName.lastIndexOf(".");
      return index === -1 ? "notype" : fileName.slice(index + 1);
    },
    getData: function getData(file) {
      var url = file.url,
        name = file.name;
      var fileSuffix = this.getFileSuffix(url || name);
      var fileName = this.genFileName(fileSuffix);
      var _this$stsConfig = this.stsConfig,
        accessKeySecret = _this$stsConfig.accessKeySecret,
        accessKeyId = _this$stsConfig.accessKeyId,
        securityToken = _this$stsConfig.securityToken;
      //   securityToken;
      var _this$genSignature = this.genSignature(accessKeySecret),
        policy = _this$genSignature.policy,
        signature = _this$genSignature.signature;
      var formData = {
        key: fileName,
        name: name,
        policy: policy,
        signature: signature,
        OSSAccessKeyId: accessKeyId,
        success_action_status: "200",
        "x-oss-security-token": securityToken
      };
      return formData;
    },
    customRequest: function customRequest(_ref) {
      var _this = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var file, stsConfig, fileSuffix, accessKeySecret, accessKeyId, securityToken, endPoint, dir, fileName, _this$genSignature2, policy, signature, data;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              file = _ref.file;
              if (_this.beforeUploadHandler(file)) {
                _context.next = 3;
                break;
              }
              return _context.abrupt("return");
            case 3:
              _context.next = 5;
              return _this.$apis.file.getTempToken();
            case 5:
              stsConfig = _context.sent;
              _this.stsConfig = stsConfig;
              if (stsConfig) {
                _context.next = 10;
                break;
              }
              _this.$message.error("未获取oss地址配置，请刷新页面！");
              return _context.abrupt("return");
            case 10:
              fileSuffix = _this.getFileSuffix(file.url || file.name);
              accessKeySecret = stsConfig.accessKeySecret, accessKeyId = stsConfig.accessKeyId, securityToken = stsConfig.securityToken, endPoint = stsConfig.endPoint, dir = stsConfig.dir;
              fileName = _this.genFileName(fileSuffix, dir);
              _this$genSignature2 = _this.genSignature(accessKeySecret), policy = _this$genSignature2.policy, signature = _this$genSignature2.signature;
              data = new FormData(); // dir
              data.append("key", fileName);
              data.append("name", file.name);
              data.append("policy", policy);
              data.append("signature", signature);
              data.append("OSSAccessKeyId", accessKeyId);
              data.append("success_action_status", 200);
              data.append("x-oss-security-token", securityToken);
              data.append("file", file);
              axios({
                url: endPoint,
                method: "post",
                data: data,
                header: {
                  "Content-Type": "multipart/form-data"
                }
              }).then(function (res) {
                if (res.status == 200) {
                  var addImgObj = {
                    status: "done",
                    uid: UIDUtil.genUID(),
                    name: fileName,
                    url: "".concat(_this.photo_url, "/").concat(fileName)
                  };
                  _this.fileList.push(addImgObj);
                  _this.updateFormData();
                } else {
                  _this.$message.error("上传失败！");
                }
              }, function (error) {
                console.log("error :>> ", error);
                _this.$message.error("上传失败！");
              });
            case 24:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    getValue: function getValue() {
      var value = this.fileList.map(function (_ref2) {
        var name = _ref2.name;
        return name;
      });
      if (value.length > 0) {
        this.value = value;
      } else {
        this.value = undefined;
      }
      return this.value === undefined ? null : this.value;
    },
    setValue: function setValue(value) {
      var _this2 = this;
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      // console.log(this.photo_url);
      if (Array.isArray(value)) {
        this.fileList = value.map(function (url) {
          return {
            status: "done",
            uid: UIDUtil.genUID(),
            name: url,
            url: "".concat(_this2.photo_url, "/").concat(url)
          };
        });
      }
      // console.log("fileList :>> ", this.fileList);
      this.value = Array.isArray(value) ? value : undefined;
      if (!silently) this.updateFormData();
    },
    removeList: function removeList(_ref3) {
      var uid = _ref3.uid;
      this.fileList = this.fileList.filter(function (file) {
        return file.uid != uid;
      });
      this.updateFormData();
    },
    previewFile: function previewFile(_ref4) {
      var url = _ref4.url;
      this.previewImg = url;
      this.visiblePreview = true;
    },
    beforeUploadHandler: function beforeUploadHandler(file) {
      if (!file) return false;
      var name = file.name,
        size = file.size;
      if (!this.testFormat(name)) {
        this.$message.error("\u4E0A\u4F20\u56FE\u7247\u53EA\u652F\u6301".concat(this.accept));
        return false;
      }
      if (this.exceedSizeLimit(size)) {
        this.$message.error("\u6587\u4EF6\u5927\u5C0F\u4E0D\u80FD\u8D85\u8FC7".concat(this.sizeLimit, "KB"));
        return false;
      }
      if (this.max && this.fileList.length >= this.max) {
        this.$message.error("\u60A8\u6700\u591A\u53EA\u80FD\u4E0A\u4F20".concat(this.max, "\u4E2A").concat(this.label, "\uFF0C\u8BF7\u5220\u9664\u540E\u518D\u7EE7\u7EED\u4E0A\u4F20"));
        return false;
      }
      return true;
    },
    // 检测图片类型
    testFormat: function testFormat(name) {
      if (!name) return false;
      var type = name.substring(name.lastIndexOf("."), name.length);
      type = type.toLocaleLowerCase();
      var accepts = this.accept.split(",").map(function (accept) {
        return accept.trim();
      });
      return accepts.includes(type);
    },
    // size单位byte
    exceedSizeLimit: function exceedSizeLimit(size) {
      if (!this.sizeLimit) return false;
      var fileSize = size / 1024;
      if (fileSize > this.sizeLimit) return true;
    }
  }
};

/* script */
var __vue_script__$a = script$a;

/* template */
var __vue_render__$a = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-upload-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      unit: _vm.unit,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-upload", {
    attrs: {
      name: "file",
      accept: _vm.accept,
      "file-list": _vm.fileList,
      disabled: _vm.readonly,
      customRequest: _vm.customRequest,
      "list-type": "picture-card",
      remove: _vm.removeList
    },
    on: {
      preview: _vm.previewFile
    }
  }, [_vm.fileList.length < _vm.max ? _c("div", [_c("a-icon", {
    attrs: {
      type: "plus"
    }
  }), _vm._v(" "), _c("div", {
    staticClass: "ant-upload-text"
  }, [_vm._v("上传图片")])], 1) : _vm._e()]), _vm._v(" "), _c("a-modal", {
    attrs: {
      title: "查看图片",
      align: "center",
      footer: null,
      visible: _vm.visiblePreview
    },
    on: {
      cancel: function cancel($event) {
        _vm.visiblePreview = false;
      }
    }
  }, [_c("img", {
    attrs: {
      src: _vm.previewImg,
      alt: ""
    }
  })])], 1)], 1);
};
var __vue_staticRenderFns__$a = [];
__vue_render__$a._withStripped = true;

/* style */
var __vue_inject_styles__$a = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-2ae5a251_0", {
    source: "\n[data-v-2ae5a251] .ant-modal {\n  height: 80%;\n  top: 10%;\n}\n[data-v-2ae5a251] .ant-modal .ant-modal-content {\n  height: 100%;\n}\n[data-v-2ae5a251] .ant-modal .ant-modal-content .ant-modal-body {\n  overflow: hidden;\n  overflow-y: auto;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  height: calc(100% - 74px);\n}\n[data-v-2ae5a251] .ant-modal .ant-modal-content .ant-modal-body img {\n  width: 100%;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": ";AAAC;EACC,WAAW;EACX,QAAQ;AACV;AACC;EACC,YAAY;AACd;AACC;EACC,gBAAgB;EAChB,gBAAgB;EAChB,aAAa;EACb,mBAAmB;EACnB,uBAAuB;EACvB,yBAAyB;AAC3B;AACC;EACC,WAAW;AACb",
      "file": "index.vue",
      "sourcesContent": [" /deep/ .ant-modal {\n  height: 80%;\n  top: 10%;\n}\n /deep/ .ant-modal .ant-modal-content {\n  height: 100%;\n}\n /deep/ .ant-modal .ant-modal-content .ant-modal-body {\n  overflow: hidden;\n  overflow-y: auto;\n  display: flex;\n  align-items: center;\n  justify-content: center;\n  height: calc(100% - 74px);\n}\n /deep/ .ant-modal .ant-modal-content .ant-modal-body img {\n  width: 100%;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$a = "data-v-2ae5a251";
/* module identifier */
var __vue_module_identifier__$a = undefined;
/* functional template */
var __vue_is_functional_template__$a = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$a = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$a,
  staticRenderFns: __vue_staticRenderFns__$a
}, __vue_inject_styles__$a, __vue_script__$a, __vue_scope_id__$a, __vue_is_functional_template__$a, __vue_module_identifier__$a, false, createInjector, undefined, undefined);

var script$9 = {
  name: 'RadioField',
  mixins: [importBaseField],
  data: function data() {
    return {
      value: null,
      items: [],
      itemsMap: {}
    };
  },
  mounted: function mounted() {
    this.init();
  },
  methods: {
    init: function init() {
      var _this = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.next = 2;
              return _this.$newUtils.dict.parse(_this.dict);
            case 2:
              _this.items = _context.sent;
              if (_this.items) {
                _this.itemsMap = _this.$newUtils.array.toMap(_this.items, 'value');
              }
            case 4:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    changeHandler: function changeHandler() {
      this.updateFormData();
    },
    updateFormData: function updateFormData() {
      this.formData[this.field] = this.value;
      var data = this.itemsMap[this.value];
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: this.value,
        data: data
      });
    }
  }
};

/* script */
var __vue_script__$9 = script$9;

/* template */
var __vue_render__$9 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-radio-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("a-radio-group", {
    attrs: {
      disabled: _vm.readonly
    },
    on: {
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  }, [_vm._l(_vm.items, function (item, index) {
    return [_c("a-radio", {
      key: index,
      attrs: {
        value: item.value
      }
    }, [_vm._v(" " + _vm._s(item.label) + " ")])];
  })], 2)], 1)], 1);
};
var __vue_staticRenderFns__$9 = [];
__vue_render__$9._withStripped = true;

/* style */
var __vue_inject_styles__$9 = undefined;
/* scoped */
var __vue_scope_id__$9 = undefined;
/* module identifier */
var __vue_module_identifier__$9 = undefined;
/* functional template */
var __vue_is_functional_template__$9 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$9 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$9,
  staticRenderFns: __vue_staticRenderFns__$9
}, __vue_inject_styles__$9, __vue_script__$9, __vue_scope_id__$9, __vue_is_functional_template__$9, __vue_module_identifier__$9, false, undefined, undefined, undefined);

var script$8 = {
  name: "SelectField",
  mixins: [importBaseField],
  data: function data() {
    return {
      value: undefined,
      initValue: undefined,
      allItems: [],
      items: [],
      itemsMap: {},
      // 过滤字段
      filterField: undefined,
      // 关注的字段
      focusField: undefined,
      // 过滤器的值
      filterValue: undefined
    };
  },
  computed: {
    placeholder: function placeholder() {
      return "\u8BF7\u9009\u62E9".concat(this.label);
    },
    showSearch: function showSearch() {
      return this.options.showSearch || false;
    },
    mode: function mode() {
      return this.options.mode || "default";
    },
    filter: function filter() {
      return this.options.filter;
    },
    lazy: function lazy() {
      return this.options.lazy;
    },
    allowClear: function allowClear() {
      return !this.options.hideClear;
    }
  },
  mounted: function mounted() {
    this.getFilter();
    if (!this.lazy) {
      this.init();
    } else {
      this.filterValue = this.formData[this.focusField];
      this.lazyDictItems();
    }
  },
  methods: {
    getFilter: function getFilter() {
      if (!this.filter && !Array.isArray(this.filter) || this.filter.length < 3) return;
      var operator = this.filter[0];
      if (operator !== "=") return;
      this.filterField = this.filter[1];
      this.focusField = this.filter[2];
    },
    // 数据量大的时候懒加载
    lazyDictItems: function lazyDictItems() {
      var _this = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var dict, filter, items;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (_this.filterValue) {
                _context.next = 4;
                break;
              }
              _this.allItems = [];
              _context.next = 10;
              break;
            case 4:
              dict = _this.$newUtils.object.deepCloneObj(_this.dict); // dict["filter"] = ["=", this.filterField, this.filterValue];
              filter = ["=", _this.filterField, _this.filterValue];
              _context.next = 8;
              return _this.$newUtils.dict.parse(dict, filter);
            case 8:
              items = _context.sent;
              _this.allItems = items || [];
            case 10:
              if (_this.allItems.length != 0) {
                _this.itemsMap = _this.$newUtils.array.toMap(_this.allItems, "value");
              }
              _this.items = _this.allItems;
            case 12:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    init: function init() {
      var _this2 = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              // 避免显示value而不是label
              _this2.value = undefined;
              _context2.next = 3;
              return _this2.$newUtils.dict.parse(_this2.dict);
            case 3:
              _this2.allItems = _context2.sent;
              if (_this2.allItems) {
                _this2.itemsMap = _this2.$newUtils.array.toMap(_this2.allItems, "value");
              }
              // 如果定义了filter，且有过滤值，则进行过滤
              if (_this2.filterField && _this2.filterValue !== undefined) {
                _this2.items = _this2.allItems.filter(function (item) {
                  return item.data[_this2.filterField] === _this2.filterValue;
                });
              } else if (_this2.filterField) {
                // 如果定义了filter，没有过滤值，则置空
                _this2.items = [];
              } else {
                _this2.items = _this2.allItems;
              }
              // 如果数据进行了初始化，派发数据变更的消息
              _this2.value = _this2.initValue;
              if (_this2.value !== undefined && _this2.value !== null) {
                _this2.updateFormData();
              }
            case 8:
            case "end":
              return _context2.stop();
          }
        }, _callee2);
      }))();
    },
    changeHandler: function changeHandler() {
      this.updateFormData();
    },
    updateFormData: function updateFormData() {
      var _this3 = this;
      this.formData[this.field] = this.getValue();
      var data;
      if (this.value) {
        if (!Array.isArray(this.value)) {
          var item = this.itemsMap[this.value];
          data = (item === null || item === void 0 ? void 0 : item.data) || item;
        } else {
          data = this.value.map(function (item) {
            var _this3$itemsMap$item;
            return ((_this3$itemsMap$item = _this3.itemsMap[item]) === null || _this3$itemsMap$item === void 0 ? void 0 : _this3$itemsMap$item.data) || _this3.itemsMap[item];
          });
        }
      }
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: this.value,
        data: data
      });
    },
    _formChangeHandler: function _formChangeHandler(_ref) {
      var _this4 = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
        var field, value;
        return _regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              field = _ref.field, value = _ref.value;
              if (!(!_this4.filterField || _this4.focusField !== field)) {
                _context3.next = 3;
                break;
              }
              return _context3.abrupt("return");
            case 3:
              // 记录过滤器的值
              _this4.filterValue = value;
              if (!_this4.lazy) {
                _context3.next = 9;
                break;
              }
              _context3.next = 7;
              return _this4.lazyDictItems();
            case 7:
              _context3.next = 12;
              break;
            case 9:
              if (!(_this4.allItems.length === 0)) {
                _context3.next = 11;
                break;
              }
              return _context3.abrupt("return");
            case 11:
              // 对字典进行过滤
              _this4.items = _this4.allItems.filter(function (item) {
                return item.data[_this4.filterField] === value;
              });
            case 12:
              // 判断当前列表是否包含该值，不包含则赋值为空
              if (!_this4.items.some(function (item) {
                return item.value == _this4.value;
              })) {
                _this4.value = undefined;
              }
              _this4.updateFormData();
            case 14:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }))();
    },
    setValue: function setValue(value) {
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      this.value = this.initValue = value === null ? undefined : value;
      if (!silently) this.updateFormData();
    }
  }
};

/* script */
var __vue_script__$8 = script$8;

/* template */
var __vue_render__$8 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-select-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.required
    }
  }, [_c("div", {
    staticClass: "select-wrap"
  }, [_c("a-select", {
    attrs: {
      mode: _vm.mode,
      placeholder: _vm.placeholder,
      "allow-clear": _vm.allowClear,
      "show-search": _vm.showSearch,
      disabled: _vm.readonly,
      optionFilterProp: "label"
    },
    on: {
      change: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  }, _vm._l(_vm.items, function (item) {
    return _c("a-select-option", {
      key: item.value,
      attrs: {
        label: item.label,
        title: item.label
      }
    }, [_vm._v("\n          " + _vm._s(item.label) + "\n        ")]);
  }), 1), _vm._v(" "), _c("span", {
    staticClass: "select-suffix"
  }, [_vm._v(_vm._s(_vm.unit))])], 1)])], 1);
};
var __vue_staticRenderFns__$8 = [];
__vue_render__$8._withStripped = true;

/* style */
var __vue_inject_styles__$8 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-44bd923a_0", {
    source: ".gt-select-field .select-wrap[data-v-44bd923a] {\n  position: relative;\n}\n.gt-select-field .select-wrap .select-suffix[data-v-44bd923a] {\n  position: absolute;\n  right: 30px;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,kBAAkB;AACpB;AACA;EACE,kBAAkB;EAClB,WAAW;AACb",
      "file": "index.vue",
      "sourcesContent": [".gt-select-field .select-wrap {\n  position: relative;\n}\n.gt-select-field .select-wrap .select-suffix {\n  position: absolute;\n  right: 30px;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$8 = "data-v-44bd923a";
/* module identifier */
var __vue_module_identifier__$8 = undefined;
/* functional template */
var __vue_is_functional_template__$8 = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$8 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$8,
  staticRenderFns: __vue_staticRenderFns__$8
}, __vue_inject_styles__$8, __vue_script__$8, __vue_scope_id__$8, __vue_is_functional_template__$8, __vue_module_identifier__$8, false, createInjector, undefined, undefined);

//
//
//
//
//
//
//
//
//
//
//
//
//
//

var RECORD_OPERATORS = [{
  key: "edit",
  label: "编辑"
}, {
  key: "delete",
  label: "删除",
  confirm: true
}];
var READONLY_OPERATORS = [{
  key: "edit",
  label: "查看"
}];
var script$7 = {
  name: "SubFormTable",
  data: function data() {
    return {};
  },
  props: {
    fields: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    dicts: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    list: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    readonly: {
      type: Boolean
    },
    unableDelete: {
      type: Boolean
    }
  },
  computed: {
    recordOperators: function recordOperators() {
      return this.readonly ? READONLY_OPERATORS : RECORD_OPERATORS;
    }
  },
  mounted: function mounted() {
    console.log("this.fields :>> ", this.fields);
  },
  methods: {
    recordOperatorClickHandler: function recordOperatorClickHandler(_ref) {
      var key = _ref.key,
        record = _ref.record;
      this.$emit("operator", {
        key: key,
        record: record
      });
      // if (key == "delete") {
      //   this.$emit("delItem", record);
      // }
      // if (key == "edit") {
      //   this.$emit("editItem", record);
      // }
    },
    getTextWidth: function getTextWidth(text) {
      var canvas = document.createElement("canvas");
      var context = canvas.getContext("2d");
      context.font = "23px Arial";
      var metrics = context.measureText(text);
      return metrics.width;
    }
  }
};

/* script */
var __vue_script__$7 = script$7;

/* template */
var __vue_render__$7 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.fields.length != 0 ? _c("GTTable", {
    attrs: {
      fields: _vm.fields,
      data: _vm.list,
      recordOperators: _vm.recordOperators,
      total: "0",
      dicts: _vm.dicts,
      operatorWidth: 120,
      keyField: "_id"
    },
    on: {
      recordOperatorClick: _vm.recordOperatorClickHandler
    }
  }) : _vm._e();
};
var __vue_staticRenderFns__$7 = [];
__vue_render__$7._withStripped = true;

/* style */
var __vue_inject_styles__$7 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-3ed3b576_0", {
    source: "\n[data-v-3ed3b576] .ant-table-thead > tr > th,[data-v-3ed3b576] .ant-table-tbody > tr > td {\n  padding: 12px 8px;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": ";AAAC;EAEC,iBAAiB;AACnB",
      "file": "index.vue",
      "sourcesContent": [" /deep/ .ant-table-thead > tr > th,\n /deep/ .ant-table-tbody > tr > td {\n  padding: 12px 8px;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$7 = "data-v-3ed3b576";
/* module identifier */
var __vue_module_identifier__$7 = undefined;
/* functional template */
var __vue_is_functional_template__$7 = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$7 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$7,
  staticRenderFns: __vue_staticRenderFns__$7
}, __vue_inject_styles__$7, __vue_script__$7, __vue_scope_id__$7, __vue_is_functional_template__$7, __vue_module_identifier__$7, false, createInjector, undefined, undefined);

var script$6 = {
  name: "SubForm",
  mixins: [importBaseField],
  computed: {
    fields: function fields() {
      var formDef = this.subFormOptions.formDef;
      return formDef.table.tableFields || formDef.fields;
    },
    formValue: function formValue() {
      var formValue = {
        form: this.formUid,
        data: []
      };
      if (this.list.length != 0) {
        var value = _.cloneDeep(this.list);
        formValue["data"] = value.map(function (item) {
          return _.omit(item, ["uid"]);
        });
      }
      return formValue;
      // if (this.list.length == 0) {
      //   return undefined;
      // } else {
      //   let value = _.cloneDeep(this.list);
      //   return {
      //     form: this.formUid,
      //     data: value.map((item) => {
      //       return _.omit(item, ["uid"]);
      //     }),
      //   };
      // }
    },
    // 是否不可删除
    unableDelete: function unableDelete() {
      return !!this.options.unableDelete;
    },
    // 是否不可添加
    unableAdd: function unableAdd() {
      var _ref = this.options || {},
        size = _ref.size,
        unableAdd = _ref.unableAdd,
        max = _ref.max;
      if (unableAdd) {
        return false;
      } else {
        if (size) {
          return this.list.length < size;
        }
        if (max) {
          return this.list.length < max;
        }
        return true;
      }
    },
    formUid: function formUid() {
      return this.options.formUid;
    },
    field: function field() {
      return this.options.field;
    },
    uniqueKey: function uniqueKey() {
      return this.options.uniqueKey;
    },
    autoIndexField: function autoIndexField() {
      return this.options.autoIndexField;
    },
    autoIndexPrefix: function autoIndexPrefix() {
      return this.options.autoIndexPrefix || "";
    },
    autoIndexSuffix: function autoIndexSuffix() {
      return this.options.autoIndexSuffix || "";
    }
  },
  data: function data() {
    return {
      subFormOptions: {
        formDef: null,
        formUid: this.formUid,
        formRecordData: null,
        parentFormData: null
      },
      formDef: null,
      modalVisible: false,
      list: [],
      dicts: []
    };
  },
  mounted: function mounted() {
    this.init();
    if (this.readonly) {
      this.$set(this.subFormOptions, "readonly", true);
    }
    this.subFormOptions.parentFormData = this.formData;
  },
  methods: {
    init: function init() {
      var _this = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var res;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              if (_this.formData && _this.field) {
                if (_this.field in _this.formData && _this.formData[_this.field]) {
                  _this.setValue(_this.formData[_this.field]);
                }
              }
              _context.next = 3;
              return _this.$apis.formDesign.queryFormDesign(_this.formUid);
            case 3:
              res = _context.sent;
              _this.subFormOptions.formDef = res;
              _this.dicts = (res === null || res === void 0 ? void 0 : res.dicts) || [];
              _this.subFormOptions.formUid = _this.formUid;
            case 7:
            case "end":
              return _context.stop();
          }
        }, _callee);
      }))();
    },
    handleOk: function handleOk() {
      this.$refs.subForm.submit();
    },
    setAutoIndexField: function setAutoIndexField() {
      var _this2 = this;
      if (!this.autoIndexField) return;
      this.list = this.list.map(function (item, index) {
        if (_this2.autoIndexPrefix || _this2.autoIndexSuffix) {
          item[_this2.autoIndexField] = "".concat(_this2.autoIndexPrefix).concat(index + 1).concat(_this2.autoIndexSuffix);
        } else {
          item[_this2.autoIndexField] = index + 1;
        }
        return item;
      });
    },
    submitData: function submitData(e) {
      var _this3 = this;
      var data = _.cloneDeep(e);
      // 连续点击去重
      if (!data["uid"]) {
        var lastItem = _.last(this.list);
        if (lastItem && this.compareItem(data, lastItem)) {
          return;
        }
      }
      // 设置唯一值
      if (this.uniqueKey) {
        var uniqueItems = [data];
        if (data.uid) {
          uniqueItems.push.apply(uniqueItems, _toConsumableArray(this.list.filter(function (item) {
            return item.uid !== data.uid;
          })));
        } else {
          uniqueItems.push.apply(uniqueItems, _toConsumableArray(this.list));
        }
        var uniqueMap = uniqueItems.map(function (item) {
          return item[_this3.uniqueKey];
        });
        if (new Set(uniqueMap).size !== uniqueMap.length) {
          var fields = this.subFormOptions.formDef.fields;
          var fieldsFind = fields.find(function (item) {
            return item["name"] == _this3.uniqueKey;
          });
          this.$message.error("".concat(fieldsFind["label"], "\u4E0D\u80FD\u91CD\u590D\uFF01"));
          return;
        }
      }
      if (data.uid) {
        var index = this.list.findIndex(function (item) {
          return item.uid == data.uid;
        });
        this.$set(this.list, index, data);
      } else {
        data.uid = uid();
        this.list.push(data);
      }
      this.setAutoIndexField();
      this.updateFormData();
      this.modalVisible = false;
      this.editing = false;
      this.subFormOptions.formRecordData = null;
    },
    compareItem: function compareItem(value, other) {
      value = _.omit(value, ["__index__", "uid"]);
      other = _.omit(other, ["__index__", "uid"]);
      return _.isEqual(value, other);
    },
    updateFormData: function updateFormData() {
      this.$set(this.formData, this.field, this.formValue);
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: this.formValue
      });
      // 处理共享数据
      if (this.share) {
        this.writeShareData();
      }
    },
    writeShareData: function writeShareData() {
      if (!this.share) return;
      var share = new Share(this.share);
      if (share) {
        var value = this.getValue();
        share.write(value === null || value === void 0 ? void 0 : value.data);
      }
    },
    handleCancel: function handleCancel() {
      this.modalVisible = false;
      this.editing = false;
      this.subFormOptions.formRecordData = null;
    },
    btnClick: function btnClick() {
      this.modalVisible = true;
    },
    delItem: function delItem(record) {
      this.list = this.list.filter(function (item) {
        return item.uid != record.uid;
      });
      this.setAutoIndexField();
      this.updateFormData();
    },
    subFormOperator: function subFormOperator(_ref2) {
      var key = _ref2.key,
        record = _ref2.record;
      switch (key) {
        case "delete":
          this.delItem(record);
          break;
        case "edit":
        case "readonly":
          this.editItem(record);
          break;
      }
    },
    editItem: function editItem(record) {
      this.editing = true;
      this.subFormOptions.formRecordData = record;
      this.modalVisible = true;
    },
    setValue: function setValue(value) {
      var silently = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      this.list = value.data.map(function (item) {
        if (item.uid) return item;
        item.uid = uid();
        return item;
      }) || [];
      if (!silently) this.updateFormData();
    },
    _beforeDestroy: function _beforeDestroy() {
      var value = {
        form: this.formUid,
        data: []
      };
      this.formData[this.field] = value;
      // 派发字段值变化事件
      this.bus.$emit(this.$events.form.FIELD_CHANGE, {
        field: this.field,
        value: value
      });
    },
    getValue: function getValue() {
      var value = _.cloneDeep(this.list);
      return {
        form: this.formUid,
        data: value
      };
    }
  }
};

/* script */
var __vue_script__$6 = script$6;

/* template */
var __vue_render__$6 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "wrap"
  }, [_c("a-modal", {
    attrs: {
      title: _vm.label,
      width: "calc(80% - 270px)",
      height: "600px",
      visible: _vm.modalVisible,
      destroyOnClose: ""
    },
    on: {
      ok: _vm.handleOk,
      cancel: _vm.handleCancel
    }
  }, [_c("GTForm", {
    ref: "subForm",
    attrs: {
      options: _vm.subFormOptions
    },
    on: {
      submit: _vm.submitData
    }
  })], 1), _vm._v(" "), _c("a-form-model-item", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      required: _vm.options.required
    }
  }, [_c("div", {
    staticClass: "form-table"
  }, [_vm.subFormOptions.formDef ? _c("SubFormTable", {
    attrs: {
      fields: _vm.fields,
      list: _vm.list,
      dicts: _vm.dicts,
      readonly: _vm.readonly,
      unableDelete: _vm.unableDelete
    },
    on: {
      operator: _vm.subFormOperator
    }
  }) : _vm._e(), _vm._v(" "), _vm.unableAdd ? _c("a-button", {
    staticClass: "btn",
    attrs: {
      type: "dashed",
      disabled: _vm.readonly
    },
    on: {
      click: _vm.btnClick
    }
  }, [_c("a-icon", {
    attrs: {
      type: "plus"
    }
  }), _vm._v("添加\n      ")], 1) : _vm._e()], 1)])], 1);
};
var __vue_staticRenderFns__$6 = [];
__vue_render__$6._withStripped = true;

/* style */
var __vue_inject_styles__$6 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-726d9e5c_0", {
    source: ".label[data-v-726d9e5c] {\n  display: inline-block;\n  overflow: hidden;\n  line-height: 39.9999px;\n  white-space: nowrap;\n  text-align: right;\n  vertical-align: middle;\n  color: rgba(0, 0, 0, 0.85);\n}\n.label-required[data-v-726d9e5c]::before {\n  display: inline-block;\n  margin-right: 4px;\n  color: #f5222d;\n  font-size: 14px;\n  font-family: SimSun, sans-serif;\n  line-height: 1;\n  content: \"*\";\n}\n[data-v-726d9e5c] .ant-modal {\n  top: 73px;\n}\n[data-v-726d9e5c] .ant-modal-body {\n  height: calc(100vh - 240px);\n  overflow-y: auto;\n}\n.btn[data-v-726d9e5c] {\n  margin: 8px 0 4px 0;\n  width: 100%;\n  line-height: 32px;\n}\n.btn .anticon[data-v-726d9e5c] {\n  color: rgba(0, 0, 0, 0.35);\n}\n.message-explain[data-v-726d9e5c] {\n  color: #f5222d;\n  margin-top: 4px;\n}\n.form-table[data-v-726d9e5c] {\n  border: 1px solid #d9d9d9;\n  padding: 5px;\n  border-radius: 4px;\n}\n.form-table[data-v-726d9e5c] .ant-table-placeholder {\n  border-bottom: none;\n}\n.table-explain[data-v-726d9e5c] {\n  border: 1px solid #f5222d;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,qBAAqB;EACrB,gBAAgB;EAChB,sBAAsB;EACtB,mBAAmB;EACnB,iBAAiB;EACjB,sBAAsB;EACtB,0BAA0B;AAC5B;AACA;EACE,qBAAqB;EACrB,iBAAiB;EACjB,cAAc;EACd,eAAe;EACf,+BAA+B;EAC/B,cAAc;EACd,YAAY;AACd;AACC;EACC,SAAS;AACX;AACC;EACC,2BAA2B;EAC3B,gBAAgB;AAClB;AACA;EACE,mBAAmB;EACnB,WAAW;EACX,iBAAiB;AACnB;AACA;EACE,0BAA0B;AAC5B;AACA;EACE,cAAc;EACd,eAAe;AACjB;AACA;EACE,yBAAyB;EACzB,YAAY;EACZ,kBAAkB;AACpB;AACA;EACE,mBAAmB;AACrB;AACA;EACE,yBAAyB;AAC3B",
      "file": "index.vue",
      "sourcesContent": [".label {\n  display: inline-block;\n  overflow: hidden;\n  line-height: 39.9999px;\n  white-space: nowrap;\n  text-align: right;\n  vertical-align: middle;\n  color: rgba(0, 0, 0, 0.85);\n}\n.label-required::before {\n  display: inline-block;\n  margin-right: 4px;\n  color: #f5222d;\n  font-size: 14px;\n  font-family: SimSun, sans-serif;\n  line-height: 1;\n  content: \"*\";\n}\n /deep/ .ant-modal {\n  top: 73px;\n}\n /deep/ .ant-modal-body {\n  height: calc(100vh - 240px);\n  overflow-y: auto;\n}\n.btn {\n  margin: 8px 0 4px 0;\n  width: 100%;\n  line-height: 32px;\n}\n.btn .anticon {\n  color: rgba(0, 0, 0, 0.35);\n}\n.message-explain {\n  color: #f5222d;\n  margin-top: 4px;\n}\n.form-table {\n  border: 1px solid #d9d9d9;\n  padding: 5px;\n  border-radius: 4px;\n}\n.form-table /deep/ .ant-table-placeholder {\n  border-bottom: none;\n}\n.table-explain {\n  border: 1px solid #f5222d;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$6 = "data-v-726d9e5c";
/* module identifier */
var __vue_module_identifier__$6 = undefined;
/* functional template */
var __vue_is_functional_template__$6 = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$6 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$6,
  staticRenderFns: __vue_staticRenderFns__$6
}, __vue_inject_styles__$6, __vue_script__$6, __vue_scope_id__$6, __vue_is_functional_template__$6, __vue_module_identifier__$6, false, createInjector, undefined, undefined);

//
var script$5 = {
  name: "TextAreaField",
  mixins: [importBaseField],
  computed: {
    maxLength: function maxLength() {
      return this.options.maxLength || "";
    },
    autoSize: function autoSize() {
      return this.options.autoSize || false;
    }
  },
  methods: {
    changeHandler: function changeHandler() {
      this.updateFormData();
    }
  }
};

/* script */
var __vue_script__$5 = script$5;

/* template */
var __vue_render__$5 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.hide,
      expression: "!hide"
    }],
    staticClass: "gt-text-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      help: _vm.help,
      required: _vm.required
    }
  }, [_c("a-textarea", {
    attrs: {
      placeholder: _vm.placeholder,
      allowClear: "",
      disabled: _vm.readonly,
      maxLength: _vm.maxLength,
      autoSize: _vm.autoSize
    },
    on: {
      change: _vm.changeHandler,
      blur: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$5 = [];
__vue_render__$5._withStripped = true;

/* style */
var __vue_inject_styles__$5 = undefined;
/* scoped */
var __vue_scope_id__$5 = undefined;
/* module identifier */
var __vue_module_identifier__$5 = undefined;
/* functional template */
var __vue_is_functional_template__$5 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$5 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$5,
  staticRenderFns: __vue_staticRenderFns__$5
}, __vue_inject_styles__$5, __vue_script__$5, __vue_scope_id__$5, __vue_is_functional_template__$5, __vue_module_identifier__$5, false, undefined, undefined, undefined);

//
var script$4 = {
  name: "TextField",
  mixins: [importBaseField],
  computed: {
    maxLength: function maxLength() {
      return this.options.maxLength || "";
    }
  },
  methods: {
    changeHandler: function changeHandler() {
      this.updateFormData();
    }
  }
};

/* script */
var __vue_script__$4 = script$4;

/* template */
var __vue_render__$4 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.hide,
      expression: "!hide"
    }],
    staticClass: "gt-text-field"
  }, [_c("GTField", {
    attrs: {
      label: _vm.label,
      prop: _vm.field,
      help: _vm.help,
      required: _vm.required
    }
  }, [_c("a-input", {
    attrs: {
      placeholder: _vm.placeholder,
      suffix: _vm.unit,
      allowClear: "",
      disabled: _vm.readonly,
      maxLength: _vm.maxLength
    },
    on: {
      change: _vm.changeHandler,
      blur: _vm.changeHandler
    },
    model: {
      value: _vm.value,
      callback: function callback($$v) {
        _vm.value = $$v;
      },
      expression: "value"
    }
  })], 1)], 1);
};
var __vue_staticRenderFns__$4 = [];
__vue_render__$4._withStripped = true;

/* style */
var __vue_inject_styles__$4 = undefined;
/* scoped */
var __vue_scope_id__$4 = undefined;
/* module identifier */
var __vue_module_identifier__$4 = undefined;
/* functional template */
var __vue_is_functional_template__$4 = false;
/* style inject */

/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$4 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$4,
  staticRenderFns: __vue_staticRenderFns__$4
}, __vue_inject_styles__$4, __vue_script__$4, __vue_scope_id__$4, __vue_is_functional_template__$4, __vue_module_identifier__$4, false, undefined, undefined, undefined);

var RequiredValidator = /*#__PURE__*/function () {
  /**
   * 必填项校验器
   * @param {*} label 字段标题
   */
  function RequiredValidator(fieldLabel, def) {
    _classCallCheck(this, RequiredValidator);
    if (!fieldLabel) return;
    this.fieldLabel = fieldLabel;
    this.def = def;
  }

  /**
   * 生成校验规则
   */
  _createClass(RequiredValidator, [{
    key: "getRule",
    value: function getRule() {
      var _this$def = this.def,
        isSubForm = _this$def.isSubForm,
        options = _this$def.options;
      var rule = {
        required: true,
        message: (options === null || options === void 0 ? void 0 : options.message) || "".concat(this.fieldLabel, "\u4E0D\u80FD\u4E3A\u7A7A")
      };
      if (isSubForm) {
        // rule["type"] = "object";
        // rule["transform"] = (value) => {
        //   console.log("value :>> ", value);
        //   const data = value?.data;
        //   if (data && data.length == 0) {
        //     return null;
        //   }
        //   return value;
        // };
        rule["type"] = "object";
        rule["fields"] = {
          data: {
            type: "array",
            min: 1,
            message: rule["message"]
          }
        };
      }
      return rule;
    }
  }]);
  return RequiredValidator;
}();

var Validator = /*#__PURE__*/function () {
  /**
   *
   * @param {*} fieldLabel    字段标题
   * @param {*} def          校验器定义
   * @param {*} formData     表单数据
   */
  function Validator(fieldLabel, def, formData) {
    _classCallCheck(this, Validator);
    if (!fieldLabel || !def || !formData) return;
    this.fieldLabel = fieldLabel;
    this.def = def;
    this.formData = formData;
  }

  /**
   * 生成校验规则
   */
  _createClass(Validator, [{
    key: "getRule",
    value: function getRule() {
      console.warn("Concrete Validator should override genRule function");
    }
  }]);
  return Validator;
}();

var NumberRangeValidator = /*#__PURE__*/function (_Validator) {
  _inherits(NumberRangeValidator, _Validator);
  var _super = _createSuper(NumberRangeValidator);
  function NumberRangeValidator(fieldLabel, def, formData) {
    _classCallCheck(this, NumberRangeValidator);
    return _super.call(this, fieldLabel, def, formData);
  }

  /**
   * 生成校验规则
   */
  _createClass(NumberRangeValidator, [{
    key: "getRule",
    value: function getRule() {
      var _this$def, _this$def2, _this$def2$options;
      var _this$def$options = (_this$def = this.def) === null || _this$def === void 0 ? void 0 : _this$def.options,
        min = _this$def$options.min,
        max = _this$def$options.max;
      return {
        type: "number",
        min: min,
        max: max,
        message: ((_this$def2 = this.def) === null || _this$def2 === void 0 ? void 0 : (_this$def2$options = _this$def2.options) === null || _this$def2$options === void 0 ? void 0 : _this$def2$options.message) || "\u8BF7\u8F93\u5165\u6B63\u786E\u7684".concat(this.fieldLabel, "\uFF0C\u503C\u5728 ").concat(min, " \u5230 ").concat(max, " \u4E4B\u95F4")
      };
    }
  }]);
  return NumberRangeValidator;
}(Validator);

var TextRangeValidator$1 = /*#__PURE__*/function (_Validator) {
  _inherits(TextRangeValidator, _Validator);
  var _super = _createSuper(TextRangeValidator);
  function TextRangeValidator(fieldLabel, def, formData) {
    _classCallCheck(this, TextRangeValidator);
    return _super.call(this, fieldLabel, def, formData);
  }

  /**
   * 生成校验规则
   */
  _createClass(TextRangeValidator, [{
    key: "getRule",
    value: function getRule() {
      var _this$def, _this$def2, _this$def2$options;
      var _this$def$options = (_this$def = this.def) === null || _this$def === void 0 ? void 0 : _this$def.options,
        min = _this$def$options.min,
        max = _this$def$options.max;
      return {
        type: "string",
        min: min,
        max: max,
        message: ((_this$def2 = this.def) === null || _this$def2 === void 0 ? void 0 : (_this$def2$options = _this$def2.options) === null || _this$def2$options === void 0 ? void 0 : _this$def2$options.message) || "\u8BF7\u8F93\u5165\u6B63\u786E\u7684".concat(this.fieldLabel, "\uFF0C\u957F\u5EA6\u5728 ").concat(min, " \u5230 ").concat(max, " \u4E4B\u95F4")
      };
    }
  }]);
  return TextRangeValidator;
}(Validator);

var RegExpValidator = /*#__PURE__*/function (_Validator) {
  _inherits(RegExpValidator, _Validator);
  var _super = _createSuper(RegExpValidator);
  function RegExpValidator(fieldLabel, def, formData) {
    _classCallCheck(this, RegExpValidator);
    return _super.call(this, fieldLabel, def, formData);
  }

  /**
   * 生成校验规则
   */
  _createClass(RegExpValidator, [{
    key: "getRule",
    value: function getRule() {
      var _this$def, _this$def2, _this$def2$options;
      var _this$def$options = (_this$def = this.def) === null || _this$def === void 0 ? void 0 : _this$def.options,
        pattern = _this$def$options.pattern;
      return {
        pattern: new RegExp(pattern),
        message: ((_this$def2 = this.def) === null || _this$def2 === void 0 ? void 0 : (_this$def2$options = _this$def2.options) === null || _this$def2$options === void 0 ? void 0 : _this$def2$options.message) || "\u8BF7\u8F93\u5165\u6B63\u786E\u7684".concat(this.fieldLabel)
      };
    }
  }]);
  return RegExpValidator;
}(Validator);

var CompareValidator = /*#__PURE__*/function (_Validator) {
  _inherits(CompareValidator, _Validator);
  var _super = _createSuper(CompareValidator);
  function CompareValidator(fieldLabel, def, formData) {
    _classCallCheck(this, CompareValidator);
    return _super.call(this, fieldLabel, def, formData);
  }

  /**
   * 生成校验规则
   */
  _createClass(CompareValidator, [{
    key: "getRule",
    value: function getRule() {
      var _this$def,
        _this$def2,
        _this$def2$options,
        _this = this;
      var _this$def$options = (_this$def = this.def) === null || _this$def === void 0 ? void 0 : _this$def.options,
        expression = _this$def$options.expression;
      if (!expression || !Array.isArray(expression) || expression.length < 3) return;
      var operator = expression[0],
        valueExpression = expression[1],
        compareExpression = expression[2];
      return {
        message: ((_this$def2 = this.def) === null || _this$def2 === void 0 ? void 0 : (_this$def2$options = _this$def2.options) === null || _this$def2$options === void 0 ? void 0 : _this$def2$options.message) || "\u8BF7\u8F93\u5165\u6B63\u786E\u7684".concat(this.fieldLabel),
        validator: function validator() {
          var value = _this.getValue(valueExpression);
          var compareValue = _this.getValue(compareExpression);
          if (isNaN(value) || isNaN(compareValue)) return true;
          switch (operator) {
            case ">=":
              return value >= compareValue;
            case ">":
              return value > compareValue;
            case "==":
              return value == compareValue;
            case "<=":
              return value <= compareValue;
            case "<":
              return value < compareValue;
            case "!=":
              return value != compareValue;
          }
        }
      };
    }
  }, {
    key: "getValue",
    value: function getValue(expression) {
      if (!expression) return;
      if (Array.isArray(expression)) {
        var calculator = CalculatorFactory.createCalculator(expression, this.formData);
        if (!calculator) return;
        return calculator.calc();
      }
      return this.formData[expression];
    }
  }]);
  return CompareValidator;
}(Validator);

var TextRangeValidator = /*#__PURE__*/function (_Validator) {
  _inherits(TextRangeValidator, _Validator);
  var _super = _createSuper(TextRangeValidator);
  function TextRangeValidator(fieldLabel, def, formData) {
    _classCallCheck(this, TextRangeValidator);
    return _super.call(this, fieldLabel, def, formData);
  }

  /**
   * 生成校验规则
   */
  _createClass(TextRangeValidator, [{
    key: "getRule",
    value: function getRule() {
      return {
        type: "object",
        required: false,
        options: {
          data: true
        },
        fields: {
          data: this.getData()
        }
      };
    }
  }, {
    key: "getData",
    value: function getData() {
      var _this$def;
      var _ref = ((_this$def = this.def) === null || _this$def === void 0 ? void 0 : _this$def.options) || {},
        min = _ref.min,
        max = _ref.max,
        size = _ref.size,
        message = _ref.message;
      if (size) {
        return {
          type: "array",
          len: size,
          message: message !== null && message !== void 0 ? message : "".concat(this.fieldLabel, "\u6570\u91CF\u9700\u8FBE\u5230").concat(size, "\u6761")
        };
      } else {
        return {
          type: "array",
          min: min,
          max: max,
          message: message !== null && message !== void 0 ? message : "".concat(this.fieldLabel, "\u6570\u91CF\u5728").concat(min, "-").concat(max, "\u4E4B\u95F4")
        };
      }
    }
  }]);
  return TextRangeValidator;
}(Validator);

var VALIDATOR_TYPES = {
  REQUIRED: "required",
  NUMBER_RANGE: "number-range",
  TEXT_RANGE: "text-range",
  REGEX: "regex",
  COMPARE: "compare",
  ITEM_COUNT: "item-count"
};
var createValidator = function createValidator(fieldLabel, validator, formData) {
  if (!fieldLabel || !validator || !formData) return;
  switch (validator.type) {
    case VALIDATOR_TYPES.REQUIRED:
      return new RequiredValidator(fieldLabel, validator);
    case VALIDATOR_TYPES.NUMBER_RANGE:
      return new NumberRangeValidator(fieldLabel, validator, formData);
    case VALIDATOR_TYPES.TEXT_RANGE:
      return new TextRangeValidator$1(fieldLabel, validator, formData);
    case VALIDATOR_TYPES.REGEX:
      return new RegExpValidator(fieldLabel, validator, formData);
    case VALIDATOR_TYPES.COMPARE:
      return new CompareValidator(fieldLabel, validator, formData);
    case VALIDATOR_TYPES.ITEM_COUNT:
      return new TextRangeValidator(fieldLabel, validator, formData);
  }
};
var ValidatorFactory = {
  createValidator: createValidator
};

var script$3 = {
  name: "GTForm",
  // 向子孙组件注入事件总线，实现模块内部消息通信
  provide: function provide() {
    return {
      bus: this.bus,
      parentFormData: this.parentFormData
    };
  },
  props: {
    // 参数
    options: {
      type: Object
    }
  },
  data: function data() {
    return {
      // 表单定义，通过MIS API获取
      formDef: undefined,
      // 表单数据
      formRecordData: undefined,
      parentFormData: undefined,
      formHelpData: {},
      // 字典
      dicts: {},
      // 校验规则
      rules: {},
      // 表单级校验规则
      formRules: undefined,
      // 布局
      layout: [],
      // 表单数据，通过MIS API获取
      formData: {},
      // 表单字段组件
      fieldRefs: {},
      // 表单范围内使用的事件总线
      bus: new Vue()
    };
  },
  watch: {
    options: {
      handler: function handler() {
        var _this = this;
        return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
          var _this$formDef, _this$formDef2;
          var _this$options, formDef, formRecordData, formHelpData, parentFormData;
          return _regeneratorRuntime().wrap(function _callee$(_context) {
            while (1) switch (_context.prev = _context.next) {
              case 0:
                if (_this.options) {
                  _context.next = 2;
                  break;
                }
                return _context.abrupt("return");
              case 2:
                _this$options = _this.options, formDef = _this$options.formDef, formRecordData = _this$options.formRecordData, formHelpData = _this$options.formHelpData, parentFormData = _this$options.parentFormData; // formDef不能为空
                if (formDef) {
                  _context.next = 5;
                  break;
                }
                return _context.abrupt("return");
              case 5:
                _this.formDef = formDef;
                _this.formRecordData = formRecordData;
                _this.parentFormData = parentFormData;
                _this.formHelpData = formHelpData || {};
                // 表单数据初始化
                if (_this.formRecordData) {
                  Object.keys(_this.formRecordData).forEach(function (field) {
                    _this.$set(_this.formData, field, _this.formRecordData[field]);
                  });
                }
                // 获取字段
                _this.fields = _this.$newUtils.array.toMap((_this$formDef = _this.formDef) === null || _this$formDef === void 0 ? void 0 : _this$formDef.fields, "name");
                // 获取字典
                _this.dicts = _this.$newUtils.array.toMap((_this$formDef2 = _this.formDef) === null || _this$formDef2 === void 0 ? void 0 : _this$formDef2.dicts, "name");
                // 生成校验规则
                _this.rules = _this.genRules();
                // 生成表单级校验器
                _this.formRules = _this.genFormRules();
                // 获取布局
                _this.layout = _this.genLayout();
              case 15:
              case "end":
                return _context.stop();
            }
          }, _callee);
        }))();
      },
      immediate: true,
      deep: true
    }
  },
  created: function created() {
    // 监听字段组件初始化
    this.bus.$on(this.$events.form.FIELD_INITIALIZED, this.fieldInitHandler);
  },
  mounted: function mounted() {
    // 监听字段值变化
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.fieldChangeHandler);
  },
  computed: {
    itemLayout: function itemLayout() {
      var _this$options2, _this$options2$formDe;
      var itemLayout = {};
      var itemOptions = (_this$options2 = this.options) === null || _this$options2 === void 0 ? void 0 : (_this$options2$formDe = _this$options2.formDef.layout) === null || _this$options2$formDe === void 0 ? void 0 : _this$options2$formDe.itemOptions;
      if (itemOptions) {
        itemLayout = this.genItemLayout(itemOptions);
      }
      return itemLayout;
    }
  },
  methods: {
    // 生成校验规则
    genRules: function genRules() {
      var _this$formDef3,
        _this$formDef3$valida,
        _this2 = this,
        _this$formDef4,
        _this$formDef4$valida;
      var rules = {};
      // 字段校验器
      var fieldValidators = (_this$formDef3 = this.formDef) === null || _this$formDef3 === void 0 ? void 0 : (_this$formDef3$valida = _this$formDef3.validators) === null || _this$formDef3$valida === void 0 ? void 0 : _this$formDef3$valida.fieldValidators;
      if (fieldValidators && Array.isArray(fieldValidators)) {
        fieldValidators.forEach(function (_ref) {
          var field = _ref.field,
            label = _ref.label,
            validators = _ref.validators;
          rules[field] = _this2._genRules(label, validators);
        });
      }
      // 子表单校验器
      var subformValidators = (_this$formDef4 = this.formDef) === null || _this$formDef4 === void 0 ? void 0 : (_this$formDef4$valida = _this$formDef4.validators) === null || _this$formDef4$valida === void 0 ? void 0 : _this$formDef4$valida.subformValidators;
      if (subformValidators && Array.isArray(subformValidators)) {
        subformValidators.forEach(function (_ref2) {
          var subform = _ref2.subform,
            label = _ref2.label,
            validators = _ref2.validators;
          rules[subform] = _this2._genRules(label, validators, true);
        });
      }
      return rules;
    },
    _genRules: function _genRules(fieldLabel, validators) {
      var _this3 = this;
      var isSubForm = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
      var rules = [];
      if (validators && Array.isArray(validators)) {
        validators.forEach(function (validator) {
          // 判断是否为子表验证
          validator["isSubForm"] = isSubForm;
          var vd = ValidatorFactory.createValidator(fieldLabel, validator, _this3.formData);
          // if (isSubForm) {
          //   console.log("vd :>> ", vd.getRule());
          // }
          if (vd) {
            rules.push(vd.getRule());
          }
        });
      }
      return rules;
    },
    // 表单级校验器
    genFormRules: function genFormRules() {
      var _this$formDef5,
        _this$formDef5$valida,
        _this4 = this;
      var validators = (_this$formDef5 = this.formDef) === null || _this$formDef5 === void 0 ? void 0 : (_this$formDef5$valida = _this$formDef5.validators) === null || _this$formDef5$valida === void 0 ? void 0 : _this$formDef5$valida.formValidators;
      if (!validators || !Array.isArray(validators)) return;
      var vds = [];
      validators.forEach(function (validator) {
        var vd = ValidatorFactory.createValidator("表单数据", validator, _this4.formData);
        if (vd) {
          vds.push(vd.getRule());
        }
      });
      return vds;
    },
    // 生成布局，在表单定义中layout的基础上，补齐相应的内容，如字典
    genLayout: function genLayout() {
      var _this5 = this;
      var layout = this.formDef.layout;
      if (!layout || !Array.isArray(layout)) {
        if (_typeof(layout) === "object" && layout.children) {
          layout = layout.children;
        } else {
          return [];
        }
      }
      layout = this.$newUtils.object.deepCloneJson(layout);
      layout.forEach(function (component) {
        _this5._handleComponent(component);
      });
      return layout;
    },
    genItemLayout: function genItemLayout(itemOptions) {
      return {
        layout: itemOptions["labelPosition"] === "left" ? "horizontal" : "vertical",
        labelCol: {
          span: itemOptions["labelSpan"]
        },
        wrapperCol: {
          span: itemOptions["wrapperSpan"]
        },
        labelAlign: itemOptions["labelAlign"],
        hideRequiredMark: itemOptions["hideRequiredMark"]
      };
    },
    _handleComponent: function _handleComponent(component) {
      var _this6 = this;
      if (!component || !component.options) return;
      var _this$options3 = this.options,
        readonly = _this$options3.readonly,
        readonlyFields = _this$options3.readonlyFields;
      var options = component.options;
      // 处理字典
      if (options.dictRef) {
        options.dict = this.dicts[options.dictRef];
      }
      // 设置只读
      if (readonly) {
        options.readonly = true;
      }
      if (readonlyFields) {
        if (readonlyFields.includes("*")) {
          options.readonly = true;
        } else {
          readonlyFields = readonlyFields.split(",");
          if (readonlyFields.includes(options.field)) {
            options.readonly = true;
          }
        }
      }
      // 设置help数据
      if (this.formHelpData[options.field]) {
        options["help"] = this.formHelpData[options.field];
      }
      // 添加formData，有label属性被认为是字段组件
      if (options.label || options.depends) {
        options.formData = this.formData;
      }
      if (options.children && Array.isArray(options.children)) {
        options.children.forEach(function (comp) {
          _this6._handleComponent(comp);
        });
      }
    },
    getFormData: function getFormData() {
      return this.formData;
    },
    /**
     * 该方法由父组件调用，对表单进行校验并提交表单数据
     */
    submit: function submit() {
      var _this7 = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee2() {
        var subFormValid, formValid, valid, result;
        return _regeneratorRuntime().wrap(function _callee2$(_context2) {
          while (1) switch (_context2.prev = _context2.next) {
            case 0:
              _context2.next = 2;
              return _this7.submitSubForms();
            case 2:
              subFormValid = _context2.sent;
              formValid = _this7.validateForm(); // 校验
              _context2.prev = 4;
              _context2.next = 7;
              return _this7.$refs.form.validate();
            case 7:
              valid = _context2.sent;
              result = valid && subFormValid && formValid;
              if (result) {
                // 提交表单
                _this7.$emit(_this7.$events.form.SUBMIT, _this7.formData);
              }
              return _context2.abrupt("return", result);
            case 13:
              _context2.prev = 13;
              _context2.t0 = _context2["catch"](4);
              console.log("表单校验失败：", _context2.t0);
            case 16:
              return _context2.abrupt("return", false);
            case 17:
            case "end":
              return _context2.stop();
          }
        }, _callee2, null, [[4, 13]]);
      }))();
    },
    validateForm: function validateForm() {
      if (!this.formRules || this.formRules.length === 0) return true;
      var _iterator = _createForOfIteratorHelper(this.formRules),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var rule = _step.value;
          if (rule.validator && !rule.validator()) {
            this.$message.error(rule.message);
            return false;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      return true;
    },
    fieldChangeHandler: function fieldChangeHandler(_ref3) {
      var field = _ref3.field,
        value = _ref3.value;
      // 去除赋值后的错误提醒
      if (value) {
        this.$refs.form.validateField(field, function () {});
      }
      // 字段发生变化派发事件，便于针对个性化需求进行功能定制
      this.$emit(this.$events.form.FIELD_CHANGE, {
        field: field,
        value: value,
        formData: this.formData
      });
    },
    fieldInitHandler: function fieldInitHandler(_ref4) {
      var field = _ref4.field,
        fieldRef = _ref4.fieldRef;
      if (!field || !fieldRef) return;
      this.fieldRefs[field] = fieldRef;
    },
    // 对外提供接口，用于定制化需求对字段组件赋值
    setFieldValue: function setFieldValue(field, value) {
      var targetField = this.fieldRefs[field];
      if (!targetField) return;
      targetField.setValue(value, false);
    },
    // 对外提供接口，用于定制化需求对字段单位赋值
    setFieldUnit: function setFieldUnit(field, unit) {
      var targetField = this.fieldRefs[field];
      if (!targetField) return;
      targetField.setUnit(unit);
    },
    /**
     * 支持子组件定制的接口，子组件按需实现submit接口，将子组件数据写入formData
     */
    submitSubForms: function submitSubForms() {
      var _this8 = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee3() {
        var validList, fields, _i, _fields, field, submitFun;
        return _regeneratorRuntime().wrap(function _callee3$(_context3) {
          while (1) switch (_context3.prev = _context3.next) {
            case 0:
              validList = [];
              fields = Object.keys(_this8.fieldRefs);
              _i = 0, _fields = fields;
            case 3:
              if (!(_i < _fields.length)) {
                _context3.next = 15;
                break;
              }
              field = _fields[_i];
              submitFun = _this8.fieldRefs[field].submit;
              if (!submitFun) {
                _context3.next = 12;
                break;
              }
              _context3.t0 = validList;
              _context3.next = 10;
              return submitFun();
            case 10:
              _context3.t1 = _context3.sent;
              _context3.t0.push.call(_context3.t0, _context3.t1);
            case 12:
              _i++;
              _context3.next = 3;
              break;
            case 15:
              return _context3.abrupt("return", validList.every(function (v) {
                return v;
              }));
            case 16:
            case "end":
              return _context3.stop();
          }
        }, _callee3);
      }))();
    }
  }
};

/* script */
var __vue_script__$3 = script$3;

/* template */
var __vue_render__$3 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-form-wrapper"
  }, [_c("a-form-model", _vm._b({
    ref: "form",
    "class": {
      "form-vertical-box": !_vm.itemLayout.wrapperCol
    },
    attrs: {
      model: _vm.formData,
      rules: _vm.rules
    }
  }, "a-form-model", _vm.itemLayout, false), [_vm._l(_vm.layout, function (component, index) {
    return [!component.options || component.options.visible !== false ? _c(component.type, {
      key: index,
      tag: "component",
      attrs: {
        options: component.options
      }
    }) : _vm._e()];
  })], 2)], 1);
};
var __vue_staticRenderFns__$3 = [];
__vue_render__$3._withStripped = true;

/* style */
var __vue_inject_styles__$3 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-b3a022ee_0", {
    source: ".gt-form-wrapper[data-v-b3a022ee] .ant-form-explain {\n  margin-top: -2px;\n}\n.gt-form-wrapper[data-v-b3a022ee] .form-vertical-box .gt-form-field .ant-form-item {\n  margin-bottom: 0;\n  padding: 4px 0;\n}\n.gt-form-wrapper[data-v-b3a022ee] .form-vertical-box .gt-form-field .ant-form-item-label {\n  line-height: 28px;\n  white-space: pre-wrap;\n  text-align: left;\n}\n.gt-form-wrapper[data-v-b3a022ee] .form-vertical-box .gt-form-field .ant-input-suffix {\n  right: 8px;\n}\n.gt-form-wrapper[data-v-b3a022ee] .form-vertical-box .gt-form-field .ant-input-suffix .anticon {\n  padding-right: 2px;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,gBAAgB;AAClB;AACA;EACE,gBAAgB;EAChB,cAAc;AAChB;AACA;EACE,iBAAiB;EACjB,qBAAqB;EACrB,gBAAgB;AAClB;AACA;EACE,UAAU;AACZ;AACA;EACE,kBAAkB;AACpB",
      "file": "index.vue",
      "sourcesContent": [".gt-form-wrapper /deep/ .ant-form-explain {\n  margin-top: -2px;\n}\n.gt-form-wrapper /deep/ .form-vertical-box .gt-form-field .ant-form-item {\n  margin-bottom: 0;\n  padding: 4px 0;\n}\n.gt-form-wrapper /deep/ .form-vertical-box .gt-form-field .ant-form-item-label {\n  line-height: 28px;\n  white-space: pre-wrap;\n  text-align: left;\n}\n.gt-form-wrapper /deep/ .form-vertical-box .gt-form-field .ant-input-suffix {\n  right: 8px;\n}\n.gt-form-wrapper /deep/ .form-vertical-box .gt-form-field .ant-input-suffix .anticon {\n  padding-right: 2px;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$3 = "data-v-b3a022ee";
/* module identifier */
var __vue_module_identifier__$3 = undefined;
/* functional template */
var __vue_is_functional_template__$3 = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$3 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$3,
  staticRenderFns: __vue_staticRenderFns__$3
}, __vue_inject_styles__$3, __vue_script__$3, __vue_scope_id__$3, __vue_is_functional_template__$3, __vue_module_identifier__$3, false, createInjector, undefined, undefined);

//
//
//
//
//
//
//
//
//
//
//
//
//
//
//
//

var script$2 = {
  name: "GTField",
  props: {
    prop: {
      type: String
    },
    required: {
      type: Boolean,
      "default": false
    },
    label: {
      type: String
    },
    help: {
      type: String
    }
  }
};

/* script */
var __vue_script__$2 = script$2;

/* template */
var __vue_render__$2 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-form-field"
  }, [_c("a-form-model-item", {
    "class": {
      "help-box": _vm.help
    },
    attrs: {
      prop: _vm.prop,
      required: _vm.required
    }
  }, [_c("div", {
    attrs: {
      slot: "label"
    },
    slot: "label"
  }, [_c("span", [_vm._v(_vm._s(_vm.label))]), _vm._v(" "), _c("span", {
    staticClass: "item-label-help"
  }, [_vm._v(_vm._s(_vm.help))])]), _vm._v(" "), _vm._t("default")], 2)], 1);
};
var __vue_staticRenderFns__$2 = [];
__vue_render__$2._withStripped = true;

/* style */
var __vue_inject_styles__$2 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-d0c1673e_0", {
    source: ".gt-form-field {\n  width: 100%;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,WAAW;AACb",
      "file": "index.vue",
      "sourcesContent": [".gt-form-field {\n  width: 100%;\n}\n"]
    },
    media: undefined
  }), inject("data-v-d0c1673e_1", {
    source: ".gt-form-field[data-v-d0c1673e] .help-box .ant-form-item-label,\n.gt-form-field[data-v-d0c1673e] .help-box .ant-form-item-control-wrapper {\n  width: 100%;\n}\n.gt-form-field[data-v-d0c1673e] .help-box .ant-form-item-label > label,\n.gt-form-field[data-v-d0c1673e] .help-box .ant-form-item-control-wrapper > label {\n  justify-content: flex-start;\n}\n.gt-form-field[data-v-d0c1673e] .ant-form-item-label {\n  position: relative;\n}\n.gt-form-field[data-v-d0c1673e] .ant-form-item-label > label {\n  display: flex;\n  align-items: center;\n  justify-content: flex-end;\n}\n.gt-form-field[data-v-d0c1673e] .ant-form-item-label > label .item-label-help {\n  position: absolute;\n  right: 5px;\n  top: 0;\n  color: #1890ff;\n}\n.gt-form-field[data-v-d0c1673e] .ant-form-item-label > label::before {\n  margin-right: 0;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;;EAEE,WAAW;AACb;AACA;;EAEE,2BAA2B;AAC7B;AACA;EACE,kBAAkB;AACpB;AACA;EACE,aAAa;EACb,mBAAmB;EACnB,yBAAyB;AAC3B;AACA;EACE,kBAAkB;EAClB,UAAU;EACV,MAAM;EACN,cAAc;AAChB;AACA;EACE,eAAe;AACjB",
      "file": "index.vue",
      "sourcesContent": [".gt-form-field /deep/ .help-box .ant-form-item-label,\n.gt-form-field /deep/ .help-box .ant-form-item-control-wrapper {\n  width: 100%;\n}\n.gt-form-field /deep/ .help-box .ant-form-item-label > label,\n.gt-form-field /deep/ .help-box .ant-form-item-control-wrapper > label {\n  justify-content: flex-start;\n}\n.gt-form-field /deep/ .ant-form-item-label {\n  position: relative;\n}\n.gt-form-field /deep/ .ant-form-item-label > label {\n  display: flex;\n  align-items: center;\n  justify-content: flex-end;\n}\n.gt-form-field /deep/ .ant-form-item-label > label .item-label-help {\n  position: absolute;\n  right: 5px;\n  top: 0;\n  color: #1890ff;\n}\n.gt-form-field /deep/ .ant-form-item-label > label::before {\n  margin-right: 0;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$2 = "data-v-d0c1673e";
/* module identifier */
var __vue_module_identifier__$2 = undefined;
/* functional template */
var __vue_is_functional_template__$2 = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$2 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$2,
  staticRenderFns: __vue_staticRenderFns__$2
}, __vue_inject_styles__$2, __vue_script__$2, __vue_scope_id__$2, __vue_is_functional_template__$2, __vue_module_identifier__$2, false, createInjector, undefined, undefined);

// import formDesign from "@/apis/formDesign";
var INDEX_NAME = "__index__";
var INDEX_LABEL = "序号";
var INDEX_WIDTH = 70;
var OPERATION_NAME = "__operation__";
var OPERATION_LABEL = "操作";
var changeSlotKeys = ["precision", "unit", "dateFormat"];
var columnArr = ["width", "fixed", "align", "ellipsis", "sorter"];
var changeSlotTypes = ["datetime", "json"];
function dateFormat(date) {
  var fmt = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "YYYY-MM-DD";
  if (!date) return "";
  // YYYY-MM-DD hh:mm:ss
  date = new Date(date);
  var ret;
  var opt = {
    "Y+": date.getFullYear().toString(),
    // 年
    "M+": (date.getMonth() + 1).toString(),
    // 月
    "D+": date.getDate().toString(),
    // 日
    "h+": date.getHours().toString(),
    // 时
    "m+": date.getMinutes().toString(),
    // 分
    "s+": date.getSeconds().toString() // 秒
    // 有其他格式化字符需求可以继续添加，必须转化成字符串
  };

  for (var k in opt) {
    ret = new RegExp("(" + k + ")").exec(fmt);
    if (ret) {
      fmt = fmt.replace(ret[1], ret[1].length == 1 ? opt[k] : opt[k].padStart(ret[1].length, "0"));
    }
  }
  return fmt;
}
// 判断是否为空值
var isEmpty = function isEmpty(value) {
  return [undefined, null, ""].includes(value);
};
// const OPERATION_WIDTH = 180;
// const DEFAULT_PAGE_SIZE = 10;
// const DEFAULT_PAGE_CURRENT = 1;
// const DEFAULT_PAGE_TOTAL = 50;
var script$1 = {
  name: "GTTable",
  props: {
    // 字段
    fields: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    // 主键字段
    keyField: {
      type: String,
      "default": INDEX_NAME
    },
    // 数据
    data: {
      type: Array
    },
    // 关联字典
    dicts: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    // 表操作
    tableOperators: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    // 表记录操作
    recordOperators: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    // 是否支持选中模式
    allowSelect: {
      type: Boolean,
      "default": false
    },
    // 是否显示边框
    bordered: {
      type: Boolean,
      "default": false
    },
    pageSize: {
      type: Number,
      "default": 10
    },
    pageCurrent: {
      type: Number,
      "default": 1
    },
    total: {
      type: Number,
      "default": 0
    },
    loading: {
      type: Boolean,
      "default": false
    },
    operatorWidth: {
      type: Number
    },
    groups: {
      type: Object
    },
    yOffset: {
      type: Number
    }
  },
  components: {
    "a-tag": Tag
  },
  data: function data() {
    return {
      selectedRowKeys: [],
      operationSlot: OPERATION_NAME,
      // pageCurrent: DEFAULT_PAGE_CURRENT,
      // pageSize: DEFAULT_PAGE_SIZE,
      // pageTotal: DEFAULT_PAGE_TOTAL,
      pageSizeOptions: ["10", "20", "30", "40", "50"],
      sortField: undefined,
      sortOrder: undefined,
      dictSlotSuffix: "_dict",
      slotSuffix: "_slot",
      keySuffix: "_key",
      dictsParse: {},
      isGroup: false
    };
  },
  computed: {
    scroll: function scroll() {
      return {
        x: "100%",
        y: "calc(100vh - ".concat(this.yOffset, "px)") || false
      };
    },
    borderedCom: function borderedCom() {
      return this.isGroup || this.bordered;
    },
    // 根据定制转化数据
    slotFormat: function slotFormat() {
      var _this = this;
      return function (data, field) {
        var type = field.type,
          precision = field.precision,
          unit = field.unit,
          dict = field.dict;
        if (changeSlotTypes.includes(type)) {
          switch (type) {
            case "datetime":
              data = dateFormat(data, field["dateFormat"]);
              break;
            case "json":
              if (Array.isArray(data)) {
                // 判断json是否为字典对应值
                if (dict) {
                  var dataArrays = _this.getDictItem(field, data);
                  if (Array.isArray(dataArrays)) {
                    data = dataArrays.map(function (_ref) {
                      var label = _ref.label;
                      return label;
                    }).join(",");
                  } else {
                    data = "";
                  }
                } else {
                  data = data.join(",");
                }
              }
              break;
          }
        }
        if (precision && !isEmpty(data) && !_.isNaN(Number(data))) {
          data = parseFloat(parseFloat(data).toFixed(precision));
        }
        if (unit && !isEmpty(data)) {
          data += field["unit"];
        }
        return data;
      };
    },
    tableOperatorsList: function tableOperatorsList() {
      return this.filterRoleList(this.tableOperators);
    },
    recordOperatorsList: function recordOperatorsList() {
      return this.filterRoleList(this.recordOperators);
    },
    columns: function columns() {
      return this.genColumns();
    },
    dataSource: function dataSource() {
      return this.genDataSource();
    },
    selectCount: function selectCount() {
      return this.selectedRowKeys.length;
    },
    dictFields: function dictFields() {
      return this.fields.filter(function (f) {
        return !!f.dict;
      });
    },
    getSlotKeys: function getSlotKeys() {
      return this.fields.filter(function (f) {
        return isTrue(f);
      });
      function isTrue(field) {
        return _.intersection(Object.keys(field), changeSlotKeys).length != 0 || changeSlotTypes.includes(field["type"]);
      }
    },
    slotFields: function slotFields() {
      return this.fields.filter(function (f) {
        return f.slot === true;
      });
    },
    getLabel: function getLabel() {
      var _this2 = this;
      return function (field, value) {
        var dictItem = _this2.getDictItem(field, value);
        if (!dictItem) return;
        return dictItem.label;
      };
    },
    getIcon: function getIcon() {
      var _this3 = this;
      return function (field, value) {
        var dictItem = _this3.getDictItem(field, value);
        if (!dictItem) return;
        return dictItem.icon;
      };
    },
    getLabelColor: function getLabelColor() {
      var _this4 = this;
      return function (field, value) {
        var dictItem = _this4.getDictItem(field, value);
        if (!dictItem) return;
        return dictItem.labelColor;
      };
    },
    getTagColor: function getTagColor() {
      var _this5 = this;
      return function (field, value) {
        var dictItem = _this5.getDictItem(field, value);
        if (!dictItem) return;
        return dictItem.tagColor;
      };
    },
    getIconColor: function getIconColor() {
      var _this6 = this;
      return function (field, value) {
        var dictItem = _this6.getDictItem(field, value);
        if (!dictItem) return;
        return dictItem.iconColor;
      };
    },
    getFontSize: function getFontSize() {
      var _this7 = this;
      return function (field, value) {
        var dictItem = _this7.getDictItem(field, value);
        if (!dictItem) return;
        return dictItem.fontSize;
      };
    },
    getComponentVisible: function getComponentVisible() {
      return function (expression, record) {
        if (!expression) return true;
        if (typeof expression === "function") {
          return expression(record);
        } else {
          return new Function("record", "return record.".concat(expression))(record);
        }
      };
    },
    getComponentDisabled: function getComponentDisabled() {
      return function (expression, record) {
        if (!expression) return false;
        if (typeof expression === "function") {
          return expression(record);
        } else {
          return new Function("record", "return record.".concat(expression))(record);
        }
      };
    }
  },
  mounted: function mounted() {
    // 如果有字典则格式化一下字典
    if (Array.isArray(this.dicts) && this.dicts.length != 0) {
      this.getDicts(this.dicts);
    }
  },
  methods: {
    getDicts: function getDicts(dicts) {
      var _this8 = this;
      return _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime().mark(function _callee() {
        var dictsParse, key, name;
        return _regeneratorRuntime().wrap(function _callee$(_context) {
          while (1) switch (_context.prev = _context.next) {
            case 0:
              _context.prev = 0;
              dictsParse = {};
              _context.t0 = _regeneratorRuntime().keys(dicts);
            case 3:
              if ((_context.t1 = _context.t0()).done) {
                _context.next = 11;
                break;
              }
              key = _context.t1.value;
              name = dicts[key].name;
              _context.next = 8;
              return _this8.$newUtils.dict.parse(dicts[key]);
            case 8:
              dictsParse[name] = _context.sent;
              _context.next = 3;
              break;
            case 11:
              _this8.dictsParse = dictsParse;
              _context.next = 17;
              break;
            case 14:
              _context.prev = 14;
              _context.t2 = _context["catch"](0);
              _this8.$message.error("\u83B7\u53D6\u5B57\u5178\u8868\u65F6".concat(_context.t2.msg));
            case 17:
            case "end":
              return _context.stop();
          }
        }, _callee, null, [[0, 14]]);
      }))();
    },
    // 通过不同权限配置操作框和显示属性
    filterRoleList: function filterRoleList(list) {
      var userInfo = JSON.parse(localStorage.getItem("userInfo"));
      var roleCodes = userInfo["roles"].map(function (_ref2) {
        var code = _ref2.code;
        return code;
      });
      if (Array.isArray(list)) {
        return list.filter(function (item) {
          if (item["showRoles"]) {
            var isShow = false;
            var _iterator = _createForOfIteratorHelper(item["showRoles"]),
              _step;
            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var value = _step.value;
                if (roleCodes.includes(value)) {
                  isShow = true;
                  break;
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }
            return isShow;
          } else {
            return true;
          }
        });
      } else {
        return [];
      }
    },
    getDictItem: function getDictItem(_ref3, value) {
      var dict = _ref3.dict;
      if (!dict) return;
      var dictData = this.dictsParse[dict];
      if (!dictData) return;
      if (Array.isArray(value)) {
        dictData = this.flatDictData(dictData);
        return dictData.filter(function (item) {
          return value.includes(item.value);
        });
      } else {
        return dictData.find(function (item) {
          return item.value == value;
        });
      }
    },
    flatDictData: function flatDictData(data) {
      var _this9 = this;
      data = _.cloneDeep(data);
      data.forEach(function (item) {
        var children = item.children;
        if (Array.isArray(children)) {
          var _data;
          (_data = data).push.apply(_data, _toConsumableArray(_this9.flatDictData(children)));
        }
        delete item.children;
      });
      return data;
    },
    // 拆分groups为map对应关系，用于判断是否参与分组
    mapTableGroups: function mapTableGroups(groups) {
      var _this10 = this;
      var map = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      var parentGroupName = arguments.length > 2 ? arguments[2] : undefined;
      if (!groups) return {};
      var _loop = function _loop() {
        var group = groups[key];
        if (Array.isArray(group)) {
          var groupNames = parentGroupName ? "".concat(parentGroupName, ",").concat(key) : key;
          group.forEach(function (item) {
            if (_typeof(item) === "object") {
              map = _this10.mapTableGroups(item, map, groupNames);
            } else {
              map[item] = groupNames;
            }
          });
        }
      };
      for (var key in groups) {
        _loop();
      }
      return map;
    },
    // 增加分组title的column对象
    columnAddGroup: function columnAddGroup(columns, groupNames) {
      var columnsMap = _.keyBy(columns, "title");
      groupNames.forEach(function (name, index) {
        if (!columnsMap[name]) {
          var _pid = index === 0 ? -1 : groupNames[index - 1];
          columns.push({
            title: name,
            _pid: _pid,
            align: "center",
            children: []
          });
        }
      });
    },
    // 将分组组合成tree
    arrayToTree: function arrayToTree(items) {
      items = _.cloneDeep(items);
      var res = [],
        map = {};
      var _iterator2 = _createForOfIteratorHelper(items),
        _step2;
      try {
        for (_iterator2.s(); !(_step2 = _iterator2.n()).done;) {
          var i = _step2.value;
          map[i.title] = _objectSpread2({}, i);
        }
      } catch (err) {
        _iterator2.e(err);
      } finally {
        _iterator2.f();
      }
      var _iterator3 = _createForOfIteratorHelper(items),
        _step3;
      try {
        for (_iterator3.s(); !(_step3 = _iterator3.n()).done;) {
          var _i = _step3.value;
          var newItem = map[_i.title];
          if (_i._pid === -1) {
            res.push(newItem);
          } else {
            if (map[_i._pid]) map[_i._pid].children.push(newItem);
          }
        }
      } catch (err) {
        _iterator3.e(err);
      } finally {
        _iterator3.f();
      }
      return res;
    },
    // 生成表格的列
    genColumns: function genColumns() {
      var _this11 = this;
      // 设置表头分组
      // let groups = {
      //   耕地: [
      //     "耕地1",
      //     {
      //       耕地2: [
      //         "耕地2-1",
      //         {
      //           "耕地2-2": ["耕地2-2-1", "耕地2-2-3"],
      //         },
      //       ],
      //     },
      //     {
      //       耕地3: ["耕地3-1", { "耕地3-2": ["耕地3-2-1"] }],
      //     },
      //   ],
      // };
      if (!Array.isArray(this.fields) || this.fields.length == 0) return;
      var columns = [];
      // 生成字段列
      if (this.groups) this.isGroup = true;
      var groupsMap = this.mapTableGroups(this.groups);
      var newFields = this.filterRoleList(this.fields);
      newFields.forEach(function (field) {
        var slot = null;
        if (field.dict) {
          slot = "".concat(field.name).concat(_this11.dictSlotSuffix);
        }
        var isSlotKey = _.intersection(Object.keys(field), changeSlotKeys).length != 0;
        var isSlotType = changeSlotTypes.includes(field["type"]);
        if (isSlotKey || isSlotType) {
          slot = "".concat(field.name).concat(_this11.keySuffix);
        }
        if (field.slot === true) {
          slot = "".concat(field.name).concat(_this11.slotSuffix);
        }
        var column = _this11.genColumn(field, slot);
        var groupNames = groupsMap[field["name"]];
        if (groupNames) {
          groupNames = groupNames.split(",");
          _this11.columnAddGroup(columns, groupNames);
          column["_pid"] = groupNames.at(-1);
        } else {
          column["_pid"] = -1;
        }
        columns.push(column);
      });
      columns = this.arrayToTree(columns);
      // 生成序号列
      var indexField = {
        label: INDEX_LABEL,
        name: INDEX_NAME,
        width: INDEX_WIDTH,
        align: "center"
      };
      columns.unshift(this.genColumn(indexField));
      // 生成操作列
      var recordLength = this.recordOperatorsList.length;
      if (recordLength > 0) {
        var recordListLabelLength = this.recordOperatorsList.map(function (item) {
          return item["label"];
        }).join("").length;
        var field = {
          label: OPERATION_LABEL,
          name: OPERATION_NAME,
          width: this.operatorWidth || recordListLabelLength * 30,
          fixed: "right",
          align: "center"
        };
        columns.push(this.genColumn(field, OPERATION_NAME));
      }
      return columns;
    },
    genColumn: function genColumn(field, slot) {
      var column = {
        title: field.label,
        dataIndex: field.name
      };
      Object.keys(field).forEach(function (columnItem) {
        if (columnArr.includes(columnItem)) {
          column[columnItem] = field[columnItem];
        }
      });
      if (slot) {
        column["scopedSlots"] = {
          customRender: slot
        };
      }
      return column;
    },
    getSelectedKeys: function getSelectedKeys() {
      return this.selectedRowKeys;
    },
    // 生成表格数据
    genDataSource: function genDataSource() {
      var _this12 = this;
      if (!this.data) return;
      this.selectedRowKeys = [];
      this.data.forEach(function (d, index) {
        d[INDEX_NAME] = _this12.pageSize * (_this12.pageCurrent - 1) + index + 1;
      });
      return this.data;
    },
    // 翻页重新请求数据
    pageChangeHandler: function pageChangeHandler(current, pageSize) {
      // this.refresh();
      // this.pageCurrent = current;
      // this.pageSize = pageSize;
      //
      this.$emit("update:pageCurrent", current);
      this.$emit("update:pageSize", pageSize);
      this.refresh();
    },
    // 每页显示数量变化重新请求数据
    showSizeChangeHandler: function showSizeChangeHandler(current, pageSize) {
      this.pageCurrent = current;
      this.pageSize = pageSize;
      this.refresh();
    },
    // 获取数据
    refresh: function refresh() {
      this.$emit(this.$events.table.REFRESH, {
        page: this.pageCurrent,
        pageSize: this.pageSize,
        sortField: this.sortField,
        sortType: this.sortOrder
      });
    },
    // 排序重新请求数据
    rowChangeHandler: function rowChangeHandler(pagination, filters, sorter) {
      var field = sorter.field,
        order = sorter.order;
      order = order ? order.substring(0, order.length - 3) : undefined;
      this.sortField = !order || field;
      this.sortOrder = order;
      this.refresh();
    },
    // table按钮点击派发事件
    tableOperatorClickHandler: function tableOperatorClickHandler(key) {
      var selectedKeys = this.selectedRowKeys;
      this.$emit(this.$events.table.TABLE_OPERATOR_CLICK, {
        key: key,
        selectedKeys: selectedKeys
      });
    },
    // table item按钮点击派发事件
    recordOperatorClickHandler: function recordOperatorClickHandler(key, record) {
      this.$emit(this.$events.table.RECORD_OPERATOR_CLICK, {
        key: key,
        record: record
      });
    },
    rowSelectChangeHandler: function rowSelectChangeHandler(selectedRowKeys) {
      this.selectedRowKeys = selectedRowKeys;
    },
    selectRowsClearHandler: function selectRowsClearHandler() {
      this.selectedRowKeys = [];
    },
    rowSelectHandler: function rowSelectHandler(record, selected) {
      this.$emit(this.$events.table.RECORD_SELECT, {
        selected: selected,
        records: [record]
      });
    },
    rowSelectAllHandler: function rowSelectAllHandler(selected, selectedRows, changeRows) {
      this.$emit(this.$events.table.RECORD_SELECT, {
        selected: selected,
        records: selected ? selectedRows : changeRows
      });
    }
  }
};

/* script */
var __vue_script__$1 = script$1;

/* template */
var __vue_render__$1 = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _c("div", {
    staticClass: "gt-table"
  }, [_c("div", {
    staticClass: "header-wrapper"
  }, [_c("div", {
    staticClass: "btn-wrapper"
  }, _vm._l(_vm.tableOperatorsList, function (operator, index) {
    return _c("a-button", {
      key: index,
      attrs: {
        type: operator.type || "primary",
        icon: operator.icon
      },
      on: {
        click: function click($event) {
          return _vm.tableOperatorClickHandler(operator.key);
        }
      }
    }, [_vm._v("\n        " + _vm._s(operator.label) + "\n      ")]);
  }), 1), _vm._v(" "), _vm.allowSelect ? _c("a-alert", {
    attrs: {
      type: "warning"
    }
  }, [_c("template", {
    slot: "message"
  }, [_c("span", [_vm._v("已选择 "), _c("span", {
    staticClass: "select-count"
  }, [_vm._v(_vm._s(_vm.selectCount))]), _vm._v(" 项")]), _vm._v(" "), _c("a-button", {
    attrs: {
      type: "link"
    },
    on: {
      click: _vm.selectRowsClearHandler
    }
  }, [_vm._v("清空")])], 1)], 2) : _vm._e()], 1), _vm._v(" "), _c("a-table", {
    ref: "table",
    attrs: {
      size: "middle",
      loading: _vm.loading,
      bordered: _vm.borderedCom,
      columns: _vm.columns,
      "data-source": _vm.dataSource,
      pagination: false,
      rowKey: _vm.keyField,
      scroll: _vm.scroll,
      rowSelection: _vm.allowSelect ? {
        selectedRowKeys: _vm.selectedRowKeys,
        onChange: _vm.rowSelectChangeHandler,
        onSelect: _vm.rowSelectHandler,
        onSelectAll: _vm.rowSelectAllHandler
      } : undefined
    },
    on: {
      change: _vm.rowChangeHandler
    },
    scopedSlots: _vm._u([_vm._l(_vm.slotFields, function (field) {
      return {
        key: field.name + _vm.slotSuffix,
        fn: function fn(text, record) {
          return [_vm._t(field.name, function () {
            return [_c("span", {
              key: field.name
            }, [_vm._v(_vm._s(text))])];
          }, {
            text: text,
            record: record
          })];
        }
      };
    }), _vm._l(_vm.getSlotKeys, function (field) {
      return {
        key: field.name + _vm.keySuffix,
        fn: function fn(text, record) {
          return [_vm._v("\n      " + _vm._s(_vm.slotFormat(record[field.name], field)) + "\n    ")];
        }
      };
    }), _vm._l(_vm.dictFields, function (field) {
      return {
        key: field.name + _vm.dictSlotSuffix,
        fn: function fn(text) {
          return [_vm.getTagColor(field, text) ? _c("a-tag", {
            key: field.name,
            attrs: {
              color: _vm.getTagColor(field, text)
            }
          }, [_vm._v("\n        " + _vm._s(text) + "\n      ")]) : _c("span", {
            key: field.name,
            style: {
              color: _vm.getLabelColor(field, text)
            }
          }, [_vm.getIcon(field, text) ? _c("span", {
            "class": ["gt-icon", "gt-icon-" + _vm.getIcon(field, text)],
            style: {
              color: _vm.getIconColor(field, text),
              fontSize: _vm.getFontSize(field, text)
            }
          }) : _vm._e(), _vm._v("\n        " + _vm._s(_vm.getLabel(field, text)) + "\n      ")])];
        }
      };
    }), {
      key: _vm.operationSlot,
      fn: function fn(text, record) {
        return [_vm._t("operation", function () {
          return [_vm._l(_vm.recordOperatorsList, function (operator) {
            return [_vm.getComponentVisible(operator.expression, record) ? _c("span", {
              key: operator.label,
              staticClass: "operation-box"
            }, [_c("a-divider", {
              attrs: {
                type: "vertical"
              }
            }), _vm._v(" "), operator.confirm && !_vm.getComponentDisabled(operator.disabled, record) ? _c("a-popconfirm", {
              attrs: {
                placement: "topRight",
                title: "确定要" + operator.label + "吗？"
              },
              on: {
                confirm: function confirm() {
                  return _vm.recordOperatorClickHandler(operator.key, record);
                }
              }
            }, [_c("a-button", {
              style: {
                color: operator.color || ""
              },
              attrs: {
                type: "link",
                disabled: _vm.getComponentDisabled(operator.disabled, record),
                icon: operator.icon
              }
            }, [_vm._v("\n                " + _vm._s(operator.label) + "\n              ")])], 1) : _c("a-button", {
              style: {
                color: operator.color || ""
              },
              attrs: {
                type: "link",
                disabled: _vm.getComponentDisabled(operator.disabled, record),
                icon: operator.icon
              },
              on: {
                click: function click($event) {
                  return _vm.recordOperatorClickHandler(operator.key, record);
                }
              }
            }, [_vm._v("\n              " + _vm._s(operator.label))])], 1) : _vm._e()];
          })];
        })];
      }
    }], null, true)
  }), _vm._v(" "), _c("a-pagination", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: _vm.total != 0,
      expression: "total != 0"
    }],
    attrs: {
      total: _vm.total,
      "show-total": function showTotal(total, range) {
        return "共 " + total + " 条记录";
      },
      pageSize: _vm.pageSize,
      pageSizeOptions: _vm.pageSizeOptions,
      showSizeChanger: true
    },
    on: {
      change: _vm.pageChangeHandler,
      showSizeChange: _vm.pageChangeHandler
    },
    scopedSlots: _vm._u([{
      key: "buildOptionText",
      fn: function fn(props) {
        return [_c("span", [_vm._v(_vm._s(props.value) + "条/页")])];
      }
    }]),
    model: {
      value: _vm.pageCurrent,
      callback: function callback($$v) {
        _vm.pageCurrent = $$v;
      },
      expression: "pageCurrent"
    }
  })], 1);
};
var __vue_staticRenderFns__$1 = [];
__vue_render__$1._withStripped = true;

/* style */
var __vue_inject_styles__$1 = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-080d223d_0", {
    source: ".gt-table[data-v-080d223d] {\n  width: 100%;\n}\n.header-wrapper[data-v-080d223d] {\n  display: flex;\n  justify-content: space-between;\n  width: 100%;\n}\n.header-wrapper .btn-wrapper[data-v-080d223d] {\n  padding: 0 0 10px;\n  flex: 1;\n}\n.header-wrapper .btn-wrapper .ant-btn[data-v-080d223d] {\n  margin-right: 10px;\n}\n.header-wrapper .ant-alert[data-v-080d223d] {\n  padding: 0;\n  margin-bottom: 10px;\n  height: 32px;\n  line-height: 32px;\n  padding-left: 15px;\n  flex-shrink: 0;\n}\n.ant-pagination[data-v-080d223d] {\n  padding-top: 20px;\n  text-align: right;\n}\n[data-v-080d223d] .ant-table-body {\n  overflow-x: auto !important;\n}\n.select-count[data-v-080d223d] {\n  color: #1890ff;\n  font-weight: 600;\n  font-size: 16px;\n  margin: 0 5px;\n}\n[data-v-080d223d] .ant-pagination .ant-pagination-total-text {\n  float: left;\n}\n.operation-box[data-v-080d223d] .ant-btn-link {\n  padding: 0;\n}\n.operation-box[data-v-080d223d] .ant-btn-link span {\n  margin-left: 5px;\n}\n.operation-box[data-v-080d223d] .ant-btn-link[disabled] {\n  color: rgba(0, 0, 0, 0.25) !important;\n}\n.operation-box:nth-child(1) .ant-divider[data-v-080d223d] {\n  display: none;\n}\n[data-v-080d223d] .ant-tag {\n  padding: 3px 0;\n  line-height: normal !important;\n  display: block;\n  width: 80%;\n  text-align: center;\n  margin: 0 auto;\n}\n[data-v-080d223d] .ant-table-body {\n  overflow: auto !important;\n}\n[data-v-080d223d] .ant-table-body-inner {\n  overflow: auto !important;\n}\n[data-v-080d223d] .gt-icon {\n  font-size: 12px;\n  margin-right: 5px;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,WAAW;AACb;AACA;EACE,aAAa;EACb,8BAA8B;EAC9B,WAAW;AACb;AACA;EACE,iBAAiB;EACjB,OAAO;AACT;AACA;EACE,kBAAkB;AACpB;AACA;EACE,UAAU;EACV,mBAAmB;EACnB,YAAY;EACZ,iBAAiB;EACjB,kBAAkB;EAClB,cAAc;AAChB;AACA;EACE,iBAAiB;EACjB,iBAAiB;AACnB;AACC;EACC,2BAA2B;AAC7B;AACA;EACE,cAAc;EACd,gBAAgB;EAChB,eAAe;EACf,aAAa;AACf;AACC;EACC,WAAW;AACb;AACA;EACE,UAAU;AACZ;AACA;EACE,gBAAgB;AAClB;AACA;EACE,qCAAqC;AACvC;AACA;EACE,aAAa;AACf;AACC;EACC,cAAc;EACd,8BAA8B;EAC9B,cAAc;EACd,UAAU;EACV,kBAAkB;EAClB,cAAc;AAChB;AACC;EACC,yBAAyB;AAC3B;AACC;EACC,yBAAyB;AAC3B;AACC;EACC,eAAe;EACf,iBAAiB;AACnB",
      "file": "index.vue",
      "sourcesContent": [".gt-table {\n  width: 100%;\n}\n.header-wrapper {\n  display: flex;\n  justify-content: space-between;\n  width: 100%;\n}\n.header-wrapper .btn-wrapper {\n  padding: 0 0 10px;\n  flex: 1;\n}\n.header-wrapper .btn-wrapper .ant-btn {\n  margin-right: 10px;\n}\n.header-wrapper .ant-alert {\n  padding: 0;\n  margin-bottom: 10px;\n  height: 32px;\n  line-height: 32px;\n  padding-left: 15px;\n  flex-shrink: 0;\n}\n.ant-pagination {\n  padding-top: 20px;\n  text-align: right;\n}\n /deep/ .ant-table-body {\n  overflow-x: auto !important;\n}\n.select-count {\n  color: #1890ff;\n  font-weight: 600;\n  font-size: 16px;\n  margin: 0 5px;\n}\n /deep/ .ant-pagination .ant-pagination-total-text {\n  float: left;\n}\n.operation-box /deep/ .ant-btn-link {\n  padding: 0;\n}\n.operation-box /deep/ .ant-btn-link span {\n  margin-left: 5px;\n}\n.operation-box /deep/ .ant-btn-link[disabled] {\n  color: rgba(0, 0, 0, 0.25) !important;\n}\n.operation-box:nth-child(1) .ant-divider {\n  display: none;\n}\n /deep/ .ant-tag {\n  padding: 3px 0;\n  line-height: normal !important;\n  display: block;\n  width: 80%;\n  text-align: center;\n  margin: 0 auto;\n}\n /deep/ .ant-table-body {\n  overflow: auto !important;\n}\n /deep/ .ant-table-body-inner {\n  overflow: auto !important;\n}\n /deep/ .gt-icon {\n  font-size: 12px;\n  margin-right: 5px;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__$1 = "data-v-080d223d";
/* module identifier */
var __vue_module_identifier__$1 = undefined;
/* functional template */
var __vue_is_functional_template__$1 = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__$1 = /*#__PURE__*/normalizeComponent({
  render: __vue_render__$1,
  staticRenderFns: __vue_staticRenderFns__$1
}, __vue_inject_styles__$1, __vue_script__$1, __vue_scope_id__$1, __vue_is_functional_template__$1, __vue_module_identifier__$1, false, createInjector, undefined, undefined);

var SEARCH_STATUS = {
  BOX_SHOW: "展开",
  BOX_BACKUP: "收起"
};
var operator_default = "=";
// 判断是否为时间间隔插件
var DateRangeFieldType = "DateRangeField";
var script = {
  data: function data() {
    return {
      isShow: false,
      formData: {},
      searchFields: [],
      bus: new Vue(),
      searchMap: {},
      DateRangeMap: {},
      dateRangeFields: {},
      createId: _.uniqueId("search_")
    };
  },
  props: {
    defaultFields: {
      type: Object,
      "default": function _default() {
        return {};
      }
    },
    fields: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    dicts: {
      type: Array,
      "default": function _default() {
        return [];
      }
    },
    showNum: {
      type: Number,
      "default": 2
    },
    listWidth: {
      type: Number,
      "default": 300
    },
    wrapperSpan: {
      type: Number,
      "default": 16
    },
    labelSpan: {
      type: Number,
      "default": 8
    }
  },
  watch: {
    fields: {
      handler: function handler() {
        this.setSearchFields();
      },
      deep: true
    },
    isShow: function isShow() {
      var _this = this;
      this.$nextTick(function () {
        var _document$getElementB;
        var domHeight = (_document$getElementB = document.getElementById(_this.createId)) === null || _document$getElementB === void 0 ? void 0 : _document$getElementB.offsetHeight;
        if (domHeight) {
          _this.$emit("add-height", domHeight - 50);
        }
      });
    }
  },
  provide: function provide() {
    return {
      bus: this.bus
    };
  },
  computed: {
    labelCol: function labelCol() {
      return {
        span: this.labelSpan
      };
    },
    wrapperCol: function wrapperCol() {
      return {
        span: this.wrapperSpan
      };
    },
    labelStatus: function labelStatus() {
      return this.isShow ? SEARCH_STATUS.BOX_BACKUP : SEARCH_STATUS.BOX_SHOW;
    },
    bodyStyle: function bodyStyle() {
      return {
        "grid-template-columns": "repeat(auto-fill, ".concat(this.listWidth, "px)")
      };
    },
    showSearchFields: function showSearchFields() {
      var fields = this.filterRoleList(this.fields);
      var showSearchFields = [];
      fields.forEach(function (item) {
        var _item$renderer$option = item.renderer.options,
          hide = _item$renderer$option.hide,
          field = _item$renderer$option.field;
        if (!hide) showSearchFields.push(field);
      });
      return showSearchFields;
    },
    allHide: function allHide() {
      return this.searchFields.every(function (item) {
        return item["options"]["hide"] == true;
      });
    }
  },
  mounted: function mounted() {
    this.formData = _.cloneDeep(this.defaultFields);
    this.setSearchFields();
    this.bus.$on(this.$events.form.FIELD_CHANGE, this.fieldChangeHandler);
  },
  methods: {
    setSearchFields: function setSearchFields() {
      var _this2 = this;
      if (Array.isArray(this.fields) && this.fields.length != 0) {
        var fields = this.filterRoleList(this.fields);
        this.searchFields = fields.map(function (item) {
          var renderer = item.renderer,
            operator = item.operator;
          var options = renderer.options,
            type = renderer.type;
          // DateRangeField
          if (type == DateRangeFieldType) {
            var startField = options.startField,
              endField = options.endField,
              field = options.field;
            _this2.DateRangeMap[startField["field"]] = {
              name: field,
              operator: startField["operator"] || ">="
            };
            _this2.DateRangeMap[endField["field"]] = {
              name: field,
              operator: endField["operator"] || "<="
            };
            _this2.dateRangeFields[field] = {
              startField: startField["field"],
              endField: endField["field"]
            };
          } else {
            _this2.searchMap[options["field"]] = operator || operator_default;
            if (options.dictRef && !options.dict) {
              var dict = _this2.dicts.find(function (d) {
                return d.name == options.dictRef;
              });
              options.dict = dict || {};
            }
          }
          // 去除不同权限不显示的组件
          var showIndex = _this2.showSearchFields.indexOf(options["field"]);
          if (showIndex >= 0) {
            renderer.show = showIndex < _this2.showNum;
          } else {
            renderer.show = false;
          }
          options.formData = _this2.formData;
          // 判断是否有初始值
          var defaultValue = _this2.defaultFields[options["field"]];
          if (defaultValue) options["default"] = defaultValue;
          return renderer;
        });
        this.isShow = false;
      }
    },
    // 通过不同权限配置操作框和显示属性
    filterRoleList: function filterRoleList(list) {
      list = _.cloneDeep(list);
      var userInfo = JSON.parse(localStorage.getItem("userInfo"));
      var roleCodes = userInfo["roles"].map(function (_ref) {
        var code = _ref.code;
        return code;
      });
      if (Array.isArray(list)) {
        return list.map(function (item) {
          if (item["showRoles"]) {
            var isShow = false;
            var _iterator = _createForOfIteratorHelper(item["showRoles"]),
              _step;
            try {
              for (_iterator.s(); !(_step = _iterator.n()).done;) {
                var value = _step.value;
                if (roleCodes.includes(value)) {
                  isShow = true;
                  break;
                }
              }
            } catch (err) {
              _iterator.e(err);
            } finally {
              _iterator.f();
            }
            item["renderer"]["options"]["hide"] = !isShow;
          }
          return item;
        });
      } else {
        return [];
      }
    },
    submitHandler: function submitHandler(e) {
      e && e.preventDefault();
      this.$emit(this.$events.form.SEARCH, this.getSearchItems(this.formData));
    },
    getSearchItems: function getSearchItems(values) {
      var _this3 = this;
      var searchValues = [];
      Object.keys(values).forEach(function (key) {
        if (![null, undefined, ""].includes(values[key])) {
          if (Array.isArray(values[key]) && values[key].length == 0) {
            return;
          }
          // 判断是否为时间间隔控件
          if (_this3.DateRangeMap[key]) {
            var _this3$DateRangeMap$k = _this3.DateRangeMap[key],
              name = _this3$DateRangeMap$k.name,
              operator = _this3$DateRangeMap$k.operator;
            searchValues.push({
              name: name,
              operator: operator,
              value: values[key]
            });
          } else {
            searchValues.push({
              name: key,
              operator: _this3.searchMap[key],
              value: values[key]
            });
          }
        }
      });
      return searchValues;
    },
    fieldChangeHandler: function fieldChangeHandler(_ref2) {
      var field = _ref2.field,
        value = _ref2.value;
      this.formData[field] = value;
      this.$emit(this.$events.form.FIELD_CHANGE, {
        field: field,
        value: value
      });
    },
    reset: function reset() {
      var _this4 = this;
      var newFormData = {};
      this.searchFields.forEach(function (_ref3) {
        var options = _ref3.options;
        var defaultVal = options === null || options === void 0 ? void 0 : options["default"];
        var field = options === null || options === void 0 ? void 0 : options.field;
        if (["", undefined, null].includes(defaultVal)) {
          _this4.$refs[field][0].reset();
        } else {
          if (_this4.formData[field] !== defaultVal) {
            _this4.$refs[field][0].setValue(defaultVal);
          }
          newFormData[field] = defaultVal;
        }
        // dateRangeFields
        // 重置兼容时间间隔控件
        if (_this4.dateRangeFields[field]) {
          var _this4$dateRangeField = _this4.dateRangeFields[field],
            startField = _this4$dateRangeField.startField,
            endField = _this4$dateRangeField.endField;
          var startFieldVal = _this4.defaultFields[startField];
          var endFieldVal = _this4.defaultFields[endField];
          _this4.$refs[field][0].setValue(startFieldVal, endFieldVal);
          newFormData[startField] = startFieldVal;
          newFormData[endField] = endFieldVal;
        }
      });
      this.formData = newFormData;
      this.$emit(this.$events.form.SEARCH, this.getSearchItems(this.formData));
    },
    showHandler: function showHandler() {
      var _this5 = this;
      this.isShow = !this.isShow;
      this.searchFields.forEach(function (item) {
        if (_this5.isShow) {
          item.show = true;
        } else {
          var showIndex = _this5.showSearchFields.indexOf(item["options"]["field"]);
          if (showIndex >= 0) {
            item.show = showIndex < _this5.showNum;
          } else {
            item.show = false;
          }
        }
      });
    }
  }
};

/* script */
var __vue_script__ = script;

/* template */
var __vue_render__ = function __vue_render__() {
  var _vm = this;
  var _h = _vm.$createElement;
  var _c = _vm._self._c || _h;
  return _vm.fields.length > 0 ? _c("div", {
    staticClass: "search-box",
    attrs: {
      id: _vm.createId
    }
  }, [_c("a-form-model", {
    ref: "form",
    attrs: {
      "label-col": _vm.labelCol,
      "wrapper-col": _vm.wrapperCol
    },
    on: {
      submit: _vm.submitHandler
    }
  }, [_c("div", {
    staticClass: "body-wrapper",
    style: _vm.bodyStyle
  }, [_vm._l(_vm.searchFields, function (ref) {
    var type = ref.type;
    var options = ref.options;
    var show = ref.show;
    return _c(type, {
      directives: [{
        name: "show",
        rawName: "v-show",
        value: show && !options["hide"],
        expression: "show && !options['hide']"
      }],
      key: options.field,
      ref: options.field,
      refInFor: true,
      tag: "component",
      attrs: {
        options: options
      }
    });
  }), _vm._v(" "), _c("div", {
    directives: [{
      name: "show",
      rawName: "v-show",
      value: !_vm.allHide,
      expression: "!allHide"
    }],
    staticClass: "search-btn-box"
  }, [_c("a-button", {
    attrs: {
      type: "primary",
      icon: "search",
      "html-type": "submit"
    }
  }, [_vm._v("\n          查找\n        ")]), _vm._v(" "), _c("a-button", {
    staticClass: "redo-btn",
    attrs: {
      type: "primary",
      icon: "redo"
    },
    on: {
      click: _vm.reset
    }
  }, [_vm._v("\n          重置\n        ")]), _vm._v(" "), _vm.showSearchFields.length > _vm.showNum ? _c("a", {
    staticClass: "button-control",
    on: {
      click: _vm.showHandler
    }
  }, [_c("span", [_vm._v(_vm._s(_vm.labelStatus))]), _vm._v(" "), _c("a-icon", {
    attrs: {
      type: _vm.isShow ? "up" : "down"
    }
  })], 1) : _vm._e()], 1)], 2)])], 1) : _vm._e();
};
var __vue_staticRenderFns__ = [];
__vue_render__._withStripped = true;

/* style */
var __vue_inject_styles__ = function __vue_inject_styles__(inject) {
  if (!inject) return;
  inject("data-v-6659b19f_0", {
    source: ".search-box[data-v-6659b19f] {\n  margin-left: 20px;\n}\n.search-box[data-v-6659b19f] .ant-form-item {\n  margin-bottom: 10px;\n}\n[data-v-6659b19f] .ant-input-affix-wrapper {\n  margin-top: 4px;\n}\n[data-v-6659b19f] .ant-select {\n  margin-top: 4px;\n}\n.search-btn-box[data-v-6659b19f] {\n  padding-bottom: 10px;\n  display: flex;\n  align-items: center;\n}\n.search-btn-box > *[data-v-6659b19f] {\n  margin-left: 10px;\n}\n.body-wrapper[data-v-6659b19f] {\n  display: grid;\n  grid-template-columns: repeat(auto-fill, 300px);\n  grid-gap: 0 8px;\n  padding: 0px;\n}\n",
    map: {
      "version": 3,
      "sources": ["index.vue"],
      "names": [],
      "mappings": "AAAA;EACE,iBAAiB;AACnB;AACA;EACE,mBAAmB;AACrB;AACC;EACC,eAAe;AACjB;AACC;EACC,eAAe;AACjB;AACA;EACE,oBAAoB;EACpB,aAAa;EACb,mBAAmB;AACrB;AACA;EACE,iBAAiB;AACnB;AACA;EACE,aAAa;EACb,+CAA+C;EAC/C,eAAe;EACf,YAAY;AACd",
      "file": "index.vue",
      "sourcesContent": [".search-box {\n  margin-left: 20px;\n}\n.search-box /deep/ .ant-form-item {\n  margin-bottom: 10px;\n}\n /deep/ .ant-input-affix-wrapper {\n  margin-top: 4px;\n}\n /deep/ .ant-select {\n  margin-top: 4px;\n}\n.search-btn-box {\n  padding-bottom: 10px;\n  display: flex;\n  align-items: center;\n}\n.search-btn-box > * {\n  margin-left: 10px;\n}\n.body-wrapper {\n  display: grid;\n  grid-template-columns: repeat(auto-fill, 300px);\n  grid-gap: 0 8px;\n  padding: 0px;\n}\n"]
    },
    media: undefined
  });
};
/* scoped */
var __vue_scope_id__ = "data-v-6659b19f";
/* module identifier */
var __vue_module_identifier__ = undefined;
/* functional template */
var __vue_is_functional_template__ = false;
/* style inject SSR */

/* style inject shadow dom */

var __vue_component__ = /*#__PURE__*/normalizeComponent({
  render: __vue_render__,
  staticRenderFns: __vue_staticRenderFns__
}, __vue_inject_styles__, __vue_script__, __vue_scope_id__, __vue_is_functional_template__, __vue_module_identifier__, false, createInjector, undefined, undefined);

var registerComponents = {
  GTForm: __vue_component__$3,
  GTField: __vue_component__$2,
  GTTable: __vue_component__$1,
  GTSearch: __vue_component__
};
// 导入fields组件
var fieldComponents = 
  (function() {
    var map = {
      './AdminField/index.vue': __vue_component__$q,
'./CascaderField/index.vue': __vue_component__$p,
'./CheckboxField/index.vue': __vue_component__$o,
'./DateField/index.vue': __vue_component__$n,
'./DateRangeField/index.vue': __vue_component__$m,
'./FileField/index.vue': __vue_component__$l,
'./IntegerField/index.vue': __vue_component__$k,
'./JsonField/AceEditor/index.vue': __vue_component__$j,
'./JsonField/index.vue': __vue_component__$i,
'./LonLatField/Amap/index.vue': __vue_component__$h,
'./LonLatField/index.vue': __vue_component__$g,
'./LonLatInputField/InputNumber.vue': __vue_component__$f,
'./LonLatInputField/index.vue': __vue_component__$e,
'./NumberField/index.vue': __vue_component__$d,
'./NumberWithUnitField/index.vue': __vue_component__$c,
'./PasswordField/index.vue': __vue_component__$b,
'./PictureField/index.vue': __vue_component__$a,
'./RadioField/index.vue': __vue_component__$9,
'./SelectField/index.vue': __vue_component__$8,
'./SubForm/components/SubFormTable/index.vue': __vue_component__$7,
'./SubForm/index.vue': __vue_component__$6,
'./TextAreaField/index.vue': __vue_component__$5,
'./TextField/index.vue': __vue_component__$4,

    };
    var req = function req(key) {
      return map[key] || (function() { throw new Error("Cannot find module '" + key + "'.") }());
    };
    req.keys = function() {
      return Object.keys(map);
    };
    return req;
  })()
;
fieldComponents.keys().forEach(function (fileName) {
  var comp = fieldComponents(fileName);
  var a = fileName.split("/");
  registerComponents[a.at(-2)] = comp;
});

// 导入layout组件
var layoutComponents = 
  (function() {
    var map = {
      './Card/index.vue': __vue_component__$v,
'./Grid/index.vue': __vue_component__$u,
'./Group/index.vue': __vue_component__$t,
'./SplitLine/index.vue': __vue_component__$s,
'./Title/index.vue': __vue_component__$r,

    };
    var req = function req(key) {
      return map[key] || (function() { throw new Error("Cannot find module '" + key + "'.") }());
    };
    req.keys = function() {
      return Object.keys(map);
    };
    return req;
  })()
;
layoutComponents.keys().forEach(function (fileName) {
  var comp = layoutComponents(fileName);
  var a = fileName.split("/");
  registerComponents[a.at(-2)] = comp;
});

// will install the plugin only once
var install = function install(Vue) {
  console.log("components :>> ", registerComponents);
  Object.keys(registerComponents).forEach(function (name) {
    Vue.component(name, registerComponents[name]);
  });
};
if (typeof window !== "undefined" && window.Vue) {
  install(window.Vue);
}
// export default { install, IconFont, TextHiddenTooltip, IconButton };
var index = {
  install: install
};
var BaseField = importBaseField;

export { BaseField, index as default };
